#ifndef _HVCRATES_H_
#define _HVCRATES_H_

/* 
   $Header: /home/elrond/baikal/src/CVS/daq98/HVcrates.h,v 1.3 1998/11/23 14:40:01 haase Exp $ 
*/

/* class for storing the list of channels in the hv crates		*/
#include <config.h>
#include "simplevector.h"


class HVCrates
{
	public:
		/** constructor */
		HVCrates ();
		/** destructor */
		~HVCrates ();

		/** Reads an Ole style configuration file.
			Reads a file of the format
			0-N1 device interface options, but only goes for the 
			channels.
			@return -1 on failure, 0 on success
			@param ConfigFileName: name of the configfile.
		*/
		int ReadConfig (const char *ConfigFileName);

		/** Set all channels to zero. */
		int Zero ();

		/** Gets the number of channels */
		int GetNChannels ();
		/** Gets the number of the first channel (0 for normal) */
		int GetFirstChannel ();
		/** Gets the number of the last channel */
		int GetLastChannel ();

		/** Checks if Channel is defined in config file. */
		bool ChannelValid (int Channel);

		/** Checks if a range of channels is defined. 
			Checks if the range of channels given by from
			and to is defined in the crates config file.
			@return: true if defined, false otherwise.
			@param: int from: the lowest channel in the range
			@param: int to: the highest channel in the range
		*/
		bool ChannelValid (int from, int to);

	private:
		typedef struct FromTo 
		{
//			FromTo (int from, int to)
//			{
//				From = from;
//				To = to;
//			}
			int From;
			int To;
		} FromTo_t;

		MAKE_INC_VECTOR (FromTo_t, FromToList_t);
		FromToList_t FromToList;

		int parse (const char *buffer);
		bool already_defined (int low, int high);

		int NChannels;
		int FirstChannel;
		int LastChannel;
};

#endif /* _HVCRATES_H_ */
