
#if ! defined __ADCMODULE_H__
#define __ADCMODULE_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/adcmodule.h,v 1.5 1999/02/05 18:34:59 steffen Exp $

  $Log: adcmodule.h,v $
  Revision 1.5  1999/02/05 18:34:59  steffen
  * Major cleanup:
    - threw out code for binary config records
    - cleaned up some module classes
  * Fixed bug which prevent 32 bit values to be read correctly from
    detector cnf
  * Added masking to s7201 module

*/

#include <config.h>
#include "channelmodule.h"

/*---------------------------------------------------------*/
/*                                                         */
/*  ADC module configuration data structure                */
/*                                                         */
/*---------------------------------------------------------*/

/** Configuration data structure for ADC modules */
struct ADCModuleConfigRecord_t:public ChannelModuleConfigRecord_t
{
     ClassTypeInfo(ChannelModuleConfigRecord_t);
     
     /** Constructor */
     ADCModuleConfigRecord_t();
     
     /** Destructor */
     virtual ~ADCModuleConfigRecord_t();
          
     /** Pedestal */
     u_i16 Ped;

     /** Upper Threshold */
     u_i16 ThreshUp;

     /** Lower Threshold */
     u_i16 ThreshLow;
};

MAKE_REFCOUNT_POINTER(ADCModuleConfigRecord_t,ADCModuleConfigRecord_p);

/*---------------------------------------------------------*/
/*                                                         */
/*  ADC module base class                                  */
/*                                                         */
/*---------------------------------------------------------*/

/** Base class for ADC module classes */
class ADCModuleClass_t: public ChannelModuleBaseClass_t
{
     ClassTypeInfo(ChannelModuleBaseClass_t);
public:
     /** Constructor.
	 @param numChannels Number of channels of this module
	 @param BytesPerInfoUnit Number of bytes per info unit (bytes per channel)
	 @param parent Pointer to parent class. Used for sending messages in Parent context. */
     ADCModuleClass_t(int numChannels,int BytesPerInfoUnit, DaqProcessBase *parent);
};

MAKE_REFCOUNT_POINTER(ADCModuleClass_t, ADCModuleClass_p);

#endif // __ADCMODULE_H__
