#if ! defined __ADCMODULEEVAL_H__
#define __ADCMODULEEVAL_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/adcmoduleeval.h,v 1.7 1999/02/08 08:08:53 steffen Exp $
*/

#include <config.h>
#include "moduleevalbase.h"

class ADCModuleEvalClass_t: public ModuleEvalBaseClass_t
{
     ClassTypeInfo(ModuleEvalBaseClass_t);
public:
     inline ADCModuleEvalClass_t(int numChannels,int bytesPerInfoUnit,DaqProcessBase* Parent)
	  :ModuleEvalBaseClass_t(numChannels,bytesPerInfoUnit,Parent){}

     virtual void Configure(ChannelModuleConfigRecord_p &ModuleConfig,
			    HWConfig_t &HWConfig){
	  SetTag(ModuleConfig->BinaryTag);
	  ChannelConfigRecordVector_t::iterator chcr_i;
	  for(chcr_i=HWConfig.ChannelConfigRecordVector->begin();
	      chcr_i<HWConfig.ChannelConfigRecordVector->end();
	      chcr_i++){
	       if((*chcr_i)->ADC_Id && (strcasecmp(ModuleConfig->ModuleID,(*chcr_i)->ADC_Id)==0)){
		    // we found a channel, that is connected to the current module
		    // insert it in our vector
		    SetChannelMapping((*chcr_i)->ADC_Channel,(*chcr_i)->ID);
	       }
	  }
     }

     virtual int BuildEventPart(BinaryDataBuffer &RawDataBuffer,
				TempDecode_EventData_t *TempEventBuffer){
	  const void *ModuleData;
	  int NumReads;
	  u_i16 NumBytes;
	  int CurADCChannel;
	  s_i32 CurOMChannel;
	  SubEventData_StaticSize_t *CurSubEvent;

	  RawDataBuffer.ReadFromBuffer(NumBytes);
	  NumReads=NumBytes/BytesPerInfoUnit;

	  for(int i=0;i<NumReads;i++){
	       ModuleData=ReadFromBuffer(RawDataBuffer);
	       // get the  channel
	       CurADCChannel=Channel(ModuleData);
	       if((CurOMChannel=GetChannelMapping(CurADCChannel))<0){
		    // error handling, couldn't map channel
		    char txt[1000];
		    sprintf(txt,"Can't map ADC with tag %i channel %i to OM channel",GetTag(),CurADCChannel);
		    LogMsg(txt,2,2,WARNING);
		    continue;
	       }
	       CurSubEvent=TempEventBuffer->GetChannelForWriting(CurOMChannel);
// ***amp	       CurSubEvent->Amplitude=Amplitude(ModuleData);
	       CurSubEvent->Amplitude.ampval=Amplitude(ModuleData);
	       CurSubEvent->Amplitude.isamp=1;
	       CurSubEvent->ID=CurOMChannel;
	  }
	  return 0;
     }
protected:
     virtual inline int Channel(const void *adc_data)=0;
     virtual inline int Amplitude(const void *adc_data)=0;
};

#endif // __ADCMODULEEVAL_H__
