#if ! defined __C63IREGMODULEEVAL_H__
#define __C63IREGMODULEEVAL_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/c63iregmoduleeval.h,v 1.5 1999/02/05 18:35:00 steffen Exp $
*/

#include <config.h>
#include "iregmoduleeval.h"

#define DEBUG_LOCAL(A)  cout   A


class C63_IREGModuleEvalClass_t: public IREGModuleEvalClass_t
{
     enum 
     { 
	  NUMBER_OF_CHANNELS =1,
	  BYTES_PER_INFO_UNIT=4
     };
     ClassTypeInfo(IREGModuleEvalClass_t);
public:
     inline C63_IREGModuleEvalClass_t(DaqProcessBase *Parent)
	  :IREGModuleEvalClass_t(NUMBER_OF_CHANNELS,BYTES_PER_INFO_UNIT,Parent){
//	       ievent_i63read=0; 
     }
     
     virtual void Configure(ChannelModuleConfigRecord_p &ModuleConfig,
			    HWConfig_t &/*HWConfig*/){
	  SetTag(ModuleConfig->BinaryTag);
//	  IREGModuleConfigRecord_p IREGConfig=TYPESAFE_DOWNCAST_RCP(IREGModuleConfigRecord_t,ModuleConfig);
//	  if(!IREGConfig) return;
     }

     /** Reads the data and builds the event part that this module is good for */
     virtual int BuildEventPart(BinaryDataBuffer &RawDataBuffer,
				TempDecode_EventData_t *TempEventBuffer){
	  const void *trigger_data;
	  u_i16 NumBytes;

//	  ievent_i63read++;


	  RawDataBuffer.ReadFromBuffer(NumBytes);
	  trigger_data=ReadFromBuffer(RawDataBuffer);

// ********* check ******************
	  memcpy(&TempEventBuffer->Trigger, trigger_data,sizeof(Trigger_t));

//	  DEBUG_LOCAL (<<"C63IREG-eval: NumBytes,BytesPerInfoUnit "<<NumBytes<<" "<<BytesPerInfoUnit<<endl);
//	  DEBUG_LOCAL( <<"C63IREG-eval: iread, data = "<<ievent_i63read<<" "<<*(u_i32*) trigger_data <<end<<flushl);
	  return 0;
     }
protected:

     virtual const void* ReadFromBuffer(BinaryDataBuffer &DataBuffer){
	  static u_i32 Data;
	  DataBuffer.ReadFromBuffer(Data);
	  return (void*)&Data;
     }
     
private:

//     u_i32 ievent_i63read;     //  testing
};

#endif // __C63IREGMODULEEVAL_H__
