#if !defined __CAMACGPSMODULE_H_
#define __CAMACGPSMODULE_H_

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/camacgpsmodule.h,v 1.5 1999/02/05 18:35:00 steffen Exp $

  $Log: camacgpsmodule.h,v $
  Revision 1.5  1999/02/05 18:35:00  steffen
  * Major cleanup:
    - threw out code for binary config records
    - cleaned up some module classes
  * Fixed bug which prevent 32 bit values to be read correctly from
    detector cnf
  * Added masking to s7201 module

*/


#include <config.h>
#include "gpsmodule.h"

/*---------------------------------------------------------*/
/*                                                         */
/*  CAMAC GPS module configuration data structure          */
/*                                                         */
/*---------------------------------------------------------*/

/** Same as GPS base type */
typedef GPSModuleConfigRecord_t CAMAC_GPSModuleConfigRecord_t;
MAKE_REFCOUNT_POINTER(CAMAC_GPSModuleConfigRecord_t,CAMAC_GPSModuleConfigRecord_p);


/*---------------------------------------------------------*/
/*                                                         */
/*  CAMAC GPS module class                                 */
/*                                                         */
/*---------------------------------------------------------*/

/** Class for CAMAC GPS module.
    This is the old style module, developed by University of Wisconsin. */
class CAMAC_GPSModuleClass_t:public GPSModuleClass_t
{
     ClassTypeInfo(GPSModuleClass_t);
     enum 
     { 
	  NUMBER_OF_CHANNELS =1,
	  BYTES_PER_INFO_UNIT=9
     };
public:
     /** Constructor.
	 @param parent Pointer to parent class. Used for sending messages in Parent context. */
     CAMAC_GPSModuleClass_t(DaqProcessBase *parent);
     
     /** Destructor */
     ~CAMAC_GPSModuleClass_t();
     
     /** Check for data
      @return {\it true} if module has data, {\it false} otherwise */
     inline virtual bool HasModuleData();

     /** Read the module data and write to the data buffer
	 @param DataBuffer Reference to the data buffer
	 @return 0 on success, -1 on failure */
     virtual int ReadToBuffer(BinaryDataBuffer &DataBuffer);
     
     /** Initialize the module
      @param  errors Reference to a vector of error strings. 
      If an error occures, the function can add a descriptive messages.
      @return 0 on success, -1 on failure */
     virtual int InitModule(StringVector_t &errors);
     
     /** Reset the module
	 @param  errors Reference to a vector of error strings. 
	 If an error occures, the function can add a descriptive messages.
	 @return 0 on success, -1 on failure */
     inline virtual int ResetModule(StringVector_t &errors);


private:
     volatile long int *cnaf_f0a0, *cnaf_f0a1, *cnaf_f0a2, *cnaf_f2a2;

};

MAKE_REFCOUNT_POINTER(CAMAC_GPSModuleClass_t, CAMAC_GPSModuleClass_p);

/*---------------------------------------------------------*/
/*                                                         */
/*  CAMAC GPS module class                                 */
/*  Inline member function definitions                     */
/*                                                         */
/*---------------------------------------------------------*/

inline bool CAMAC_GPSModuleClass_t::HasModuleData(){
     return true;
}

inline int CAMAC_GPSModuleClass_t::ResetModule(StringVector_t &/*errors*/)
{
     return 0;
}
#endif // __MODULECLASSES_H__
