/*
  $Header: /home/elrond/baikal/src/CVS/daq98/camacgpsmodule97.h,v 1.5 1999/02/05 18:35:00 steffen Exp $
*/

#if !defined __CAMACGPSMODULE97_H_
#define __CAMACGPSMODULE97_H_

#include <config.h>
#include "gpsmodule.h"
#include "crateclasses.h"

class CAMAC_GPSModule97Class_t:public GPSModuleClass_t
{
     ClassTypeInfo(GPSModuleClass_t);
     enum 
     { 
	  NUMBER_OF_CHANNELS =1,
	  BYTES_PER_INFO_UNIT=9   // 3 *24bit raw
     };
public:
     CAMAC_GPSModule97Class_t(DaqProcessBase *parent);/***/
     
     ~CAMAC_GPSModule97Class_t();
     
     /** returns true, if the module has data or false if the module
	 does not have any data */
     
     // should not be used for GPS Modules 
     virtual bool HasModuleData();

     /** this function reads the entire module and saves the RAW data
         at the current position into the buffers, which is given as
         the paramter */
     virtual int ReadToBuffer(BinaryDataBuffer &DataBuffer);
     
     /** this function initializes the module 
	 CCrate Init is done here for Crate Nb. =1 (perlim.) */
     virtual int InitModule(StringVector_t &errors);
     
     /** Resets the module */
     virtual int ResetModule(StringVector_t &errors);
private:
     /** decoding the GPS data and some printout */
     int GPS_Decode (u_i32 data0,u_i32 data1,u_i32 data2);
private:
     long int *cnaf_f0a0, *cnaf_f0a1, *cnaf_f0a2, *cnaf_f2a2;

};

MAKE_REFCOUNT_POINTER(CAMAC_GPSModule97Class_t, CAMAC_GPSModule97Class_p);

#endif // __MODULECLASSES97_H__
