/*
$Header: /home/elrond/baikal/src/CVS/daq98/cnfreader.C,v 1.4 1999/01/29 08:50:00 steffen Exp $
*/

#include "mapinclude.h"
#include <String.h>
#include "item.h"
#include "pointerutil.h"
#include "fileinterpreter.h"
#include "configsection.h"
#include "cnfreader.h"

#define SECTION_NAME "SECTION"

ConfigReader::ConfigReader(){
     CnfInterpreter.AddFunction(SECTION_NAME,&CMD_Section);
     CnfInterpreter.UnknownFunction(&CMD_Unknown);
     CnfInterpreter.WrongTypeFunction(&CMD_WrongType);
     CnfInterpreter.CleanupFunction(&CMD_CleanUp);
     CurrentSection=0;
}

ConfigReader::~ConfigReader(){
}

void ConfigReader::AddSection(ClassWithTypeInfo_p cnfsect){
     ConfigSection_p CNFSect1;
     ConfigSection_old_p CNFSect2;
     if((CNFSect1=TYPESAFE_DOWNCAST_RCP(ConfigSection_t,cnfsect))!=(void*)0){
	  Sections[CNFSect1->GetSectionName()]=cnfsect;
	  for(int i=0;i<CNFSect1->GetNoProperties();i++)
	       CnfInterpreter.AddFunction(CNFSect1->GetPropertyName(i),&CMD_ItemProp);
     } else if ((CNFSect2=TYPESAFE_DOWNCAST_RCP(ConfigSection,cnfsect))!=(void*)0){
	  Sections[CNFSect2->GetSectionName()]=cnfsect;
	  for(int i=0;i<CNFSect2->GetNoProperties();i++)
	       CnfInterpreter.AddFunction(CNFSect2->GetPropertyName(i),&CMD_ItemProp);
     } 
}       

int ConfigReader::Read(istream &stream){
     if(!stream){
	  (*Error)=NO_CONFIG_FILE;
	  (*Error)="int ConfigReader::Read(..)";
	  return -1;
     }     
     return CnfInterpreter.Do(this,stream);
}

int ConfigReader::CMD_Section(String *params,int numparams){
     if(2==numparams){
	  // look for the section naem in the section map
	  CnfMapperIterator sect_it=Sections.find(params[1]);
	  // did we find it ?
	  if(sect_it!=Sections.end())
	       CurrentSection=(*sect_it).second; //yes
	  else
	       CurrentSection=0; // no
	  // we must not produce an error if we did not find it, 
	  // because there might be more sections in the file 
	  // than we want to read and therefore we must simply 
	  // ignore it
	  return 0;
     }
     char txt[100];
     sprintf(txt,"At Section %s",(const char*)join(params,numparams," "));
     (*Error)=ERROR_IN_CONFIG_FILE;
     (*Error)=txt;
     return 1;
}

int ConfigReader::CMD_ItemProp(String *Param,int numparams){
     if(!CurrentSection) return 0;
     ConfigSection_p CNFSect1;
     ConfigSection_old_p CNFSect2;
     if((CNFSect1=TYPESAFE_DOWNCAST_RCP(ConfigSection_t,CurrentSection))!=(void*)0){
	  if(CNFSect1->SetProperty(Param[0],join(Param+1,numparams-1," "))<0){
	       char txt[1000];
	       sprintf(txt,"At Item %s",(const char*)join(Param,numparams," "));
	       (*Error)=ERROR_IN_CONFIG_FILE;
	       (*Error)=txt;
	       return -1;
	  }
     } else if ((CNFSect2=TYPESAFE_DOWNCAST_RCP(ConfigSection,CurrentSection))!=(void*)0){
	  if(CNFSect2->SetProperty(Param[0],join(Param+1,numparams-1," "))<0){
	       char txt[1000];
	       sprintf(txt,"At Item %s",(const char*)join(Param,numparams," "));
	       (*Error)=ERROR_IN_CONFIG_FILE;
	       (*Error)=txt;
	       return -1;
	  }
     }
     return 0;
}

int ConfigReader::CMD_Unknown(String *Param,int numparams){
     if(!CurrentSection)return 0;
     char txt[1000];
     sprintf(txt,"Unknown Command found: %s",(const char*)join(Param,numparams," "));
     (*Error)=ERROR_IN_CONFIG_FILE;
     (*Error)=txt;
     return -1;
}

int ConfigReader::CMD_WrongType(String *Param,int numparams){
     if(!CurrentSection)return 0;
     char txt[1000];
     sprintf(txt,"Command has wrong type: %s",(const char*)join(Param,numparams," "));
     (*Error)=ERROR_IN_CONFIG_FILE;
     (*Error)=txt;
     return -1;
}

int ConfigReader::CMD_CleanUp(){
     return 0;
}

