/*
$Header: /home/elrond/baikal/src/CVS/daq98/conswidget.C,v 1.2 1998/11/23 14:41:06 haase Exp $
*/

#include <qlined.h>
#include <qlined.h>
#include <qmlined.h>
#include <qsocknot.h>
#include <unistd.h>
#include <fstream.h>
#include <String.h>
#include "processlink.h"
#include "process.h"
#include "conswidget.h"


// int SignalHandler::Handle_SIGCHLD(Process &P){
//      pid_type pid=SignalHandlerClass::Handle_SIGCHLD(P);
//      return pid;
// }

QProcessLink_type::QProcessLink_type(QObject *parent=0,const char *name=0):
     QObject(parent,name),ProcessLink_type(){
     quitsequence="exit\nquit\n";
}

QProcessLink_type::~QProcessLink_type(){
     if(stdinput()) stdinput() << (const char*)quitsequence << endl << flush;
}

void QProcessLink_type::SetQuitSequence(char *qs){
     quitsequence=String(qs);
}

int QProcessLink_type::RunProcess(char *name,char *param1,char *param2,char *param3){
     int ret;
     if((ret=ProcessLink_type::RunProcess(name,param1,param2,param3))!=0){ // parent
	  CoutNotifier=new QSocketNotifier(pipe_stdout_descriptor(),QSocketNotifier::Read,this);
	  connect(CoutNotifier,SIGNAL(activated(int)),
		  this,SLOT(DataAvailableAtCout()));
	  CerrNotifier=new QSocketNotifier(pipe_stderr_descriptor(),QSocketNotifier::Read,this);
	  connect(CerrNotifier,SIGNAL(activated(int)),
		  this,SLOT(DataAvailableAtCerr()));
     }
     return ret;
}

void QProcessLink_type::DataAvailableAtCout(){
     emit readableAtCout();
}

void QProcessLink_type::DataAvailableAtCerr(){
     emit readableAtCerr();
}

ConsoleWidget::ConsoleWidget(QWidget *parent=0,const char *name=0)
     :QWidget(parent,name){

     Output=new QTextView(this);
     Input=new QLineEdit(this);

     SetGeometry();

     connect(Input,SIGNAL(returnPressed()),
	     this,SLOT(CommandEntered()));
     ProcessLink=new QProcessLink_type(this);

     connect(ProcessLink,SIGNAL(readableAtCout()),
	     this,SLOT(OutputFromProcessAvailable_cout()));
     connect(ProcessLink,SIGNAL(readableAtCerr()),
	     this,SLOT(OutputFromProcessAvailable_cerr()));
}

ConsoleWidget::~ConsoleWidget(){
     delete ProcessLink;
     delete Input;
     delete Output;
}

void ConsoleWidget::SendCommand(char *txt){
     if(stdinput()) stdinput() << txt << flush;
}

void ConsoleWidget::CommandEntered(){
     char txt[strlen(Input->text())+5];
     strcpy(txt,Input->text());
     strcat(txt,"\n");
     Input->setText("");
     SendCommand(txt);
}

void ConsoleWidget::OutputFromProcessAvailable_cout(){
     static char txt[1000];
     int i=0,numbytes;
     while ((numbytes=(Process().IsOutputWaiting(Process().pipe_stdout_descriptor())))&&
	    (i!=999)){
	  read(Process().pipe_stdout_descriptor(),txt+i,numbytes);
	  i+=numbytes;
     }
     txt[i]=0;
     if(i>0) Output->append((const char *)txt);
}

void ConsoleWidget::OutputFromProcessAvailable_cerr(){
     static char txt[1000];
     int i=0,numbytes;
     while ((numbytes=(Process().IsOutputWaiting(Process().pipe_stderr_descriptor())))&&
	    (i+numbytes<999)){
	  read(Process().pipe_stderr_descriptor(),txt+i,numbytes);
	  i+=numbytes;
     }
     txt[i]=0;
     if(i>0) Output->append((const char *)txt);
}

void ConsoleWidget::resizeEvent(QResizeEvent *){
     SetGeometry();
}


void ConsoleWidget::closeEvent(QCloseEvent *){
     emit widgetClosed();
}

void ConsoleWidget::SetGeometry(){
     int X1=2;
     int X2=width()-4;
     int Y2=height()-2;
     int Y1=Y2-Input->fontMetrics().lineSpacing()-5;
     Output->setGeometry(X1,2,X2-X1,Y1-2);
     Input->setGeometry(X1,Y1,X2-X1,Y2-Y1);
}

