/*
$Header: /home/elrond/baikal/src/CVS/daq98/conswidget.h,v 1.4 1999/02/03 03:42:13 steffen Exp $
*/

#if !defined __CONSWIDGET_H__
#define __CONSWIDGET_H__

#include <config.h>
#include <qlined.h>
#include <qlined.h>
#include <qmlined.h>
#include <qsocknot.h>
#include <unistd.h>
#include <fstream.h>
#include <String.h>
#include "processlink.h"


class QProcessLink_type:public QObject,public ProcessLink_type{
     Q_OBJECT;
public:
     QProcessLink_type(QObject *parent=0,const char *name=0);
     ~QProcessLink_type();
     int RunProcess(char *name,char *param1=0,char *param2=0,char *param3=0);
     void SetQuitSequence(char *qs);

public slots:
     void DataAvailableAtCout();
     void DataAvailableAtCerr();
signals:
     void readableAtCout();
     void readableAtCerr();
private:
     String quitsequence;
     QSocketNotifier *CoutNotifier,*CerrNotifier;
};


class QTextView:public QMultiLineEdit
{
     Q_OBJECT;
public:
     QTextView(QWidget *parent=0,const char *name=0):
	  QMultiLineEdit(parent,name){
          setReadOnly(true);
	  line=col=0;
     }
     void insertAtEnd(const char *txt){
	  bool nl=false;
	  for(char *i=(char *)txt+strlen(txt);i!=txt;i--){
	      if(*i=='\n') nl=true;
	      else if (*i=='\r' && nl){
		   *i='\n';
		   *(++i)='\0';
		   break;
	      }
	  }
	  
	  setCursorPosition(line,col);
 	  insertAt(txt,line,col);
	  getCursorPosition(&line,&col);
     }       
     void append(const char *txt){
	  insertAtEnd(txt);
     }
private:
     int line,col;
};


class ConsoleWidget:public QWidget
{
     Q_OBJECT;
public:
     ConsoleWidget(QWidget *parent=0,const char *name=0);
     ~ConsoleWidget();
     QProcessLink_type &Process(){
	  return *ProcessLink;
     }       
     ofstream &stdinput(){
	  return ProcessLink->stdinput();
     }
public slots:
     void CommandEntered();
     void OutputFromProcessAvailable_cout();
     void OutputFromProcessAvailable_cerr();
     void SendCommand(char *txt);
signals:
     void widgetClosed();
protected:
     void resizeEvent(QResizeEvent *);
     void closeEvent(QCloseEvent *);
private:
     void SetGeometry();
     QProcessLink_type *ProcessLink;
     QTextView *Output;
     QLineEdit *Input;
     int cursor_line,cursor_col;
};

#endif
