/*
$Header: /home/elrond/baikal/src/CVS/daq98/corbomodule.h,v 1.3 1998/11/23 14:41:08 haase Exp $
*/

#if !defined __CORBOMODULE_H__
#define __CORBOMODULE_H__

#include <config.h>
#include "daqdebug.h"
#include "globalmacros.h"
#include "globaltypes.h"
#include <sys/types.h>

class CORBOModule //:public GeneralModuleBaseClass
{
public:
     CORBOModule() {
	  DEBUG_MESSAGE( << "CORBO created " << endl);
	  
	  // module ddress and ad-mod 
	  corbo_address=0x00500000;   // this must go to .cnf file later !!!
	  corbo_am=0x39;              // this may  go elsewhere ?
	  nw_map_corbo = 256;     
     }

#ifdef VME_ACCESS
     virtual ~CORBOModule(){
	  DEBUG_MESSAGE( << "CORBO destroyed " << endl);
	  // relase memory
	  vme_rel (p_corbo,nw_map_corbo);
     }
#else
     virtual ~CORBOModule(){
	  DEBUG_MESSAGE( << "CORBO destroyed " << endl);
     }
#endif // VME_ACCESS     
		    

#ifdef VME_ACCESS
//
//  Basic Init of the CORBO Module: vme_map & all addresses
//
     int InitModule(StringVector_t &/*errors*/){

//	  p_corbo        = (u_i32 *) vme_map(corbo_address,nw_map_corbo,corbo_am);
	  p_corbo        = (u_i16 *) vme_map(corbo_address,nw_map_corbo,corbo_am);

	  if (!p_corbo) {
	       DEBUG_MESSAGE( << "Init vme_map for CORBO failed " << endl);
	       return -1;
	  }
  
	  p_corbo_csr1           = p_corbo; 
//	  p_corbo_test1          = (u_i32 *) ((void *) p_corbo + 0x50);
//	  p_corbo_clear1         = (u_i32 *) ((void *) p_corbo + 0x58);
	  p_corbo_test1          = (u_i16 *) ((void *) p_corbo + 0x50);
	  p_corbo_clear1         = (u_i16 *) ((void *) p_corbo + 0x58);
	  p_corbo_eventnumber1_h = (u_i16 *) ((void *) p_corbo + 0x10);
	  p_corbo_eventnumber1_l = (u_i16 *) ((void *) p_corbo + 0x12);
	  p_corbo_deadtime1      = (u_i16 *) ((void *) p_corbo + 0x20);

	  DEBUG_MESSAGE( << "CORBO initialized"  << endl);
	  cout           << "CORBO initialized"  << endl;
	  return 0;
     }
#else // VME_ACCESS

//  Basic Init of the CORBO Module: vme_map & all addresses

     int InitModule(StringVector_t &/*errors*/){
	  return 0;
     }
#endif // VME_ACCESS

     virtual int ResetModule(StringVector_t &/*errors*/){
	  return 0;
     }
//   sets the CORBO to the simple Output Register Mode for setting a BUSY on Chan1

     int InitBUSYModeChan1(){
#ifdef VME_ACCESS
	  *p_corbo_csr1 = 0xec;           //  enable chan1,  BUSY latched 
	  SetBUSYChan1();                 // set busy = on = 0V 
#endif // VME_ACCESS
	  return 0;
     }

//   sets the CORBO to the 'read-out-controller' mode (automatic BUSY by input strobe) 

   int InitROCModeChan1(){
#ifdef VME_ACCESS
      asm("eieio");
      *p_corbo_csr1 = 0xD0;           //  enable chan1,  BUSY latched 
      asm("eieio");
      SetBUSYChan1();                 // set busy = on = 0V 
#endif
      return 0;
   }
   
//  Remove the BUSY Chan1 

     inline int RemoveBUSYChan1 (void){
#ifdef VME_ACCESS
	  *p_corbo_clear1 = 0;             // set busy = off = -0.8V 
#endif // VME_ACCESS
	  return 0;
     }

//  Set the BUSY Chan1 

     inline int SetBUSYChan1 (void){
#ifdef VME_ACCESS
	  *p_corbo_test1  = 0;             // set busy = on = 0V 
#endif // VME_ACCESS
	  return 0;
     }

//  Input Present1 Chan1  
//    1=input present (BUSY was set),   0=no input (No BUSY set)
   
   inline int InputPresentChan1 (void){
#ifdef VME_ACCESS
//      asm("eieio");
	u_i16 i = *p_corbo_csr1;
//      i = 0x01 & (i>>8);               // input present 
	i = 0x01 & (i>>9);                 // local BUSY present
#else
      int i=1;
#endif // VME_ACCESS
      return i;
   }
   
//  Some LED flashing - just for fun....

     inline int PlayChan1(void){
#ifdef VME_ACCESS
	  time_t useconds_off=500000;      // in musecs
	  time_t useconds_on=500000;    
	  
	  // just to light the led's
	  for (int i=0;i<2;i++){
	       SetBUSYChan1();             // set busy = on = 0V 
	       usleep (useconds_on);
	       RemoveBUSYChan1();          // set busy = off = -0.8V 
	       usleep (useconds_off);
	  }
	  SetBUSYChan1();                  // set busy = on = 0V
#endif // VME_ACCESS
	  return 0;
     }


private:

// the CORBO privates
//     u_i32 *p_corbo, *p_corbo_csr1, *p_corbo_test1, *p_corbo_clear1;
     u_i16 *p_corbo, *p_corbo_csr1, *p_corbo_test1, *p_corbo_clear1;
     u_i16 *p_corbo_eventnumber1_h,*p_corbo_eventnumber1_l, *p_corbo_deadtime1;
     u_i32 corbo_address;   
     int   corbo_am;
     int   nw_map_corbo;
};


#endif // __CORBOModule_H__
