/*
$Header: /home/elrond/baikal/src/CVS/daq98/crateclasses.h,v 1.6 1999/02/10 21:35:14 daq Exp $
*/

#if !defined __CRATECALSSES_H__
#define __CRATECALSSES_H__

//#define DEBUG_MSG
//#define DEBUG_SETTER

#include <config.h>
#include <String.h>
#include "simplevector.h"
#include "daqdebug.h"
#include "settergetter.h"
#include "pointerutil.h"
#include "hwconfigitems2.h"
#include "channelmodule.h"
#include "stringutil.h"


#ifdef VME_ACCESS   // .......................

#include        <smem.h>    
#include        <types.h>

#include	"ces/rtpc8067.h"
extern "C" {
#include	"ces/pcilib.h"
#include	"ces/pvsb8464.h"
#include	"ces/vsb.h"
}

#include        <timers.h>


// typedef  unsigned long int  u_i32;

// /usr/src/ces/examples/vlib/vlib.c
//void myloop(u_i32 &i);
//void loop_gps(u_i32 &i);
////void init_vsb(long i);
////void close_vsb(long i);


extern "C"{
int PCI_Conf1_open();
int PCI_Conf1_close();
}
   
extern long Bridge;
extern long VSBM;
extern long NCR;
extern _Bridge B;
extern _VsbMaster V;
extern long BridgeType;

#endif    // VME_ACCESS  .....................



class CrateBaseClass_t:public ClassWithTypeInfo_t
{ 
     ClassTypeInfo(ClassWithTypeInfo_t);
     MAKE_VECTOR(u_i32,ModuleSlotVector_t);
public:
     CrateBaseClass_t(int numslots){
	  NumSlots=numslots;
	  ModuleSlotVector=new ModuleSlotVector_t(NumSlots);
     }
     virtual ~CrateBaseClass_t(){
	  delete ModuleSlotVector;
     }
     virtual int Init()=0;
     inline const bool IsAddress_SlotReserved(const u_i32 addr_slot){
	  ModuleSlotVector_t::iterator module=ModuleSlotVector->begin();
	  while((module<ModuleSlotVector->end())&&((*module)!=addr_slot)) module++;
	  if(module==ModuleSlotVector->end()){
	       return false;
	  }
	  return true;
     }       

     inline void ReserveAddress_Slot(const u_i32 addr_slot){
	  ModuleSlotVector->push_back(addr_slot);
     }
     inline void SetCrateConfig(CrateConfigRecord_p cc){
	  CrateConfig=cc;
     }
     inline CrateConfigRecord_p &GetCrateConfig(){
	  return CrateConfig;
     }
     /** insert a Module into the crate for event readout */
     inline void InsertModule(ChannelModuleBaseClass_p &Module){
	  Module->SetCrate(this);
	  EventReadoutModules.push_back(Module);
     }
     
     /** insert a Module into the crate for asynch readout */
     inline void InsertModule_Asynch(ChannelModuleBaseClass_p &Module){
	  Module->SetCrate(this);
	  AsynchReadoutModules.push_back(Module);
     }
	       
     /** insert a Module into the crate for DMAD readout */
     inline void InsertModule_DMAD(ChannelModuleBaseClass_p &Module){
	  Module->SetCrate(this);
	  DMADModules.push_back(Module);
     }

     /** read real Event-Modules  */
     inline int ReadoutModules(BinaryDataBuffer &DataBuffer){
	  return ReadoutModules_priv(EventReadoutModules,DataBuffer);
     }
     
     /** read asynch Modules  */
     inline int ReadoutModules_Asynch(BinaryDataBuffer &DataBuffer){
	  return ReadoutModules_priv(AsynchReadoutModules,DataBuffer);
     }

     /** read DMAD Modules  */
     inline int ReadoutModules_DMAD(BinaryDataBuffer &DataBuffer){
	  return ReadoutModules_priv(DMADModules,DataBuffer);
     }

     /** Init real Event-Modules  */
     inline int InitModules(StringVector_t &errors){
	  return InitModules_priv(EventReadoutModules,errors);
     }
     
     /** Init asynch Modules  */
     inline int InitModules_Asynch(StringVector_t &errors){
	  return InitModules_priv(AsynchReadoutModules,errors);
     }

     /** Init DMAD Modules  */
     inline int InitModules_DMAD(StringVector_t &errors){
	  return InitModules_priv(DMADModules,errors);
     }

     /** Reset real Event-Modules  */
     inline int ResetModules(StringVector_t &errors){
	  return ResetModules_priv(EventReadoutModules,errors);
     }
     
     /** Reset asynch Modules  */
     inline int ResetModules_Asynch(StringVector_t &errors){
	  return ResetModules_priv(AsynchReadoutModules,errors);
     }

     /** Reset asynch Modules  */
     inline int StartModules_Asynch(StringVector_t &errors){
	  return StartModules_priv(AsynchReadoutModules,errors);
     }

     /** Checks for triggers from the modules Modules  */
     inline int CheckTrigger_Asynch(){
	  return CheckTrigger_priv(AsynchReadoutModules);
     }

private:
     /** read all modules that are in the vector */
     inline int ReadoutModules_priv(ChannelModuleVector_t &ReadOutVector,
				    BinaryDataBuffer &DataBuffer){
	  // read the Module
	  ChannelModuleVector_t::iterator mi;
	  for(mi=ReadOutVector.begin();mi<ReadOutVector.end();mi++){
	       if((*mi)->HasModuleData())
		    (*mi)->ReadToBuffer(DataBuffer);
	  }
	  return 0;
     }

     /** init all modules that are in the vector */
     inline int InitModules_priv(ChannelModuleVector_t &InitVector, StringVector_t &errors){
	  // init the modules in Vector
	  int err=0;
	  ChannelModuleVector_t::iterator mi;
	  for(mi=InitVector.begin();mi<InitVector.end();mi++){
	       if((*mi)->GetModuleConfig()->Enabled)
		    err+=(*mi)->InitModule(errors);
	  }
	  return err;
     }       

     /** Resets all modules that are in the vector */
     inline int ResetModules_priv(ChannelModuleVector_t &InitVector, StringVector_t &errors){
	  // init the modules in Vector
	  int err=0;
	  ChannelModuleVector_t::iterator mi;
	  for(mi=InitVector.begin();mi<InitVector.end();mi++){
	       if((*mi)->GetModuleConfig()->Enabled)
		    err+=(*mi)->ResetModule(errors);
	  }
	  return err;
     }       

     /** Resets all modules that are in the vector */
     inline int StartModules_priv(ChannelModuleVector_t &InitVector, StringVector_t &errors){
	  // init the modules in Vector
	  int err=0;
	  ChannelModuleVector_t::iterator mi;
	  for(mi=InitVector.begin();mi<InitVector.end();mi++){
	       if((*mi)->GetModuleConfig()->Enabled)
		    err+=(*mi)->StartModule(errors);
	  }
	  return err;
     }       

     /** checks triggers for all  modules that are in the vector */
     inline int CheckTrigger_priv(ChannelModuleVector_t &ReadOutVector){
	  // read the Module
	  ChannelModuleVector_t::iterator mi;
	  for(mi=ReadOutVector.begin();mi<ReadOutVector.end();mi++){
	       if((*mi)->HasModuleData()) return 1;
	  }
	  
	  return 0;
     }

protected:
     int NumSlots;
private:
     ModuleSlotVector_t *ModuleSlotVector;
     CrateConfigRecord_p CrateConfig;
     ChannelModuleVector_t EventReadoutModules;
     ChannelModuleVector_t AsynchReadoutModules;
     ChannelModuleVector_t DMADModules;
};

MAKE_REFCOUNT_POINTER(CrateBaseClass_t,CrateClass_p);
MAKE_INC_VECTOR(CrateClass_p,     CrateVector_t);

class VSB_Class
{   
     enum {
	  AD=0x02000000
     };
     

public:
     VSB_Class() {}
     ~VSB_Class(){
	  if (vsb_is_init) VSB_Release();
	  vsb_is_init =  false;
     }

#ifdef VME_ACCESS

     int VSB_Init(){
      
	  long   ad,br,bdg;
      
	  ad=AD;
     
	  /*
	   * set bridge type
	   */
	  br=LK;
	  BridgeType = br;
	  cout << "Going Init VSB:" << endl;
	  printf (" PPC-PCI Bridge type set to %s\n",br?"Lanai-Kauai":"NS-Dakota");
	  /*
	   * get window for bridge configuration
	   */
	  if (!(m1=(long)smem_create("BDG",(char *)(BRIDGE_CFG_PPC_BASE&~0xFFF),0x1000,SM_READ|SM_WRITE))){
	       fprintf(stderr,"unable to allocate BDG window\n");
	       exit(0);
	  }
	  bdg = (m1 | (BRIDGE_CFG_PPC_BASE&0xFFF));
	  /* 
	   * configure base addresses
	   */
	  Bridge = bdg;
	  VSBM = VSBM_CFG_RIO_BASE;
	  /*
	   * open RIO communication
	   */
	  PCI_Conf1_open();
	  /*
	   * initialize PCI-PCI bridge and VSB master defaults
	   */
	  InitBrParam(&B);
	  InitVsbParam(&V);
	  SetBrDefaults(&B);
	  SetVsbDefaults(&V);
	  /*
	   * set VSB Host Entry Descriptor (VHED)
	   * bits 18:17 = 0 (no prefetch)
	   * bit  16    = 0 (no BLT)
	   * bits 15:07 = taken from ad
	   * bits 06:05 = 3 (System Addres Space)
	   * bots 04:03 = 1 (Byte and Word Swap)
	   * bit  02    = 0 (No VSB prefetch)
	   * bit  01    = 0 (No VSB write post)
	   * bit  00    = 1 (Valid)
	   */
	  V.VHED.Value = ((ad >> 16)&0xFF80)|0x69;
	  /*
	   * so far, we initialized memory structures,
	   * Now write parameters to hardware
	   */
	  WriteBrParam( &B, Bridge);
	  WriteVsbParam( &V, VSBM);
      
	  printf(" VSB address 0x%lx mapped to 0x%x\n", \
		 ad&0xff800000,VSBWIN_BASE);
         
	  vsb_is_init = true;
	  return 0;   
     }
   
     int VSB_Release() {

	  PCI_Conf1_close();
	  smem_create("BDG",(char *)m1,0x1000,SM_DETACH);
	  smem_remove("BDG");
	  vsb_is_init = false;
	  cout << "VSB is released." << endl;     
	  return 0;   
     }

#else

     int VSB_Init()	       
	  {
	  vsb_is_init = true;
	  return 0;   
	  }

     int VSB_Release() {
	  vsb_is_init = false;
	  return 0;
     }
     
#endif




private:      
     long m1;
     bool vsb_is_init;        
};

// CAMAC Crate Class - one per Crate

class CAMAC_Crate_Class_t:public CrateBaseClass_t
{
     ClassTypeInfo(CrateBaseClass_t);
     enum 
     {
	  SLOTS=20
     };
     
public:
     CAMAC_Crate_Class_t():CrateBaseClass_t(SLOTS) {
	  crate_is_init=false;
     }
     ~CAMAC_Crate_Class_t(){
	  if (crate_is_init) CAMAC_Crate_Release();
     }
     
     virtual int Init(){
	  StringSplitter sp(GetCrateConfig()->ConnectedTo,' ');
	  int CrateNumber=atoi(sp()[0]);

	  VSB.VSB_Init();

	  return CAMAC_Crate_Init(CrateNumber);
     }

#ifdef VME_ACCESS
	       
     int CAMAC_Crate_Init(int number){
	  
	  long int    *pmy_data, winvsb_725,*cnaf_vsb;
	  u_i32       data;
   
	  crate_number = number;

	  if (crate_is_init) {
	       cout << "**** CAMAC_Crate_Init: " << GetCrateConfig()->CrateID
		    << " connected as Crate# " <<crate_number<< " already exists ****"<<endl;
	       return -1;
	  }
      
	
	  //	winvsb_725 = 0x1;   this was ok with  MVME162/68040
	  winvsb_725 = 0x0;
	  camac_ioff_vsb = ((0x07 & winvsb_725) << 26) | ((0x0F & crate_number) << 21);

//	  printf (" ioff_vsb =  0x%lx \n",(long)camac_ioff_vsb);
		
	  //	pmy_data = (long *) VSBWIN_BASE;
	  //	pmy_data = (long *) 0xc020f624;   /* vsb-win=0 */
	  pmy_data = (long *) 0xc420f624;   // vsb-win=1 

	  // initialize the crate 

	  cnaf_vsb       = CAMAC_Crate_Pointer (28,8,26);     // Camac zero
	  data = *cnaf_vsb;
	  cnaf_vsb       = CAMAC_Crate_Pointer (30,9,24);     // reset inhibit 
	  data = *cnaf_vsb;
	  cnaf_vsb       = CAMAC_Crate_Pointer (28,1,26);     // enable Q&X in data-word 
	  data = *cnaf_vsb;      
      
	  cout << "CAMAC Crate " << GetCrateConfig()->CrateID 
	       << "  connected as Crate# "<< crate_number << "  initialized. " << endl; 
	  crate_is_init = true;
	  return 0;
     }
 
   
     int CAMAC_Crate_Release () {   

	  crate_is_init = true;
	  // nothing to be done ....      
	  cout << "CAMAC Crate " << GetCrateConfig()->CrateID 
	       << "  connected as Crate# "<< crate_number << "  is released." << endl; 
	  return 0;
     }
     
 
     inline u_i32 CAMAC_Crate_Base_Address () {
	  return camac_ioff_vsb | VSBWIN_BASE;
     }
  
   
     inline long int *  CAMAC_Crate_Pointer (int N, int A, int F) {

	  long int  *cnaf_vsb;
	  u_i32 lnaf = 0x0000FFFC & (((0x1F & N)<<11) | ((0x1F & F)<<6) | ((0xF & A)<<2));
	  cnaf_vsb = (long *)(( camac_ioff_vsb  | VSBWIN_BASE) | lnaf);
//          printf (" CAMAC_Pointer: N,A,F= %3d %3d %3d, cnaf_vsb = 0x%lx \n",N,A,F,(long)cnaf_vsb);
	  return  cnaf_vsb;
     }

#else   // VME_ACCESS

     int CAMAC_Crate_Init(int number) {
   
	  crate_number = number;
	  crate_is_init = true;

	  cout << "CAMAC Crate " << GetCrateConfig()->CrateID 
	       << "  connected as Crate# "<< crate_number << "  initialized (SIMUL). " << endl; 

	  return 0;
     }   
     int CAMAC_Crate_Release () {   

	  crate_is_init = true;
	  return 0;
     } 
     inline u_i32 CAMAC_Crate_Base_Address () {
	  return 0;
     }   
     inline long int *  CAMAC_Crate_Pointer (int /*N*/, int /*A*/, int /*F*/) {
	  return  0;
     }

#endif

private:
     bool      crate_is_init;
     int       crate_number;
     u_i32     camac_ioff_vsb;
     
     VSB_Class VSB;
      
};  // CAMAC_Crate_Class_t


class VME_Crate_Class_t:public CrateBaseClass_t
{
     ClassTypeInfo(CrateBaseClass_t);
     enum
     {
	  SLOTS=21
     };
public:
     /** map vme window */
     VME_Crate_Class_t():CrateBaseClass_t(SLOTS){};
//      static u_i32 vme_map(u_i32 vaddr,u_i32 wsiz,u_i32 am){
// 	  u_i32 ad;
// 	  ad = find_controller(vaddr,wsiz,am,0,0,&param);
// 	  if (ad == -1){
// 	       return(0);
// 	  }else{
// 	       return(ad);
// 	  }
//      }
//      /** return page descriptor */
//      static u_i32 vme_rel(u_i32 laddr,u_i32 wsiz){
// 	  return(return_controller(laddr,wsiz));
//      }
};


#endif //__CRATECALSSES_H__
