#if ! defined __DAQ98DMADEVENT_H__
#define __DAQ98DDMADEVENT_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/daq98dmadevent.h,v 1.2 1999/02/03 03:42:13 steffen Exp $
*/

#include <config.h>
#include "event.h"
#include "daq98rawdataanalysis.h"
#include "daq98f2000.h"

/** A class that analyses counter event data */
class Daq98DMADEvent_t:public Daq98RawDataAnalysis_t
{
public:
     /** Constructor */
     Daq98DMADEvent_t(DaqProcessBase *parent);

     /** Destructor */
     ~Daq98DMADEvent_t();

     SetF2000Writer(Daq98F2000_t *f2000){F2000=f2000;}       

protected:
     /*
	 @param RecordHeader Record header, contains the record ID and the
	 size of the data to follow.
	 @param Buf Binary data buffer to act on.
	 @return 1 if the data was read from the buffer and the 
	 data processing was successful. Returning 1 tells the 
	 base class to rewind the buffer that it can be used by
	 other data handling classes.\\ \\
	 0 if the data was not touched.\\ \\
	 {\tt CRITICAL\_ERROR} on, you guessed it, critical errors. This leads to the abortion
	 of the program. \\ \\
	 {\tt NONCRITICAL\_ERROR} on internal failure. 
	 It is assumed that the data was read (how else
	 could you tell that there was an error) so the buffer will be rewind after
	 that by the base class. 
	 If you did not touch the data and somehow managed to produce an error
	 you have to call the {\tt \Ref{DontRewind}} function. */
     inline virtual int __AnalyseData(RecordHeader_t RecordHeader, 
				      BinaryDataBuffer &Buf);

protected:
     /** Object that is able to build muon events */
     EventBuilder_t EventBuilder;

private:
     /** the F2000 writer */
     Daq98F2000_t *F2000;
     
     /** Mounon event builder needs hw configuration */
     bool EventBuilderNotConfigured;
     
     /** Header for muon events */
     DMAD_EventHeader_t EventHeader;

};


#endif // __DAQ98COUNTEREVENT_H__
