/*
  $Header: /home/elrond/baikal/src/CVS/daq98/daq98f2000.C,v 1.17 1999/08/19 23:45:41 wischnew Exp $
*/

#include "daq98f2000.h"
#include "base.h"

Daq98F2000_t::Daq98F2000_t(DaqProcessBase *parent,output_mode_t o_mode=OUTMODE_MULTIPLE_EVENTS):
     Daq98MuonEventAnalysis_t(parent),
     F2000Stream(0),output_mode(o_mode),
     external_year(0){}

Daq98F2000_t::~Daq98F2000_t(){}

int Daq98F2000_t::Init(){
     if(!F2000Stream) F2000Stream=&cout;
     if(output_mode!=OUTMODE_SINGLE_EVENT){
	  *F2000Stream << 
	       "V 2000.1.2 \n" 
	       "HI DAQ98 reader (" << VERSION << ")\n"
	       "!    DAQ98 reader99 (1.320/01) \n"
	       "!    V2000.1.1 modified  for daq  \n"
	       "TRIG_DEF 1 amaa   trig_pulse_le trig_pulse_tot regi_flag\n"
	       "TRIG_DEF 2 amab10 trig_pulse_le trig_pulse_tot regi_flag\n"
	       // JJ request 2/98	   << "TRIG_PAR 2 type=majority window=2000  fold=16\n"
	       "TRIG_DEF 4 amaab  trig_pulse_le trig_pulse_tot regi_flag\n"
	       "TRIG_DEF 8 spase2 trig_pulse_le trig_pulse_tot regi_flag\n"
	       "TRIG_DEF 16 string trig_pulse_le trig_pulse_tot regi_flag\n"
	       "TRIG_DEF 32 Bsc1 trig_pulse_le trig_pulse_tot regi_flag\n";
	  //	  << "STAT_DEF GPS device words\n";
     }
     return 0;
}
     
	  
void Daq98F2000_t::SetOutputStream(ostream *Stream){
     if(!Stream) F2000Stream=&cout; else F2000Stream=Stream;
}

void Daq98F2000_t::SetYear(int i){
     if(i<1900){
	  if(i<90)
	       external_year=i+2000;
	  else
	       external_year=i+1900;
     }
     else
	  external_year=i;
}

int Daq98F2000_t::AnalyseCounterEvent(CounterEventHeader_t EventHeader,
				      S7201CounterEvent_t &CntEvnt){
#warning RALF, this is for you, this function is called, when a Counter Event wants to be written as F2000
     cerr << "Would like to write Counter-Event F2000, but do not know how" << endl;
     return 0;
}


int Daq98F2000_t::AnalyseDMADEvent(DMAD_EventHeader_t &DMADHeader,
				   DMAD_ModuleConfigRecord_p DMAD_Event){
// DMAD_ModuleConfigRecord_p DMAD_Event <- this is not only config but
// also actual data from the module
#warning RALF, this is for you, this function is called, when a DMAD_Status wants to be written as F2000
     cerr << "Would like to write DAMD-Status F2000, but do not know how" << endl;
     return 0;     
}


// void Daq98F2000_t::SetFile(const char *File,int flags=ios::app);
//      Flags=flags;
//      if(F2000File!=0) delete [] F2000File;
//      F2000File=new char[strlen(File)+1];
//      strcpy(F2000File,File);
// }

// HH: I do not trust the ostream.form thing, first I do have bad
// experience with this function (bugs etc. (may be obsolete
// meanwhile)) and second it is not part of any c++ standart, so it
// might not be good to use it !

int Daq98F2000_t::__AnalyseData(MuonEventHeader_t &EventHeader, MuonEventData_p Event){
     static first=1;
     char msg[MAX_TEXT_SIZE];
          
     if(output_mode==OUTMODE_SINGLE_EVENT){
	  *F2000Stream << 
	       "V 2000.1.2 \n" 
	       "HI DAQ98 reader (" << VERSION << ")\n"
	       "!    DAQ98 reader99 (1.320/01) \n"
	       "!    V2000.1.1 modified  for daq  \n"
	       "TRIG_DEF 1 amaa   trig_pulse_le trig_pulse_tot regi_flag\n"
	       "TRIG_DEF 2 amab10 trig_pulse_le trig_pulse_tot regi_flag\n"
	       // JJ request 2/98	   << "TRIG_PAR 2 type=majority window=2000  fold=16\n"
	       "TRIG_DEF 4 amaab  trig_pulse_le trig_pulse_tot regi_flag\n"
	       "TRIG_DEF 8 spase2 trig_pulse_le trig_pulse_tot regi_flag\n"
	       "TRIG_DEF 16 string trig_pulse_le trig_pulse_tot regi_flag\n";
	       "TRIG_DEF 32 Bsc1 trig_pulse_le trig_pulse_tot regi_flag\n";
     }

     // special TDC channels
     int Trigger_A_TDCChan =  490;
     int Trigger_B_TDCChan =  491;
     int Trigger_AB_TDCChan = 492;
     int Trigger_S2_TDCChan = 493;
     int Trigger_ST_TDCChan = 494;
     int Trigger_Bsc1_TDCChan = 458;

     // 1999: ch456 = "laser"
     //       ch457 = "Trigger"


     // Offline Extraction: trigger-flag
     Trigger_t trigger = Event->Trigger;
     
     int Trigger_A_Bit = 0x01;
     int Trigger_B_Bit = 0x02;
     int Trigger_AB_Bit = 0x04;
     int Trigger_S2_Bit = 0x08;
     int Trigger_ST_Bit = 0x10;
     int Trigger_Bsc1_Bit = 0x20;

     // output decision: trigger -  B / S2 / A  .............   make your choice here   ..............
     int offline_trigger_f2000 = 0;

     int offline_trigger_use_A  = 1;
     int offline_trigger_use_B  = 1;
     int offline_trigger_use_AB = 1;
     int offline_trigger_use_S2 = 1;
     int offline_trigger_use_ST = 1;
     int offline_trigger_use_Bsc1 = 1;
     
     if (offline_trigger_use_A  &&   (Trigger_A_Bit  & trigger))  offline_trigger_f2000 = 1;
     if (offline_trigger_use_B  &&   (Trigger_B_Bit  & trigger))  offline_trigger_f2000 = 1;
     if (offline_trigger_use_AB &&   (Trigger_AB_Bit & trigger))  offline_trigger_f2000 = 1;
     if (offline_trigger_use_S2 &&   (Trigger_S2_Bit & trigger))  offline_trigger_f2000 = 1;
     if (offline_trigger_use_ST &&   (Trigger_ST_Bit & trigger))  offline_trigger_f2000 = 1;
     if (offline_trigger_use_Bsc1 &&   (Trigger_Bsc1_Bit & trigger))  offline_trigger_f2000 = 1;


     // SKIP untriggered events          
     if(!offline_trigger_f2000){
//     ****
//     printf (" **** trigger rejected  ",trigger); 
	  return 0;
     }
     
     // Event accepted
     GPSTime_t gps_time;
     if(Event->GPSTime[0].quality == 0){
	  gps_time=Event->GPSTime[0];
     }
     else if(Event->GPSTime[1].quality == 0){
	  gps_time=Event->GPSTime[1];
     }
     else if(Event->GPSTime[2].quality == 0){
	  gps_time=Event->GPSTime[2];
     }
     else{
	  LogMsg("All GPS times have poor quality. Using GPS 0",2,2,WARNING);
	  gps_time=Event->GPSTime[0];
     }
     if(external_year){
	  year=external_year;
     }
     else {
	  if(gps_time.year==0 && Event->UnixTime.year !=0){
	       // we are not realy in year 2000, the GPS repeater modules just screwed up
	       // We use Unix time year, and hope that this is not New Years eve
	       year=Event->UnixTime.year;
	  }else{
	       // this must be a real year
	       year = gps_time.year;
	  }
	  if(year<90) 
	       year+=2000;
	  else 
	       year+=1900;
     }
     
     day  = gps_time.day;
     UTC = gps_time.hour*3600. + gps_time.min*60. + gps_time.sec + (double)1.e-9 * (double)gps_time.nsec;

     
     if (first){
	  first = 0;
	  F2000Stream->form("TBEGIN  %d  %d  %f\n",year,day,UTC);
//	  DEBUG_MESSAGE(<< "TBEGIN= " << year<<" "<<day<<" "<< UTC << endl,5);     
     }

     int run=RunNumber;

     //Event Header line
     F2000Stream->form("EM  %d  %d    %d %d %f\n",EventHeader.EventNumber,run,year,day,UTC);
     
     // prepare the event: construct Hits, and trigger times....
     SubEventData_p se_i=Event->SubEvents;

     char s_le_trigger_A[20]="-1", s_tot_trigger_A[20]="-1",
	  s_le_trigger_B[20]="-1", s_tot_trigger_B[20]="-1",
	  s_le_trigger_AB[20]="-1", s_tot_trigger_AB[20]="-1",
	  s_le_trigger_S2[20]="-1", s_tot_trigger_S2[20]="-1",
	  s_le_trigger_ST[20]="-1", s_tot_trigger_ST[20]="-1",
	  s_le_trigger_Bsc1[20]="-1", s_tot_trigger_Bsc1[20]="-1";
	       

     u_i16 nhits_event=0;
     for(int i=0;i<Event->NoOfChannels;i++){
	  int chan = (*se_i).ID;

//	  if (chan>428)  break;              //    just skip the 'trigger' channels for the moment .... (3/98)

// treat all special channels as ordinary ones   (12/98)
//   during 3-12/98 we had them ignored    
//    .. these are: 
//             - true trigger input channels (that are reported to the input register)
//             - additional special channels (e.g. laser, not used as trigger bit) 
//


//	  if(Parent->IsVerboseLevel(2)){
//	       sprintf(msg,"Big CHAN_Nb.: EvtNb, Chan =  %10d %5d\n",EventHeader.EventNumber,chan);
//	       LogMsg(msg,2,2,WARNING);
//	  }



	  int amp   = (*se_i).Amplitude.ampval;
	  int isamp = (*se_i).Amplitude.isamp;
	  
	  u_i16 nle_ch=0;      //   **
	  u_i16 fifoov=0;      //   ** FIFO overflow, if ==1 
	  u_i16 eall[MAX_TIME_HITS], edg[MAX_TIME_HITS];
	  u_i16 le[MAX_TIME_HITS], tot[MAX_TIME_HITS], hqual[MAX_TIME_HITS];   
	  u_i16 t_fullscale=32767;

	  int ne = (*se_i).NoOfEdges;

	  if (ne > MAX_TIME_HITS) {              // this should never happen !!! ********
	       if(Parent->IsVerboseLevel(2)){
		    sprintf(msg,"too many edges ne %d, Event %d, chan %d",
			   ne,EventHeader.EventNumber,chan);
		    LogMsg(msg,2,2,WARNING);
	       }
	       ne = MAX_TIME_HITS;
	  }

	  // Set the FIFO-OV ,  prelim. *** (K32)
	  if (ne==MAX_TIME_HITS)    fifoov = 1;

	  // fill all edges,  check if increasing (reversed)  order    (k32 vs 3377)
	  //   ** better: do sort in moduleeval module-type-wise !
	  if (ne>1 && (((*se_i).Times[0].timeval)<((*se_i).Times[1].timeval))) { 
	       unsigned int eall_last =0;
	       for(int jj=0; jj<ne; jj++){
// ***		    eall[ne-jj-1]=(*se_i).Times[jj].timeval;
		    eall[ne-jj-1]=t_fullscale - (*se_i).Times[jj].timeval;
		    edg[ne-jj-1]=(*se_i).Times[jj].edge;

// 		    if(Parent->IsVerboseLevel(2)){
// 			 if (jj && (eall[ne-jj-1] > eall_last) ){
// 			      sprintf(msg," wrong order eall: Evt %d, OM %d, nedges %d, t_curr %d, t_last %d ",
// 				      EventHeader.EventNumber,chan,ne,eall[ne-jj-1],eall_last);
// 			      LogMsg(msg,2,2,WARNING);
// 			 }
// 			 eall_last = t_fullscale - (*se_i).Times[jj].timeval;
// 		    }
	       }
	  }
	  else 
	  {
	       for(int jj=0; jj<ne; jj++){
		    eall[jj]= t_fullscale - (*se_i).Times[jj].timeval;
		    edg[jj]=(*se_i).Times[jj].edge;
	       }
	  }
	  
	  // form a hit from next 1 or two edges:     
	  // 1)  LE & TE (hit_qual=3) ,  2) LE only (=1),  3) TE only (=2), 4) no LE &TE but Amp (!=0)
	  u_i16  e_1=0;
	  u_i16  t_1=0;                                
	  u_i16  e_2=0;
	  u_i16  t_2=0;                                

	  int   new_hit = 1;
	  int   stop_hit = 0;
	  int   hit_qual = 0;

	  for (int j=0;j<ne;j++){
	       u_i16 ti = eall[j];
	       u_i16 ed = edg[j];
	       
	       if (new_hit) {
		    new_hit = 0;
		    hit_qual = 0;
		    stop_hit = 0;
		    if (ed==0) {         // ok - LE
			 e_1 = ed;
			 t_1 = ti;
			 hit_qual +=1;
		    }
		    else {               // TE only
			 t_2 = ti;
			 hit_qual +=2;
			 stop_hit = 1;
		    }
	       }
	       else {                     
		    stop_hit = 1;
		    if (ed==1) {         // ok - TE
			 e_2 = ed;
			 t_2 = ti;
			 hit_qual +=2;
		    }
		    else j--;               // next LE - reset
	       }
	       
	       if (stop_hit || (j==(ne-1)) ) {           //  hit ready for output (hit finished or last hit) 
		    nle_ch++;
		    hqual[nle_ch-1]=hit_qual;
		    if (hit_qual==3) {                 //  LE & TE
			 le[nle_ch-1]=t_1;
// ***			 tot[nle_ch-1]=t_1-t_2;
			 tot[nle_ch-1]=t_2-t_1;
		    }
		    else if(hit_qual==1) {             // LE only
			 le[nle_ch-1]=t_1;
		    }
		    else if(hit_qual==2) {             // TE only
			 tot[nle_ch-1]=t_2;
		    }
		    else 
			 if(Parent->IsVerboseLevel(2)){
			      sprintf(msg,"hit_qual = %d",hit_qual);
			      LogMsg(msg,2,2,WARNING);
			 }
		    new_hit = 1;
		    stop_hit = 0;
		    hit_qual = 0;
		    stop_hit = 0;
	       }
	  }
     

	  // output all hits for this channel ... 

	  int source=0,
	       so,
	       nle_ch_print;
	  char s_le[20], 
	       s_tot[20],
	       s_nedges[20];	       
//	  sprintf (s_nedges,"%3d",ne);
//	  if (fifoov==1)  sprintf (s_nedges+strlen(s_nedges),"F");
//	  if (fifoov==1)  sprintf (s_nedges,">");
//	  else            sprintf (s_nedges," ");
//	  sprintf (s_nedges+strlen(s_nedges),"%3d",ne);
	  if (fifoov==1)  sprintf (s_nedges,">%2d",ne);
	  else            sprintf (s_nedges," %2d",ne);

	  nle_ch ? nle_ch_print=nle_ch : nle_ch_print=1;         // print zero hits



#if 0     //  ... in "CH"-output format

	  if (isamp)  F2000Stream->form("CH %5d %5.1f ",chan,float(amp));       
	  else F2000Stream->form("CH %5d     ? ",chan);     

	  F2000Stream->form("  %s",s_nedges);  


	  for (int il=0; il<nle_ch_print; il++){
	       nhits_event++; 

	       so=source;

	       sprintf (s_le, "%7d",le[il]);
	       sprintf (s_tot,"%7d",tot[il]);

	       if (ne==0)      {                              // no hits 
		    sprintf (s_tot,"      ?");
		    sprintf (s_le, "      ?");
	       }
	       if (hqual[il]==1)       sprintf (s_tot,"      ?");      // no TE 
	       else if (hqual[il]==2)  sprintf (s_le, "      ?");      // no LE
				  
	       F2000Stream->form("   %4d %3d %s %s",nhits_event,so,s_le,s_tot);  
	  }
	  F2000Stream->form("\n");


#else     //  ... in "HT"-output format


	  for (int il=0; il<nle_ch_print; il++){
	       nhits_event++; 

	       so = source;
	       
	       sprintf (s_le, "%7d",le[il]);
	       sprintf (s_tot,"%7d",tot[il]);

	       if (ne==0)      {                              // no hits 
		    sprintf (s_tot,"      ?");
		    sprintf (s_le, "      ?");
	       }
	       if (hqual[il]==1)       sprintf (s_tot,"      ?");      // no TE 
	       else if (hqual[il]==2)  sprintf (s_le, "      ?");      // no LE

	       char s_amp[20];
	       if (!il) {
		    if (isamp) sprintf (s_amp,"%5.0f",(float)amp);
		    else       sprintf (s_amp,"    ?");
	       }
	       else sprintf (s_amp,"   * ");

	       // save for trigger line

	       if (Trigger_A_TDCChan == chan) {
		    s_le_trigger_A = s_le;
		    s_tot_trigger_A = s_tot;
	       }
	       else if (Trigger_B_TDCChan == chan) {
		    s_le_trigger_B = s_le;
		    s_tot_trigger_B = s_tot;
	       }
	       else if (Trigger_AB_TDCChan == chan) {
		    s_le_trigger_AB = s_le;
		    s_tot_trigger_AB = s_tot;
	       }
	       else if (Trigger_S2_TDCChan == chan) {
		    s_le_trigger_S2 = s_le;
		    s_tot_trigger_S2 = s_tot;
	       }
	       else if (Trigger_ST_TDCChan == chan) {
		    s_le_trigger_ST = s_le;
		    s_tot_trigger_ST = s_tot;
	       }
	       else if (Trigger_Bsc1_TDCChan == chan) {
		    s_le_trigger_Bsc1 = s_le;
		    s_tot_trigger_Bsc1 = s_tot;
	       }



	       F2000Stream->form("HT %5d %s",chan,s_amp);
				  
	       F2000Stream->form("   %4d %3d %s %s",nhits_event,so,s_le,s_tot);  
	       F2000Stream->form("   %s",s_nedges);  
	       
	       *F2000Stream << "\n";
	  }
#endif        // CH vs HT format

	  se_i++;
     }

     // write the trigger...  
     // ... but at the end  ( John's request feb11, he will change it ) 
//     char yes_string[5] = "yes";
//     u_i16    le_trig = 0;
//     u_i16    tot_trig = 0;
//     
//     if (Trigger_B_Bit & trigger) {	  
//	  F2000Stream->form("TRIG  amab10  %d	 %d  %s \n",le_trig,tot_trig,yes_string);
//     }
//     if (Trigger_S2_Bit & trigger) {	  
//	  F2000Stream->form("TRIG  spase2  %d	 %d  %s \n",le_trig,tot_trig,yes_string);
//     }
//     if (Trigger_A_Bit & trigger) {	  
//	  F2000Stream->form("TRIG  amaa    %d	 %d  %s \n",le_trig,tot_trig,yes_string);
//     }
//     if (Trigger_AB_Bit & trigger) {	  
//	  F2000Stream->form("TRIG  amaab   %d	 %d  %s \n",le_trig,tot_trig,yes_string);
//     }
//     if (Trigger_ST_Bit & trigger) {    
//	  F2000Stream->form("TRIG  string  %d    %d  %s \n",le_trig,tot_trig,yes_string);
//     }


     // write the trigger...  
     // ... but at the end  ( John's request feb11, he will change it ) 
     char yes_string[5] = "yes";
     
     if (Trigger_B_Bit & trigger) {	  
	  F2000Stream->form("TRIG  amab10  %s    %s  %s \n",s_le_trigger_B,s_tot_trigger_B,yes_string);
     }
     if (Trigger_S2_Bit & trigger) {	  
	  F2000Stream->form("TRIG  spase2  %s    %s  %s \n",s_le_trigger_S2,s_tot_trigger_S2,yes_string);
     }
     if (Trigger_A_Bit & trigger) {	  
	  F2000Stream->form("TRIG  amaa    %s	 %s  %s \n",s_le_trigger_A,s_tot_trigger_A,yes_string);
     }
     if (Trigger_AB_Bit & trigger) {	  
	  F2000Stream->form("TRIG  amaab   %s	 %s  %s \n",s_le_trigger_AB,s_tot_trigger_AB,yes_string);
     }
     if (Trigger_ST_Bit & trigger) {    
	  F2000Stream->form("TRIG  string  %s    %s  %s \n",s_le_trigger_ST,s_tot_trigger_ST,yes_string);
     }
     if (Trigger_Bsc1_Bit & trigger) {    
	  F2000Stream->form("TRIG  Bsc1    %s    %s  %s \n",s_le_trigger_Bsc1,s_tot_trigger_Bsc1,yes_string);
     }
     
     *F2000Stream << "EE\n";
     
     return 0;
}

int Daq98F2000_t::AnalyseDataFinal()
{
     F2000Stream->form("TEND  %d  %d  %f\n",year,day,UTC);
     *F2000Stream << "END\n";
}

