
/*
  $Header: /home/elrond/baikal/src/CVS/daq98/daq98f2000spectrig.C,v 1.2 1999/02/03 03:42:13 steffen Exp $
*/

#include <config.h>
#include "daq98f2000spectrig.h"

Daq98F2000SpecTrigger_t::Daq98F2000SpecTrigger_t(DaqProcessBase *base,
						 int TriggerFlag,
						 output_mode_t o_mode=OUTMODE_MULTIPLE_EVENTS)
     :Daq98F2000_t(base,o_mode){
	  SetTriggerFlag(TriggerFlag);
}

Daq98F2000SpecTrigger_t::Daq98F2000SpecTrigger_t(DaqProcessBase *base,
						 const char *TriggerFlag,
						 output_mode_t o_mode=OUTMODE_MULTIPLE_EVENTS)
     :Daq98F2000_t(base,o_mode){
	  SetTriggerFlag(TriggerFlag);
}

bool Daq98F2000SpecTrigger_t::IsValidTrigger() { return trigger_flag!=0; }
     
int Daq98F2000SpecTrigger_t::SetTriggerFlag(const char *Flag){
     int TriggerFlag=0;
     String FlagStr=Flag;
     if(!fcompare(FlagStr,"amanda-ab")){
	  TriggerFlag=AB_TRIGGER_FLAG;
     } else if(!fcompare(FlagStr,"spase2")){
	  TriggerFlag=SPASEII_TRIGGER_FLAG;
     } else if(!fcompare(FlagStr,"string")){
	  TriggerFlag=STRING_TRIGGER_FLAG;
     } else TriggerFlag=atoi(Flag);
     SetTriggerFlag(TriggerFlag);
     trigger_flag_str=Flag;
     return 0;  
}

int Daq98F2000SpecTrigger_t::SetTriggerFlag(int Flag){
     trigger_flag=Flag;
}

int Daq98F2000SpecTrigger_t::AnalyseDataFinal(){
     if(Parent->IsVerboseLevel(4)){
	  char str[512];
	  if(trigger_flag_str.length()>0){
	       sprintf(str,"Read %ld events with trigger %s",
		       NumTrigger,(const char*) trigger_flag_str);
	  } else {
	       sprintf(str,"Read %ld events with trigger %i",
		       NumTrigger,(const char*) trigger_flag);
	  }
	  LogMsg(str,4,4);
     }
     return 0;
}

int Daq98F2000SpecTrigger_t::__AnalyseData(MuonEventHeader_t &EventHeader, 
					   MuonEventData_p Event){
     if(trigger_flag & Event->Trigger){
	  NumTrigger++;
	  return Daq98F2000_t::__AnalyseData(EventHeader,Event);
     }
     return 0;
}

Daq98AmandaACoinc_t::Daq98AmandaACoinc_t(DaqProcessBase *base,
					 output_mode_t o_mode=OUTMODE_MULTIPLE_EVENTS)
     :Daq98F2000SpecTrigger_t(base,AB_TRIGGER_FLAG,o_mode){}

Daq98Spase2Coinc_t::Daq98Spase2Coinc_t(DaqProcessBase *base,
				       output_mode_t o_mode=OUTMODE_MULTIPLE_EVENTS):
     Daq98F2000SpecTrigger_t(base,SPASEII_TRIGGER_FLAG,o_mode){}


