#if ! defined __DAQ98f2000SPECSTRIG_H__
#define __DAQ98f2000SPECSTRIG_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/daq98f2000spectrig.h,v 1.2 1999/02/03 03:42:13 steffen Exp $
*/

#include <config.h>
#include "globaltypes.h"
#include "event.h"
#include "daq98muoneventana.h"
#include "daq98f2000.h"

/** A class that extract events for certain trigger flags. Output is f2000 */
class Daq98F2000SpecTrigger_t:public Daq98F2000_t{
public:
     /** Constructor */
     Daq98F2000SpecTrigger_t(DaqProcessBase *base,int TriggerFlag,
			     output_mode_t o_mode=OUTMODE_MULTIPLE_EVENTS);
     Daq98F2000SpecTrigger_t(DaqProcessBase *base,const char *TriggerFlag,
			     output_mode_t o_mode=OUTMODE_MULTIPLE_EVENTS);

     bool IsValidTrigger();
     
     /** Sets the trigger flag.
	 @param Flag Trigger flags
	 @return 0 on success, -1 on failure */
     int SetTriggerFlag(const char *Flag);

     int SetTriggerFlag(int Flag);
     /** Called after reading the last event.
	 @return 0 on success and -1 on failure */
     virtual int AnalyseDataFinal();
     
protected:
     /** Analyses data.
       @param EventHeader Muon event header
       @param Event Muon event data
       @return 0 on success and -1 on failure*/ 
     virtual int __AnalyseData(MuonEventHeader_t &EventHeader, MuonEventData_p Event);
protected:
     /** The Triggerflag */
     int trigger_flag;

     /** The trigger flag as string , if initialized with a string*/
     String trigger_flag_str;
     
     /** Number of triggers in file */
     unsigned long int NumTrigger;
     
};     

class Daq98AmandaACoinc_t:public  Daq98F2000SpecTrigger_t{
public:
     Daq98AmandaACoinc_t(DaqProcessBase *base,output_mode_t o_mode=OUTMODE_MULTIPLE_EVENTS);     
};

class Daq98Spase2Coinc_t:public  Daq98F2000SpecTrigger_t{
public:
     Daq98Spase2Coinc_t(DaqProcessBase *base,output_mode_t o_mode=OUTMODE_MULTIPLE_EVENTS);
};


#endif // __DAQ98f2000SPECSTRIG_H__
