/*
  $Header: /home/elrond/baikal/src/CVS/daq98/daq98hwconfig.C,v 1.8 1999/02/03 03:42:14 steffen Exp $
  
  $Log: daq98hwconfig.C,v $
  Revision 1.8  1999/02/03 03:42:14  steffen
  * introduced DaqProcessBase. Classes that only need Error excess can
  now use base

  Revision 1.7  1998/11/23 14:41:22  haase
  -- major changes in event building and histogramming to make it faster
  -- minor class structure changes
  -- sorry for late commit, but cvs at SP is almost impossible!

  Revision 1.6  1998/11/03 06:43:53  daq
  merged pamanda2 and pamanda3 versions

  Revision 1.5  1998/08/10 12:59:24  daq
  configure changes


*/

#include "daq98hwconfig.h"

Daq98HWConfigReader_t::Daq98HWConfigReader_t(DaqProcessBase* parent):
     Daq98RawDataAnalysis_t(parent)
{
     DontNeedConfig=true;
     InFile=0;
     InStream=0;
}

Daq98HWConfigReader_t::~Daq98HWConfigReader_t()
{
     if(InFile!=0) delete [] InFile;
     InFile=0;
     if(InStream!=0) delete InStream;
     InStream=0;
}

int Daq98HWConfigReader_t::ReadCnfFromFile(const char *File)
{
     InStream=new ifstream(File);
     if(!(*InStream)){
	  (*Base::Error)=SYS_ERROR;
	  (*Base::Error)="int Daq98HWConfig_t::Init()";
	  return -1;
     }
     if(HWConfig!=NULL) delete HWConfig;
     HWConfig=new HWConfigAscii_t;
     
     if(HWConfig->ReadFromStream(*InStream)<0){
	  delete HWConfig;
	  HWConfig=0;
	  return -1;
     }
     return 0;
}

