/*
  $Header: /home/elrond/baikal/src/CVS/daq98/daq98muoneventbuilder.C,v 1.15 1999/06/04 12:55:15 wischnew Exp $

  $Log: daq98muoneventbuilder.C,v $
  Revision 1.15  1999/06/04 12:55:15  wischnew
  buffer set to 2MB

  Revision 1.14  1999/04/01 14:58:18  amanda
  Buffer bug fixed

  Revision 1.13  1999/02/10 11:59:51  steffen
  added config flags, sn vmegps output

  Revision 1.12  1999/02/09 16:09:04  steffen
  *** empty log message ***

  Revision 1.11  1999/02/09 15:52:11  steffen
  soory, last second changes

  Revision 1.10  1999/02/08 16:08:01  steffen
  *** empty log message ***

  Revision 1.9  1999/02/03 03:42:14  steffen
  * introduced DaqProcessBase. Classes that only need Error excess can
  now use base

  Revision 1.8  1999/01/29 08:50:04  steffen
  - changes for compilation under egcs
  - install target works now

  Revision 1.7  1998/11/23 14:41:29  haase
  -- major changes in event building and histogramming to make it faster
  -- minor class structure changes
  -- sorry for late commit, but cvs at SP is almost impossible!

  Revision 1.6  1998/11/06 21:58:39  haase
  first commit of heiko only verry minor chages + new text base client

  Revision 1.5  1998/10/29 20:52:54  steffen
  *** empty log message ***

  Revision 1.4  1998/07/31 07:39:39  daq
  * daq98muoneventbuilder.C (__AnalyseData): removed PrintEvent
  function. The output was not compatible with the reader
  philosophie. F2000 output can be used instead

*/

#include "daq98muoneventbuilder.h"
#include "daq98muoneventana.h"

Daq98MuonEventAnalysisVector_t *Daq98MuonEventBuilder_t::MuonEventAnalysisVector=NULL;

Daq98MuonEventBuilder_t::Daq98MuonEventBuilder_t(DaqProcessBase *parent):
     Daq98RawDataAnalysis_t(parent), MEventBuilder(parent),is_valid(false)
{
     EventBuilderNotConfigured=true;
     MuonEventDataBuffer=(void*)new char[1024*2000];
     VME_GPSModuleEvalClass_t::outstream=0;
}


Daq98MuonEventBuilder_t::~Daq98MuonEventBuilder_t()
{
     MuonEventAnalysisVector=NULL;
     delete[] (char*)MuonEventDataBuffer;
}

int Daq98MuonEventBuilder_t::Init()
{
     Daq98MuonEventAnalysisVector_t::iterator AnalysisVector;
     for(AnalysisVector=MuonEventAnalysisVector->begin();
	 AnalysisVector<MuonEventAnalysisVector->end();
	 AnalysisVector++){
	  TEST_FAILURE((*AnalysisVector)->Init());
     }
     TEST_FAILURE(Daq98RawDataAnalysis_t::Init());
     return 0;
}

int Daq98MuonEventBuilder_t::AnalyseDataFinal()
{
     if(Parent->IsVerboseLevel(4)){
	  char str[512];
	  sprintf(str,"Read %d events",EventHeader.EventNumber);
	  LogMsg(str,4,4);
     }
     
     Daq98MuonEventAnalysisVector_t::iterator AnalysisVector;
     for(AnalysisVector=MuonEventAnalysisVector->begin();
	 AnalysisVector<MuonEventAnalysisVector->end();
	 AnalysisVector++){
	  TEST_FAILURE((*AnalysisVector)->AnalyseDataFinal());
     }
     return 0;
}

int Daq98MuonEventBuilder_t::__AnalyseData(RecordHeader_t RecordHeader, 
					   BinaryDataBuffer &Buf)
{
     static Daq98MuonEventAnalysisVector_t::iterator AnalysisVector;
     is_valid=false;
     // quick SN Event hackk
     if(RecordHeader.RecordID!=RID_MUONEVENT  && RecordHeader.RecordID!=RID_SNEVENT)
	  return 0;
     if(EventBuilderNotConfigured){
	  MEventBuilder.SetUpDetectorConfig(*HWConfig);
	  EventBuilderNotConfigured=false;
	  Daq98MuonEventAnalysis_t::HWConfig=HWConfig;
     }
     if(Parent->IsVerboseLevel(8)){
	  if(RecordHeader.RecordID==RID_MUONEVENT) LogMsg("Muon event received",8,8);
	  else LogMsg("Super nova event received",8,8);
     }
     
     if(RecordHeader.RecordID==RID_SNEVENT){
	  ReadRecord(SNEventHeader,Buf);
	  MEventBuilder.BuildGeneralEvent(Buf);
     }else{
	  const MuonEventData_p MuonEvent=(MuonEventData_t*)MuonEventDataBuffer;
	  ReadRecord(EventHeader,Buf);
	  MEventBuilder.BuildEvent_fast(Buf,EventHeader,MuonEvent);
	  if(Parent->IsVerboseLevel(9)){
	       char str[200];
	       sprintf(str,"Event No: %d",EventHeader.EventNumber);
	       LogMsg(str,9,9);
	  }
	  is_valid=true;
	  // call the muon event analyser objects
	  for(AnalysisVector=MuonEventAnalysisVector->begin();
	      AnalysisVector<MuonEventAnalysisVector->end();
	      AnalysisVector++){
	       TEST_FAILURE((*AnalysisVector)->AnalyseData(EventHeader,MuonEvent));
	  }
     }
     
     return 1;
}


void Daq98MuonEventBuilder_t::SetAnalysisVector(Daq98MuonEventAnalysisVector_t *Vector)
{
     MuonEventAnalysisVector=Vector;
}

