#if ! defined __DAQ98MOUNEVENTSORT_H__
#define __DAQ98MOUNEVENTSORT_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/daq98muoneventsort.h,v 1.4 1999/02/03 03:42:14 steffen Exp $
*/

#include <config.h>
#include "globaltypes.h"
#include "event.h"
#include "daq98muoneventana.h"

/** A class that sorts the channels by their ID in one event */
class Daq98MuonEventSort_t:public Daq98MuonEventAnalysis_t{
public:
     /** Constructor */
     Daq98MuonEventSort_t(DaqProcessBase *base):Daq98MuonEventAnalysis_t(base){}
     
protected:
     /** Analyses data.
	 @param EventHeader Muon event header
	 @param Event Muon event data
	 @return 0 on success and -1 on failure*/ 
     virtual int __AnalyseData(MuonEventHeader_t &EventHeader, MuonEventData_p Event){
	  SubEventData_StaticSize_t *SubEvents=Event->SubEvents;
	  int NumberOfChannels=Event->NoOfChannels;
	  struct comp_id{
	       static int comp_id_fn(const void *v1,
				     const void *v2){
		    ID_t ID1=((const SubEventData_StaticSize_t *)v1)->ID;
		    ID_t ID2=((const SubEventData_StaticSize_t *)v2)->ID;
		    return ID1<ID2 ? -1 : (ID1==ID2 ? 0 : 1);
	       }
	  };   
	  qsort(SubEvents,NumberOfChannels,sizeof(SubEventData_StaticSize_t),
		&(comp_id::comp_id_fn));
	  return 0;
     }
};     

#endif //__DAQ98MOUNEVENTSORT_H__
