#if ! defined __DAQ98_RATE_H_
#define  __DAQ98_RATE_H_

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/daq98rate.h,v 1.2 1998/11/23 14:41:35 haase Exp $

  $Log: daq98rate.h,v $
  Revision 1.2  1998/11/23 14:41:35  haase
  -- major changes in event building and histogramming to make it faster
  -- minor class structure changes
  -- sorry for late commit, but cvs at SP is almost impossible!

  Revision 1.1  1998/11/03 06:46:58  daq
  *** empty log message ***

*/

#include <config.h>
#include "globaltypes.h"

/** Class for data and event rate calculation based on actual evetn times */
class Daq98Rate_t
{
public:
     Daq98Rate_t()
	  {
	       bytes_last=0;
	       event_num_last=0;
	  };
     inline void Calc(time_t time_diff, u_i32 event_num);
     inline void SetCurrent(const unsigned long long bytes_current);
     
private:
     /** Current number of bytes read */
     unsigned long long bytes_current;

     /** Last number of bytes read */
     unsigned long long bytes_last;
     
     /** Last event number */
     u_i32 event_num_last;

     /** Time between rate calculations */
     unsigned int rate_time;
};


void Daq98Rate_t::SetCurrent(const unsigned long long bytes)
{
     bytes_current=bytes;
}

void Daq98Rate_t::Calc(time_t time_diff, u_i32 event_num)
{
     float event_rate;
     float data_rate;
     cerr << "diff="<<time_diff<<" bl=" << bytes_last
	  << " bc=" << bytes_current << endl;
     data_rate=(bytes_current - bytes_last)/float(time_diff)/1024.0;
     bytes_last=bytes_current;
     event_rate=(event_num - event_num_last)/float(time_diff);
     event_num_last=event_num;
     
     cerr << data_rate << " kB/sec\t" << event_rate << " events/sec\n";
}


#endif //  __DAQ98_RATE_H_
