#if ! defined __DAQ98RUNTIME_H__
#define __DAQ98RUNTIME_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/daq98runtime.h,v 1.6 1999/02/03 03:42:15 steffen Exp $
*/

#include <config.h>
#include "globaltypes.h"
#include "event.h"
#include "daq98muoneventana.h"
#include "daq98rate.h"

/** A class that analyses muon event data and does a lot of histogramming */
class Daq98RunTime_t:public Daq98MuonEventAnalysis_t 
{
public:
     /** Constructor */
     Daq98RunTime_t(DaqProcessBase *base);
     
     /** Destructor */
     ~Daq98RunTime_t();

     /** Called after reading the last event.
	 This function saves all histograms that we have in
	 memory in an hbook file.
	 @return 0 on success and -1 on failure */
     virtual int AnalyseDataFinal();

     /** Set object for calculating data and event rates */
     void SetRate(Daq98Rate_t *r);
     
protected:
     /** Analyses data.
       @param EventHeader Muon event header
       @param Event Muon event data
       @return 0 on success and -1 on failure*/ 
     virtual int __AnalyseData(MuonEventHeader_t &EventHeader, MuonEventData_p Event);

private:
     time_t UnixStartTime;
     time_t UnixEndTime;
     GPSTime_t GPSStartTime0;
     GPSTime_t GPSStartTime1;
     GPSTime_t GPSEndTime0;
     GPSTime_t GPSEndTime1;
     /** Object for data and event rate calculation*/
     Daq98Rate_t *rate;
};     
#endif // __DAQ98RUNTIME_H__
