# -* perl *-

####################
#
# Print usage message
#
sub Usage(){
    print <<"EOF";
Usage:
% daq_killshm [OPTION]

Options:
  --help     Print this message
  --version  Print version information

Send bug reports to <steffen\@alizarin.physics.wisc.edu>
EOF
    exit(1);
}

####################
#
# Print version info
#
sub Version(){
    no strict;
    print <<"EOF";
daq_killshm ($PACKAGE) $VERSION - Kill shared memory allocated by the AMANDA DAQ 

Copyright (C) 1998 Steffen Richter <steffen\@alizarin.physics.wisc.edu>
This is free software; the author gives unlimited permission to copy 
and/or distribute it, with or without modifications, as long as this 
notice is preserved.
This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

EOF
    use strict;
    exit(1);
}

####################
#
# Print invalid usage message
#
sub Invalid(){
    print "Invalid usage. For help:\n";
    print "% daq_killshm --help\n";
    exit(1);
}


if($#ARGV==0){
    do Version() if ($ARGV[0] eq "--version");
    do Usage() if ($ARGV[0] eq "--help");
    do Invalid();
}

open(INFILE,"ipcs |") || die "Can't run 'ipcs':$!\n";

while(<INFILE>){
    if(/Shared/){
	$Shm=1;
	$Sem=0
    }elsif(/Semaphore/){
	$Sem=1;
	$Shm=0;
    }elsif(/[0-9]+/){
	($ID1,$ID2)=split /[ \t]/;
	if($Shm==1){
	  if($ID1 =~ /x/){
	    system("ipcrm shm $ID2");
	  }else{
	    system("ipcrm shm $ID1");
	  }
	}elsif($Sem==1){ 
	  if($ID1 =~ /x/){
	    system("ipcrm sem $ID2");
	  }else{
	    system("ipcrm sem $ID1");
	  }
	}
    }
}	    
