/*
$Header: /home/elrond/baikal/src/CVS/daq98/daqdebug.C,v 1.2 1998/11/23 14:41:49 haase Exp $
*/

#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <iostream.h>
#include <fstream.h>

#include "daqdebug.h"

int gv_DebugLevel=DL_MESSAGES;

Debugger DebugStreamer;

Debugger::Debugger(ostream &DebOut=cerr){
     DebugOut=&DebOut;
     FunctionDepth=0;
     Null=new ofstream("/dev/null");
}

Debugger::~Debugger(){
     delete Null;
}

void Debugger::SetOutput(ostream *DebOut){
     DebugOut=DebOut;
}

void Debugger::SetOutput(ofstream *DebOut){
     DebugOut=(ostream*)DebOut;
}

ostream &Debugger::operator()(){
     return *DebugOut;
}

void Debugger::EnterFunction(char *Name,char *file,int line) {
     if(file)
	  sprintf(CallStack[FunctionDepth++],"%s in file %s:%i",Name,file,line);
     else
	  sprintf(CallStack[FunctionDepth++],"%s",Name);
     char spaces[200]="";
     for (int i=0;i<FunctionDepth;i++) 
	  strcat(spaces,"  ");
     if(((gv_DebugLevel)&(DL_FUNCTIONS_E))!=0){
	  (*DebugOut)<< getpid() << "\t"
		     << "-> " 
		     << spaces
		     << Name 
		     << " " 
		     << FunctionDepth << endl << flush;
     }
}

void Debugger::QuitFunction(char *Name){
     char spaces[200]="";
     for (int i=0;i<FunctionDepth;i++) 
	  strcat(spaces,"  ");
     if(((gv_DebugLevel)&(DL_FUNCTIONS_Q))!=0){
	  (*DebugOut)<< getpid() << "\t"
		     << "<- " 
		     << spaces
		     << Name 
		     << " "<< FunctionDepth << endl << flush;
     }
     FunctionDepth--;
}

void Debugger::PrintCallStack(){
     for(int i=0;i<FunctionDepth;i++){
	  char spaces[200]="-> ";
	  for (int j=0;j<i;j++) 
	       strcat(spaces," ");
	  (*DebugOut)<< getpid() << "\t"
		     << spaces
		     << CallStack[i]
		     << " "<< i << endl << flush;
     }
}

ostream &Debugger::Message()     {
     if(((gv_DebugLevel)&(DL_MESSAGES))!=0){
	  return *DebugOut;
     }
     return *Null;
}

char *Quote(char *a){
     static char helper[200];
     char *s=helper;
     while(*a){
	  switch(*a){
	  case '\n': *s='\\' ; s++; *s='n'; break;
	  case '\r': *s='\\' ; s++; *s='r'; break;
	  case '\t': *s='\\' ; s++; *s='t'; break;
	  default: *s=*a;
	  }
	  s++;
	  a++;
     }
     *s=0;
     return helper;
}

DebugFunction::DebugFunction(char *name,char *file=0,int line=0){
     Name=name;
     DebugStreamer.EnterFunction(Name,file,line);
}

DebugFunction::~DebugFunction(){
     DebugStreamer.QuitFunction(Name);
}
