/*
$Header: /home/elrond/baikal/src/CVS/daq98/daqdebug.h,v 1.3 1998/11/23 14:41:49 haase Exp $
*/

#if ! defined __DEBUG_H__
#define __DEBUG_H__

#include <config.h>
#include <iostream.h>
#include <fstream.h>
#include "base.h"

#define DL_FUNCTIONS_E 1
#define DL_FUNCTIONS_Q 2
#define DL_FUNCTIONS DL_FUNCTIONS_Q | DL_FUNCTIONS_E 
#define DL_MESSAGES 4
#define DL_CALLSTACK 8

extern int gv_DebugLevel;

// #if ! defined DEBUG_LEVEL
// #define DEBUG_LEVEL DL_MESSAGES
// #endif

#define FUNCTION_POS

class Debugger:public Base
{
public:
     Debugger(ostream &DebOut=cerr);
     virtual ~Debugger();
     void SetOutput(ostream *DebOut);
     void SetOutput(ofstream *DebOut);
     ostream &operator()();
     void EnterFunction(char *Name,char *file,int line);
     void QuitFunction(char *Name);
     void PrintCallStack();
     ostream &Message();
private:
     ostream *DebugOut;
     ostream *Null;
     char CallStack[150][100];
     int FunctionDepth;
};

extern Debugger DebugStreamer;

class DebugFunction:public Base
{
public:
     DebugFunction(char *name,char *file=0,int line=0);
     ~DebugFunction();
private:
     char *Name;
};

char *Quote(char *a);

#define PRINT_FILE_INFO 
#endif //__DEBUG_H__

#ifdef DEB_M
# undef DEB_M
#endif


#ifdef DEB_F
# undef DEB_F
#endif

#ifdef ASSERTION_FAILED
# undef ASSERTION_FAILED
#endif

#ifdef DEBUG
       
#define DEB_M(a) DebugStreamer.Message() << getpid() << "\t" a << endl << flush;

#ifdef FUNCTION_POS
#define DEB_F(n)DebugFunction __DebugFunctionInstanz__(n,__FILE__,__LINE__); 
#else
#define DEB_F(n) DebugFunction __DebugFunctionInstanz__(n); 
#endif

#define ASSERTION_FAILED { DebugStreamer.PrintCallStack(); cerr << "press RET" << endl; cin.get(); }

#else // DEBUG

#define DEB_M(a)
#define DEB_F(n)
#define ASSERTION_FAILED

#endif // DEBUG

#ifdef DEBUG_MSG

# ifdef DEBUG_MESSAGE
#  undef DEBUG_MESSAGE
# endif

# define DEBUG_MESSAGE(a) DebugStreamer() a << flush;

#else 

# ifdef DEBUG_MESSAGE
#  undef DEBUG_MESSAGE
# endif

# define DEBUG_MESSAGE(a)

#endif     





