/*
$Header: /home/elrond/baikal/src/CVS/daq98/daqprocessbase.C,v 1.1 1999/02/03 03:42:15 steffen Exp $
*/

#include <unistd.h>
#include "daqprocessbase.h"
#include "process.h"
#include "error.h"
#include "configsection2.h"
#include "globalmacros.h"

DaqProcessBase::DaqProcessBase()
{
     // some defaults
     DispatcherAddress.Hostname=DEFAULT_DISPATCHER_HOST;
     DispatcherAddress.Port=DEFAULT_DISPATCHER_PORT;
     VerboseLevelFile=2;
     VerboseLevelConsole=2;
     Mail=0;
     WarningIntervall=600;
     ErrorIntervall=300;
     MailRecipients="";
     Wall=0;
     WallHosts="";
     SecureLogin=1;
}

DaqProcessBase::~DaqProcessBase()
{
}

void DaqProcessBase::InitializeGlobals(char *Appname){
     Quit_FLAG=false;
     static SignalHandlerClass SH;
//     DefaultSignalHandler=&SH;
     (*ThisProcess).SetSignalHandler(SH);
     (*ThisProcess).SetName(Appname);
     char hn[200];
     gethostname(hn,200);
     LocalHostname=hn;
}

ClassWithTypeInfo_t *DaqProcessBase::GetCommonConfigSection(){
     return new class CommonConfigSection:public ConfigSection_t{
     public:
	  /** ctor */
	  CommonConfigSection(IPAddress_t &DispatcherAddress, 
			      int &VerboseLevelFile, 
			      int &VerboseLevelConsole,
			      int &Mail,
			      int &ErrorIntervall,
			      int &WarningIntervall,
			      String &MailRecipients,
			      int &Wall,
			      String &WallHosts,
			      int &SecureLogin)
	       :ConfigSection_t(),
		DispatcherAddress_cnf(DispatcherAddress),
		VerboseLevelFile_cnf(VerboseLevelFile),
		VerboseLevelConsole_cnf(VerboseLevelConsole),
		Mail_cnf(Mail),
		ErrorIntervall_cnf(ErrorIntervall),
		WarningIntervall_cnf(WarningIntervall),
		MailRecipients_cnf(MailRecipients),
		Wall_cnf(Wall),
		WallHosts_cnf(WallHosts),
		SecureLogin_cnf(SecureLogin){}
	  BeginItems(ConfigSection_t){
	       BeginLinks{
		    ItemLink2("DispatcherAddress",
			     DispatcherAddress_cnf.Hostname,
			     DispatcherAddress_cnf.Port);
		    ItemLink1("VerboseLevelFile",VerboseLevelFile_cnf);
		    ItemLink1("VerboseLevelConsole",VerboseLevelConsole_cnf);
		    ItemLink1("Mail",(ON_OFF_t&)Mail_cnf);
		    ItemLink1("ErrorIntervall",ErrorIntervall_cnf);
		    ItemLink1("WarningIntervall",WarningIntervall_cnf);
		    ItemLink1("MailRecipients",MailRecipients_cnf);
		    ItemLink1("Wall",(ON_OFF_t&)Wall_cnf);
		    ItemLink1("WallHosts",WallHosts_cnf);
		    ItemLink1("SecureLogin",(ON_OFF_t&)SecureLogin_cnf);
	       }EndLinks;
	  }EndItems(ConfigSection_t);
	  SectionName(COMMON_SECTION_NAME);

     private:
	  IPAddress_t &DispatcherAddress_cnf;
	  int &VerboseLevelFile_cnf;
	  int &VerboseLevelConsole_cnf;
	  int &Mail_cnf;
	  int &ErrorIntervall_cnf;
	  int &WarningIntervall_cnf;
	  String &MailRecipients_cnf;
	  int &Wall_cnf;
	  String &WallHosts_cnf;
	  int &SecureLogin_cnf;
     }(DispatcherAddress,VerboseLevelFile,VerboseLevelConsole,Mail,
       ErrorIntervall,WarningIntervall,MailRecipients,Wall,WallHosts,SecureLogin);
}

void DaqProcessBase::LogMsg(const char *Msg, int LogFileLevel=10,
		  int LogConsoleLevel=10, LogType_t Type=INFO)
{
     if(!LogFileLevel) LogFileLevel=1;
     if(!LogConsoleLevel) LogConsoleLevel=1;
     
     if(LogFileLevel<=VerboseLevelFile){
	  cerr << "Warning: No log file open\n";
     }
     if(LogConsoleLevel<=VerboseLevelConsole){
	  if(Type==ERROR)
	       cerr << "***Error***: ";
	  else if(Type==WARNING)
	       cerr << "Warning: ";
	       
	  cerr << (const char*)Msg << endl;
     }
}

void DaqProcessBase::SetVerboseLevel(int FileLevel, int ConsoleLevel){
     VerboseLevelFile=FileLevel;
     VerboseLevelConsole=ConsoleLevel;
}

int DaqProcessBase::GetFileVerboseLevel(){
     return VerboseLevelFile;
}
     
int DaqProcessBase::GetConsoleVerboseLevel(){
     return VerboseLevelConsole;
}

volatile bool DaqProcessBase::Quit_FLAG;
ErrorClass_t E;
Process P;
Process *const DaqProcessBase::ThisProcess=&P;
IPAddress_t DaqProcessBase::DispatcherAddress;
String DaqProcessBase::LocalHostname;
