/*
$Header: /home/elrond/baikal/src/CVS/daq98/datatypes.h,v 1.3 1998/11/23 14:42:09 haase Exp $
*/

# if ! defined __DATATYPES_H__
#define __DATATYPES_H__
#include <config.h>
#include <string.h>

class DataBin
{
public:
     inline DataBin():len(0),size(0),buf(0){}
     inline DataBin(size_t l):len(l),size(l){
	  buf=new char[size];
     }
     inline ~DataBin(){RemoveBuffer();}
     inline void RemoveBuffer(){if(buf!=NULL) delete[] buf;}
     inline void *Buffer()const{return buf;}
     inline const DataBin &operator=(const DataBin &D){
	  len=D.len;
	  if (len>size){
	       RemoveBuffer();
	       buf=new char[len];
	       size=len;
	  }
	  memcpy(buf,D.Buffer(),len);	       
	  return D;
     }
     inline operator const void*() const{return buf;}     
     inline void Resize(const size_t l){
	  if(l<size){
	       len=l;
	       return;
	  }
	  size=l;
	  len=l;
	  RemoveBuffer();
	  buf=new char[size];
     }
     inline void SetSize(const size_t s){len=s;}       
     inline const unsigned int Size() const{return len;}
     inline const unsigned int MaxSize() const{return size;}
private:
     size_t len;
     size_t size;
     char *buf;
};



// typedef DataBin Message;     

#endif // __DATATYPES_H__


