#if ! defined __DISCMODULE_H__
#define __DISCMODULE_H__

/* 
   $Header: /home/elrond/baikal/src/CVS/daq98/discmodule.h,v 1.5 1999/02/05 18:35:04 steffen Exp $

   $Log: discmodule.h,v $
   Revision 1.5  1999/02/05 18:35:04  steffen
   * Major cleanup:
     - threw out code for binary config records
     - cleaned up some module classes
   * Fixed bug which prevent 32 bit values to be read correctly from
     detector cnf
   * Added masking to s7201 module

*/

#include <config.h>
#include "channelmodule.h"

/*---------------------------------------------------------*/
/*                                                         */
/*  Discriminator module configuration data structure      */
/*                                                         */
/*---------------------------------------------------------*/

/** Configuration data structure for discriminator modules */
struct DISCModuleConfigRecord_t:public ChannelModuleConfigRecord_t
{
     ClassTypeInfo(ChannelModuleConfigRecord_t);

     /** Constructor */
     DISCModuleConfigRecord_t();
     
     /** Destructor */
     virtual ~DISCModuleConfigRecord_t();
     
     /** Threshold value */
     u_i16 Threshold;
};

MAKE_REFCOUNT_POINTER(DISCModuleConfigRecord_t,DISCModuleConfigRecord_p);


/*---------------------------------------------------------*/
/*                                                         */
/*  Discriminator module base class                        */
/*                                                         */
/*---------------------------------------------------------*/

/** Base class for discriminator module classes */
class DISCModuleClass_t: public ChannelModuleBaseClass_t
{
     ClassTypeInfo(ChannelModuleBaseClass_t);
public:
     /** Constructor.
	 @param numChannels Number of channels of this module
	 @param BytesPerInfoUnit Number of bytes per info unit (bytes per channel)
	 @param parent Pointer to parent class. Used for sending messages in Parent context. */
     DISCModuleClass_t(int numChannels,
		       int BytesPerInfoUnit, 
		       DaqProcessBase *parent);
};

MAKE_REFCOUNT_POINTER(DISCModuleClass_t, DISCModuleClass_p);

#endif // __DISCMODULE_H__
