#if ! defined __DISCMODULEEVAL_H__
#define __DISCMODULEEVAL_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/discmoduleeval.h,v 1.7 1999/02/05 18:35:04 steffen Exp $
*/

#include <config.h>
#include "genericmoduleevalbase.h"

class DISCModuleEvalClass_t: public GenericModuleEvalBaseClass_t
{
     ClassTypeInfo(GenericModuleEvalBaseClass_t);
public:
     inline DISCModuleEvalClass_t(int numChannels,int bytesPerInfoUnit, DaqProcessBase *Parent)
	  :GenericModuleEvalBaseClass_t(numChannels,bytesPerInfoUnit,Parent){}
     
     virtual void Configure(ChannelModuleConfigRecord_p &ModuleConfig,
			    HWConfig_t &HWConfig){
	  SetTag(ModuleConfig->BinaryTag);
	  ChannelConfigRecordVector_t::iterator chcr_i;
	  for(chcr_i=HWConfig.ChannelConfigRecordVector->begin();
	      chcr_i<HWConfig.ChannelConfigRecordVector->end();
	      chcr_i++){
	       if(strcasecmp(ModuleConfig->ModuleID,(*chcr_i)->TDC_Id)==0){
		    // we found a channel, that is connected to the current module
		    // insert it in our vector
		    SetChannelMapping((*chcr_i)->TDC_Channel,(*chcr_i)->ID);
	       }
	  }
     }

     virtual int BuildEventPart(BinaryDataBuffer &RawDataBuffer, TempDecode_EventData_t *){
	  const void *ModuleData;
	  int NumReads;
	  u_i16 NumBytes;
	  int CurDISCChannel;
	  s_i32 CurOMChannel;
//	  SubEventData_StaticSize_t *CurSubEvent;
	  
	  RawDataBuffer.ReadFromBuffer(NumBytes);
	  NumReads=NumBytes/BytesPerInfoUnit;

	  for(int i=0;i<NumReads;i++) {
	       ModuleData=ReadFromBuffer(RawDataBuffer);
	       // get the hit channel
	       CurDISCChannel=Channel(ModuleData);
	       if((CurOMChannel=GetChannelMapping(CurDISCChannel))<0){
		    // error handling, couldn't map channel
		    char txt[1000];
		    sprintf(txt,"Can't map DISC with tag %i channel %i to OM channel",GetTag(),CurDISCChannel);
		    LogMsg(txt,2,2,WARNING);
		    continue;
	       }
	  }
	  return 0;
     }
protected:
     virtual inline int Channel(const void *disc_data)=0;
     virtual inline int Threshold(const void *disc_data)=0;
     virtual inline int Local(const void *disc_data)=0;
};

#endif // __DISCMODULEEVAL_H__
