#if ! defined __DUMMYDISCMODULE_H__
#define __DUMMYDISCMODULE_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/dummydiscmodule.h,v 1.4 1999/02/03 03:42:17 steffen Exp $
*/

#include <config.h>
#include "discmodule.h"

class Dummy_DISCModule_t:public DISCModuleClass_t
{
     ClassTypeInfo(DISCModuleClass_t);
     enum 
     { 
	  NUMBER_OF_CHANNELS =16,
	  BYTES_PER_INFO_UNIT=4
     };
public:
     /** Constructor */
     Dummy_DISCModule_t(DaqProcessBase *Parent);/***/

     /** Destructor */
     ~Dummy_DISCModule_t();
     
     /** Checks if module has any data.
	 @return true, if the module has data or false if the module
         does not have any data */
     virtual bool HasModuleData();

     /** Reads data from module into data buffer.
	 This function reads out the entire module and saves the raw data
         at the current position into the buffers, which is given as
         the paramter.
	 @param DataBuffer Binary data buffer
	 @return 0 on success and -1 on failure.*/
     virtual int ReadToBuffer(BinaryDataBuffer &DataBuffer);
     
     /** Initializes the module.
       Do whatever you need to do to get the module working.
       @param errors Vector of errors that may occur during initialization.
       @return 0 on success. Negative number of errors occured during 
       initialization on failure.*/
     virtual int InitModule(StringVector_t &errors);

     /** Resets the module 
       @param errors Vector of errors that may occur during initialization.
       @return 0 on success. Negative number of errors occured during 
       initialization on failure.*/
     virtual int ResetModule(StringVector_t &errors);
};


#endif // __DUMMYDISCMODULE_H__
