/*
  $Header: /home/elrond/baikal/src/CVS/daq98/dummygpsmodule.C,v 1.1 1999/02/05 18:35:05 steffen Exp $

  $Log: dummygpsmodule.C,v $
  Revision 1.1  1999/02/05 18:35:05  steffen
  * Major cleanup:
    - threw out code for binary config records
    - cleaned up some module classes
  * Fixed bug which prevent 32 bit values to be read correctly from
    detector cnf
  * Added masking to s7201 module

*/

#include "dummygpsmodule.h"
#include <time.h>
/*---------------------------------------------------------*/
/*                                                         */
/*  Dummy GPS module base class                            */
/*  Member function definition                             */
/*                                                         */
/*---------------------------------------------------------*/
DummyGPSModuleClass_t::DummyGPSModuleClass_t(DaqProcessBase *parent)
     :GPSModuleClass_t(NUMBER_OF_CHANNELS,BYTES_PER_INFO_UNIT,parent){
}

DummyGPSModuleClass_t::~DummyGPSModuleClass_t(){
}

int DummyGPSModuleClass_t::InitModule(StringVector_t &/*errors*/){
     return 0;
}
     
int DummyGPSModuleClass_t::ReadToBuffer(BinaryDataBuffer &DataBuffer){
     u_i16 NumWords=0;

     // write the binary tag
     DataBuffer.WriteToBuffer(GetModuleConfig()->BinaryTag);

     // save the position where we have to store the number of hits 
     DataBuffer.PushPosition();
     // Write a zero size first
     DataBuffer.WriteToBuffer(NumWords); 
     // write the data words
     
     time_t Time=time(NULL);
     struct tm UnixTime;
     UnixTime= *gmtime(&Time);
     DataBuffer.WriteToBuffer((u_i8)0);
     DataBuffer.WriteToBuffer((u_i8)0);
     DataBuffer.WriteToBuffer((u_i8)0);
	  
     u_i8 WriteByte;
     WriteByte=(UnixTime.tm_sec/10) << 4 | (UnixTime.tm_sec%10);
     DataBuffer.WriteToBuffer(WriteByte);
     WriteByte=(UnixTime.tm_min/10) << 4 | (UnixTime.tm_min%10);
     DataBuffer.WriteToBuffer(WriteByte);
     WriteByte=(UnixTime.tm_hour/10) << 4 | (UnixTime.tm_hour%10);
     DataBuffer.WriteToBuffer(WriteByte);

     WriteByte=((UnixTime.tm_yday-UnixTime.tm_yday/100)/10) << 4 | 
	  ((UnixTime.tm_yday-UnixTime.tm_yday/100)%10);
     DataBuffer.WriteToBuffer(WriteByte);
     WriteByte=UnixTime.tm_yday/100;
     DataBuffer.WriteToBuffer(WriteByte);
     DataBuffer.WriteToBuffer((u_i8)0x0f);
     NumWords+=1;

     // set the position to the place where we have to write the size 
     DataBuffer.PopPosition();
     u_i16 NumBytes=NumWords*GetBytesPerInfoUnit();
     // write the size
     DataBuffer.WriteToBuffer(NumBytes);
     // restore the old position
     DataBuffer.IncPosition(NumBytes);
     return 0;
}
