#ifndef __DUMMYGPSMODULE_H__
#define __DUMMYGPSMODULE_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/dummygpsmodule.h,v 1.1 1999/02/05 18:35:05 steffen Exp $

  $Log: dummygpsmodule.h,v $
  Revision 1.1  1999/02/05 18:35:05  steffen
  * Major cleanup:
    - threw out code for binary config records
    - cleaned up some module classes
  * Fixed bug which prevent 32 bit values to be read correctly from
    detector cnf
  * Added masking to s7201 module

*/

#include "gpsmodule.h"

/*---------------------------------------------------------*/
/*                                                         */
/*  Dummy GPS module class                                 */
/*                                                         */
/*---------------------------------------------------------*/

/** Dummy GPS module class.
    This class emulated the data of the old style University of Wisconsin
    CAMAC GPS modules using UNIX time. */
class DummyGPSModuleClass_t: public GPSModuleClass_t
{
     enum 
     { 
	  NUMBER_OF_CHANNELS =1,
	  BYTES_PER_INFO_UNIT=9
     };
     ClassTypeInfo(GPSModuleClass_t);
public:
     /** Constructor.
	 @param parent Pointer to parent class. Used for sending messages in Parent context. */
     DummyGPSModuleClass_t(DaqProcessBase *parent);
     
     /** Destructor */
     virtual ~DummyGPSModuleClass_t();

     /** Check for data
      @return {\it true} if module has data, {\it false} otherwise */
     inline virtual bool HasModuleData();
     
     /** Initialize the module
      @param  errors Reference to a vector of error strings. 
      If an error occures, the function can add a descriptive messages.
      @return 0 on success, -1 on failure */
     virtual int InitModule(StringVector_t &errors);

     /** Reset the module
	 @param  errors Reference to a vector of error strings. 
	 If an error occures, the function can add a descriptive messages.
	 @return 0 on success, -1 on failure */
     inline virtual int ResetModule(StringVector_t &errors);

     /** Read the module data and write to the data buffer
	 @param DataBuffer Reference to the data buffer
	 @return 0 on success, -1 on failure */
     virtual int ReadToBuffer(BinaryDataBuffer &DataBuffer);     
};


/*---------------------------------------------------------*/
/*                                                         */
/*  Dummy GPS module base class                            */
/*  Inline member function definition                      */
/*                                                         */
/*---------------------------------------------------------*/
inline bool DummyGPSModuleClass_t::HasModuleData()
{
     return true;
}

inline int DummyGPSModuleClass_t::ResetModule(StringVector_t &/*errors*/){
     return 0;
}

#endif //__DUMMYGPSMODULE_H__
