/*
  $Header: /home/elrond/baikal/src/CVS/daq98/dummyrndadcmodule.C,v 1.3 1999/02/03 03:42:17 steffen Exp $
*/

#include "dummyrndadcmodule.h"


RNDDummy_ADCModule_t::RNDDummy_ADCModule_t(DaqProcessBase *parent):
     ADCModuleClass_t(NUMBER_OF_CHANNELS,BYTES_PER_INFO_UNIT,parent)
{
}
  
RNDDummy_ADCModule_t::~RNDDummy_ADCModule_t(){
}      

bool RNDDummy_ADCModule_t::HasModuleData(){
     return  GetModuleConfig()->Enabled&&(rand()%100<10); // only 10% of the module have data
}

int RNDDummy_ADCModule_t::ReadToBuffer(BinaryDataBuffer &DataBuffer)
{
     DEBUG_MESSAGE( << "Module " << GetModuleID() << " read" << endl);
	  
     // for the number of 32Bit words read from the TDC
     u_i16 NumWords=0;
     u_i32 adcdata;
     /* buffer readout */
     
     // first there must be the tag for the module in the bytestream
     DataBuffer.WriteToBuffer(GetModuleConfig()->BinaryTag);

     // save the position where we have to store the number of hits 
     DataBuffer.PushPosition();
     // Write a zero size first
     DataBuffer.WriteToBuffer(NumWords); 
     for (u_i32 i=0;i<16;i++){
	  if(IsChannelInUse(i)){
	       if(IsChannelOn(i)){
		    adcdata= (((rand()%4096)&0xFFFF)| // Amplitude
			      ((i<<16)&0xFFFF0000)); // channel
		    DataBuffer.WriteToBuffer(adcdata);
		    NumWords++;
	       }
	  }
     }
     // set the position to the place where we have to write the size 
     DataBuffer.PopPosition();
     u_i16 NumBytes=NumWords*GetBytesPerInfoUnit();
     // write the size
     DataBuffer.WriteToBuffer(NumBytes);
     // restore the old position
     DataBuffer.IncPosition(NumBytes);
     return 0;
}


int RNDDummy_ADCModule_t::InitModule(StringVector_t &/*errors*/){
     DEBUG_MESSAGE( << "Module " << GetModuleID() << " initilized" << endl);
     return 0;
}

int RNDDummy_ADCModule_t::ResetModule(StringVector_t &/*errors*/)
{
     return 0;
}

