/*
  $Heder$
*/

#include "dummyrndtdcmodule.h"


RNDDummy_TDCModule_t::RNDDummy_TDCModule_t(DaqProcessBase *parent):
     TDCModuleClass_t(NUMBER_OF_CHANNELS,BYTES_PER_INFO_UNIT,parent)
{
}

RNDDummy_TDCModule_t::~RNDDummy_TDCModule_t(){
}      

bool RNDDummy_TDCModule_t::HasModuleData(){
     return GetModuleConfig()->Enabled&&(rand()%100<10);  // only 10% percent
}

int RNDDummy_TDCModule_t::ReadToBuffer(BinaryDataBuffer &DataBuffer)
{
     DEBUG_MESSAGE( << "Module " << GetModuleID() << " read to buffer" << endl);
     DEBUG_MESSAGE( << "Module " << GetModuleID() << " read" << endl);
	  
     // for the number of 32Bit words read from the TDC
     u_i16 NumWords=0;
     u_i32 tdcdata;
     /* buffer readout */
     
     // first there must be the tag for the module in the bytestream
     DataBuffer.WriteToBuffer(GetModuleConfig()->BinaryTag);
     // save the position where we have to store the number of hits 
     DataBuffer.PushPosition();
     // Write a zero size first
     DataBuffer.WriteToBuffer(NumWords); 
     for (u_i32 i=0;i<16;i++){
//	  cerr << "\nTDC " << i;
	  if(IsChannelInUse(i)){
	       if(IsChannelOn(i)){
		    unsigned timevalmax=rand()%16+1; // 1-16 hits per channel
//		    cerr << " " << timevalmax;
		    int lasttime=0;
		    for(u_i32 timeval=0;timeval<timevalmax;timeval++){
			 lasttime+=rand()%4096;
			 //		 cerr << " lt" << lasttime;
			 
			 tdcdata= 
			      ((lasttime)&       0x0000FFFF)| //lowest 2 bytes -> time value
			      ((i<<16)&          0x00FF0000)| //3. bytes -> channel 
			      (((timeval%2)<<31)&0xFF000000); // highest bit -> edge
			 DataBuffer.WriteToBuffer(tdcdata);
			 NumWords++;
			 
		    }
	       }
	  }
     }
     // set the position to the place where we have to write the size 
     DataBuffer.PopPosition();
     u_i16 NumBytes=NumWords*GetBytesPerInfoUnit();
     // write the size
     DataBuffer.WriteToBuffer(NumBytes);
     // restore the old position
     DataBuffer.IncPosition(NumBytes);
     return 0;
}


int RNDDummy_TDCModule_t::InitModule(StringVector_t &/*errors*/){
     DEBUG_MESSAGE( << "Module " << GetModuleID() << " initilized" << endl);
     return 0;
}

int RNDDummy_TDCModule_t::ResetModule(StringVector_t &/*errors*/)
{
     return 0;
}

