#include "dummytdcmodule.h"

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/dummytdcmodule.C,v 1.3 1999/02/03 03:42:17 steffen Exp $
*/

Dummy_TDCModule_t::Dummy_TDCModule_t(DaqProcessBase *parent):
     TDCModuleClass_t(NUMBER_OF_CHANNELS,BYTES_PER_INFO_UNIT,parent)
{
}

Dummy_TDCModule_t::~Dummy_TDCModule_t(){
}      

bool Dummy_TDCModule_t::HasModuleData(){
     return  GetModuleConfig()->Enabled;
}

int Dummy_TDCModule_t::ReadToBuffer(BinaryDataBuffer &DataBuffer)
{
     DEBUG_MESSAGE( << "Module " << GetModuleID() << " read to buffer" << endl);
     DEBUG_MESSAGE( << "Module " << GetModuleID() << " read" << endl);
	  
     // for the number of 32Bit words read from the TDC
     u_i16 NumWords=0;
     u_i32 tdcdata;
     /* buffer readout */
     
     // first there must be the tag for the module in the bytestream
     DataBuffer.WriteToBuffer(GetModuleConfig()->BinaryTag);
     // save the position where we have to store the number of hits 
     DataBuffer.PushPosition();
     // Write a zero size first
     DataBuffer.WriteToBuffer(NumWords); 
     for (u_i32 i=0;i<16;i++){
	  if(IsChannelInUse(i)){
	       if(IsChannelOn(i)){
		    for(u_i32 timeval=0;timeval<2;timeval++){
			 tdcdata= 
			      ((timeval*20)&     0x0000FFFF)| //lowest 2 bytes -> time value
			      ((i<<16)&          0x00FF0000)| //3. bytes -> channel 
			      (((timeval%2)<<31)&0xFF000000); // highest bit -> edge
			 DataBuffer.WriteToBuffer(tdcdata);
			 NumWords++;
		    }
	       }
	  }
     }
     // set the position to the place where we have to write the size 
     DataBuffer.PopPosition();
     u_i16 NumBytes=NumWords*GetBytesPerInfoUnit();
     // write the size
     DataBuffer.WriteToBuffer(NumBytes);
     // restore the old position
     DataBuffer.IncPosition(NumBytes);
     return 0;
}


int Dummy_TDCModule_t::InitModule(StringVector_t &/*errors*/){
     DEBUG_MESSAGE( << "Module " << GetModuleID() << " initilized" << endl);
     return 0;
}

int Dummy_TDCModule_t::ResetModule(StringVector_t &/*errors*/)
{
     return 0;
}

