/*
$Header: /home/elrond/baikal/src/CVS/daq98/errorlog.C,v 1.3 1999/01/29 08:50:12 steffen Exp $
*/

#include <config.h>
#include <iostream.h>
#include <fstream.h>
#include <unistd.h>
#include <sys/types.h>
#include <time.h>
#include <String.h>
#include <localdir.h>
#include "process.h"
#include "errorlog.h"
#include "socketclass.h"

LogFile *Logger::LoggerFile;

LogFile::LogFile(String filename, LogFileAction_t LogFileAction){
     filename=DAQ_LOG_DIR + String("/") + filename + ".log";
     bool error=false;
     if(LogFileAction==SAVE_OLD) {
	  ifstream infile(filename);
	  char tmp[512];
	  if(infile) {
	       char Line[512];
	       Line[0]='\0';
	       while(1){
		    infile.getline(Line,512);
		    if(infile.eof() || Line[0]!='\0') break;
	       }
	       String Str(Line);
	       if(Line[0]=='\0') Str=" ";
	       int r=Str.gsub("Log started: ","");
	       if(r==0) {
		    (*Error)=GENERIC_ERROR;
		    (*Error)="LogFile::LogFile(..)";
		    sprintf(tmp,"No start date in old log file '%s'.\n\
Name of old file changed to '%s.unknown'.",
			    (const char *)filename,
			    (const char *)filename);
		    Error->SetParam(tmp);
		    Error->WarningOnly();
		    error=true;
		    sprintf(tmp,"%s.unknown",(const char *)filename);
	       }
	       else {
		    Str.gsub(RXwhite,"_");
		    Str.gsub("__","_");
		    Str.gsub(":","_");
		    sprintf(tmp,"%s.%s",(const char *)filename,
			    (const char *)Str);
	       }
	       infile.close();
	       
	       if(rename(filename,tmp)<0){
		    (*Error)=SYS_ERROR;
		    (*Error)="LogFile::LogFile(..)";
		    Error->Print();
	       }
	  }
	  Logfile.open(filename,ios::out|ios::trunc);
     } else if(LogFileAction==APPEND) {
	  Logfile.open(filename,ios::out|ios::app);
     } else if(LogFileAction==TRUNCATE) {
	  Logfile.open(filename,ios::out|ios::trunc);
     }
     
     
     time_t t, dummy;
     t=time(&dummy);
     Logfile << "Log started: " << ctime(&t) << "\n\n";
     
     if(error){
	  Error->Print();
     }
     SetCloseExec(Logfile.rdbuf()->fd());
}

LogFile::~LogFile(){
     Logfile.close();
}

ofstream &LogFile::operator()(){
     return Logfile;
}

Logger::Logger(){
     (*LoggerFile)() << "-----------------------------------------------------------------------------" << endl;
     time_t clock=time(NULL);
     (*LoggerFile)() << ctime(&clock);
     (*LoggerFile)() << ThisProcess->GetName() << ", pid :" << getpid() << endl;
}

Logger::~Logger(){
}

void Logger::SetLogger(LogFile *LF){
     LoggerFile=LF;
}

ostream &Logger::operator()() const{
     return (*LoggerFile)();
}


