/*
$Header: /home/elrond/baikal/src/CVS/daq98/fileinterpreter.h,v 1.4 1998/11/23 14:42:42 haase Exp $
*/

#if !defined __FILEINTERPRETER_H
#define __FILEINTERPRETER_H

#include <config.h>
#include "interpreter.h"
#include "processlink.h"

template<class T>
class FileInterpreter:protected Interpreter<T>
{
public:
     FileInterpreter(){
     }
     ~FileInterpreter(){}
     void AddFunction(const String &Cmd,CommandFunction0 Cmdfn){
	  Interpreter<T>::AddFunction(Cmd,Cmdfn);
     }
     void AddFunction(const String &Cmd,CommandFunction1 Cmdfn){
	  Interpreter<T>::AddFunction(Cmd,Cmdfn);
     }
     void CleanupFunction(CommandFunction0 Cmdfn){
	  DEB_F("void FileInterpreter::CleanupFunction(..)");
	  cleanupFunction.CmdFn=Cmdfn;
	  cleanupFunction.Help="";
	  cleanupFunction.Type=0;
     }
     void UnknownFunction(CommandFunction1 Cmdfn){
	  DEB_F("void FileInterpreter::UnknownFunction(..)");
	  DefaultFunction(Cmdfn);
     }

     void WrongTypeFunction(CommandFunction0 Cmdfn){
	  DEB_F("void FileInterpreter::UnknownFunction(..)");
	  Interpreter<T>::WrongTypeFunction(Cmdfn);
     }
     void WrongTypeFunction(CommandFunction1 Cmdfn){
	  DEB_F("void FileInterpreter::UnknownFunction(..)");
	  Interpreter<T>::WrongTypeFunction(Cmdfn);
     }
     void WrongTypeFunction(CommandFunction2 Cmdfn){
	  DEB_F("void FileInterpreter::UnknownFunction(..)");
	  Interpreter<T>::WrongTypeFunction(Cmdfn);
     }
     int Do(T* object,istream &infile){
	  char txt[MAX_TEXT_SIZE];
	  int LineNumber=0;
	  EndOfFileByCommand=false;
	  while(infile.good()&&(!EndOfFileByCommand)){
	       infile.getline(txt,MAX_TEXT_SIZE);
	       LineNumber++;
	       String cmds(txt);
	       FStringSplitter sp(cmds,';');
	       if(!sp.IsValid()) continue; 
	       for(int i=0;i<sp.NumSplits();i++){
		    if(Do_wo_type(object,sp()[i])<0){
			 (*Error).SetParam(ltoasc(LineNumber));
			 return -1;
		    }
	       }
	  }
	  return CallCmdFunction(object,&cleanupFunction,*(IOSocket*)0,0,0);
     }
     inline void SetEndOfFile(){
	  EndOfFileByCommand=true;
     }
private:	       
     class FStringSplitter:public Interpreter<T>::IStringSplitter
     {
     public:
	  FStringSplitter(String &txt,char separator){
	       if(!CleanUpString(txt)) {
		    valid=false;
		    return;
	       }
	       valid=true;
	       Split(txt,separator);
	  }
     private:
	  bool CleanUpString(String &txt){
	       if(!IStringSplitter::CleanUpString(txt)) return false;
	       if(';'==txt[txt.length()-1]) txt=txt.before((int)txt.length()-1);
	       return true;
	  }    
     };
		    
     int Do_wo_type(T* object,const String &CmdText,IOSocket &S=(*(IOSocket*)0)){
	  return Interpreter<T>::Do_wo_type(object,CmdText,S);
     }
     Command_t cleanupFunction;
     bool EndOfFileByCommand;
};

#endif // __FILEINTERPRETER_H
