/*
  $Header: /home/elrond/baikal/src/CVS/daq98/filenamefactory.C,v 1.3 1999/02/03 03:42:18 steffen Exp $
*/

#include "filenamefactory.h"
#include <stdio.h>

FileNameFactory_t::FileNameFactory_t(String directory, 
				     String baseFileName, 
				     String extension,
				     DerivationMode_t mode, 
				     String delimiter)
{
     Directory=directory;
     BaseFileName=baseFileName;
     Extension=extension;
     DMode=mode;
     Delimiter=delimiter;
     FileCount=0;
}

FileNameFactory_t::~FileNameFactory_t()
{
}

FileNameFactory_t::DerivationMode_t FileNameFactory_t::SetMode(DerivationMode_t mode)
{
     DerivationMode_t tmp=DMode;
     DMode=mode;
     return tmp;
}
     
FileNameFactory_t::DerivationMode_t FileNameFactory_t::GetMode()
{
     return DMode;
}

String FileNameFactory_t::SetDirectory(const String &directory)
{
     static String tmp=Directory;
     Directory=directory;
     return tmp;
}

String FileNameFactory_t::GetDirectory()
{
     return Directory;
}

String FileNameFactory_t::SetBaseFileName(const String &baseFileName)
{
     static String tmp=BaseFileName;
     BaseFileName=baseFileName;
     return tmp;
}

String FileNameFactory_t::GetBaseFileName()
{
     return BaseFileName;
}

String FileNameFactory_t::SetExtension(const String &extension)
{
     static String tmp=extension;
     Extension=extension;
     return tmp;
}

String FileNameFactory_t::GetExtension()
{
     return Extension;
}

String FileNameFactory_t::SetDelimiter(const String &delimiter)
{
     static String tmp(Delimiter);
     Delimiter=delimiter;
     return tmp;
}

String FileNameFactory_t::GetDelimiter()
{
     return Delimiter;
}

u_i32 FileNameFactory_t::SetFileCount(u_i32 count)
{
     u_i32 tmp=FileCount;
     FileCount=count;
     return tmp;
}

u_i32 FileNameFactory_t::GetFileCount()
{
     return (FileCount-1);
}

String FileNameFactory_t::GetNextFileName()
{
     static String file;
     String name;
     
     switch(DMode){
     case INCREMENT:
     {
	  char a[20];
	  sprintf(a,"%03i",FileCount++);
	  name=a;
	  break;
     }
     
     default:
	  name="000";
     }
     
     file=Directory + BaseFileName + Delimiter + name + Extension;
     return file;
}

String FileNameFactory_t::GetFileName()
{
     static String file;
     String name;
     
     switch(DMode){
     case INCREMENT:
     {
	  char a[20];
	  sprintf(a,"%03i",FileCount - 1);
	  name=a;
	  break;
     }
     
     default:
	  name="000";
     }
     
     file=Directory + BaseFileName + Delimiter + name + Extension;
     return file;
}
