/*
$Header: /home/elrond/baikal/src/CVS/daq98/genericmoduleevalbase.h,v 1.4 1999/02/03 03:42:18 steffen Exp $
*/

#if !defined __GENERICMODULEEVALBASE_H__ 
#define __GENERICMODULEEVALBASE_H__

#include <config.h>
#include "moduleevalbase.h"

/** Evaluator base class for all modules.
    All classes that implement a module evaluator must be derived from 
    eihter this class or from {\tt \Ref{ModuleEvalBase_t}}.
    To implement a module derived directly from this class you have 
    to write a class of the following this example:\\
    {\tt
    
    class NameOfModuleEvalClass_t: public NameOfModuleEvalBaseClass_t
    {
        enum 
	{ 
	    NUMBER_OF_CHANNELS =HERE_THE_NUMBER_OF_CHANNELS_OF_THE_MODULE,
	    BYTES_PER_INFO_UNIT=HERE_THE_NUMBER_OF_BYTES_PER_INFO_UNIT
	};
	ClassTypeInfo(NameOfModuleEvalBaseClass_t);
     public:
        inline NameOfModuleEvalClass_t()
	    :ModuleEvalBaseClass_t(NUMBER_OF_CHANNELS,BYTES_PER_INFO_UNIT){}
	// set additional information out of the config file, like channel mapping etc.
        virtual void Configure(ModuleConfigRecord_p &ModuleConfig,HWConfig_t &HWConfig);

     protected:
        virtual const void* ReadFromBuffer(BinaryDataBuffer &DataBuffer){
	// allocate some staic memory, so we can return a pointer to
	// the memory with no worry
	static u_i32 Data;
	// read the data from the buffer
	DataBuffer.ReadFromBuffer(Data);
	// return a pointer to the data
	return (void*)&Data;
     };
	
    }
}
*/

class GenericModuleEvalBaseClass_t:public ModuleEvalBaseClass_t
{
     ClassTypeInfo(ModuleEvalBaseClass_t);

public:
     inline GenericModuleEvalBaseClass_t(int numChannels,int bytesPerInfoUnit, DaqProcessBase *Parent)
	  :ModuleEvalBaseClass_t(numChannels, bytesPerInfoUnit,Parent){};
private:
     virtual int BuildEventPart(BinaryDataBuffer &,
				TempDecode_EventData_t *){
	  return -1;
     }
};

#endif // __GENERICMODULEEVALBASE_H__

