/*
  $Header: /home/elrond/baikal/src/CVS/daq98/globalfunctions.C,v 1.5 1998/11/23 14:42:48 haase Exp $
*/

#include <stdlib.h>
#include "globalmacros.h"
#include "globalfunctions.h"
#include "string.h"

u_i64 time_diff(GPSTime_t  t1, GPSTime_t t2)
{
     u_i64 nt1=(t1.day * 24 * 3600 + t1.hour * 3600 + t1.min * 60 + t1.sec) * 1000000000L + t1.nsec;
     u_i64 nt2=(t2.day * 24 * 3600 + t2.hour * 3600 + t2.min * 60 + t2.sec) * 1000000000L + t2.nsec;
     return nt2-nt1;
}

u_i64 time_nsecs(GPSTime_t  t)
{
     return (t.day * 24 * 3600 + t.hour * 3600 + t.min * 60 + t.sec) * 1000000000L + t.nsec;
}

/** to convert an long int into a string */
char *ltoasc(long int i){
     static char txt[20];
     sprintf(txt,"%li",i);
     return txt;
}

/** delay of ~1 msec on RIO2-P603/200MHz   */
int delay_msec (int n_msec){
     int nloop_msec=25000;
     for (int i=n_msec;i;i--){
	  for (int j=nloop_msec;j;j--){;}
     }
     return 0;
}



String TimeToString(time_t t)
{
     time_t ttime,rem=t;
     String Time="";
     char tmp[512];
     if(t>7*24*60*60){
	  ttime=t/(7*24*60*60);
	  rem=t%(7*24*60*60);
	  if(ttime>1)
	       sprintf(tmp,"%ld weeks ",ttime);
	  else 
	       sprintf(tmp,"%ld week ",ttime);
	  Time+=tmp;
     }
     if(t>24*60*60){
	  ttime=rem/(24*60*60);
	  rem=t%(24*60*60);
	  if(ttime>1)
	       sprintf(tmp,"%ld days ",ttime);
	  else 
	       sprintf(tmp,"%ld day ",ttime);
	  Time+=tmp;
     }
     if(t>60*60){
	  ttime=rem/(60*60);
	  rem=rem%(60*60);
	  if(ttime>1)
	       sprintf(tmp,"%ld hours ",ttime);
	  else 
	       sprintf(tmp,"%ld hour ",ttime);
	  Time+=tmp;
     }
     if(t>60){
	  ttime=rem/60;
	  rem=rem%60;
	  sprintf(tmp,"%ld min ",ttime);
	  Time+=tmp;
     }
     sprintf(tmp,"%ld sec",rem);
     Time+=tmp;
     return Time;
}

time_t StringToTime(String &Time)
{
     Regex Units("[smhdwSMHDW]");
     String Number;
     time_t  TimeVal;
     if(Time.contains(Units,1))
	  Number=Time.before(Units);
     else 
	  Number=Time;
     char u;
     int index;
     if((index=Time.index(Units))>=0) {
	  u=Time[index];
	  switch (u=tolower(u)){
	  case 's':
	       // seconds
	       TimeVal=1;
	       break;
	  case 'm':
	       // minutes
	       TimeVal=60;
	       break;
	  case 'h':
	       // hours
	       TimeVal=60*60;
	       break;
	  case 'd':
	       // days
	       TimeVal=60*60*24;
	       break;
	  case 'w':
	       // weeks
	       TimeVal=60*60*24*7;
	       break;
	  default:
	       TimeVal=1;
	  }
	  TimeVal*=atol((const char *)Number);
     }
     else {
	  TimeVal=atol((const char *)Number);
     }
     return TimeVal;
}
     
int SplitCommand(String &Command, String Split[],int MaxNum)
{
     int Freq=Command.freq("\r\n");
     String *SplitAll=new String[Freq+1];
     split(Command,SplitAll,Freq,String("\r\n"));
     int Num=0;
     for(int i=0;i<Freq;i++){
	  if(Num<MaxNum){
	       Split[Num]=SplitAll[i]+"\r\n"+SplitAll[i+1]+"\r\n";
	       Num++;
	       i++;
	       String test=Split[Num];
	       test.gsub("\r","\\r");
	       test.gsub("\n","\\n");
	       cerr << "Split: " << test << endl;
	  }else break;
     }
     delete [] SplitAll;
     return Num;
}

