/*
  $Header: /home/elrond/baikal/src/CVS/daq98/globalfunctions.h,v 1.4 1998/11/23 14:42:49 haase Exp $
*/

#include <config.h>
#include "globaltypes.h"
#include <String.h>

#if ! defined __GLOBALFUNCTIONS_H__
#define __GLOBALFUNCTIONS_H__

/** Difference between two GPS times in nsec.
    Please note, that this function ignores the year, since this
    information is currently undefined 
    @param t1 GPS time 1
    @param t2 GPS time 2
    @return t2 - t1 in nsec */
u_i64 time_diff(GPSTime_t  t1, GPSTime_t t2);

/** GPS time in nsec.
    Please note, that this function ignores the year, since this
    information is currently undefined 
    @param t GPS time  */
u_i64 time_nsecs(GPSTime_t  t);

/** Convert a long int to a string 
  @param i Number to convert
  @return Number converted to a string.*/
char *ltoasc(long int i);

/** delay of ~1 msec on RIO2-P603/200MHz   */
int delay_msec (int n_msec);

#if defined (linux)
#define yield() sched_yield()
#endif //linux

#if defined(__lynx__)
/** Compares two strings ignoring the case of the characters.
    @param s1 string 1
    @param s2 string 2
    @return an integer less than, equal to, or greater than  zero  if  s1
    (or  the first n bytes thereof) is found, respectively, to
    be less than, to match, or be greater than s2. */
inline int strcasecmp(const char *s1, const char *s2)
{
     return fcompare(String(s1),String(s2));
}

#endif // __lynx__ ||| __osf__


String TimeToString(time_t t);
time_t StringToTime(String &Time);

#endif // __GLOBALFUNCTIONS_H__
