/*
$Header: /home/elrond/baikal/src/CVS/daq98/globalmacros.h,v 1.12 1999/02/10 17:31:46 daq Exp $
*/

#if ! defined __GLOBALMACROS_H__
#define __GLOBALMACROS_H__

#include <config.h>
#include <stdio.h>
#include "daqdebug.h"

extern int FORMAT_VERSION;
extern int PROGRAM_VERSION;

#define FORMAT_VERSION_DEF     1100 // the actual version is this number devided by 1000
#define PROGRAM_VERSION_DEF    VERSION
/* 1002
   - added CamacGps97
*/

#define MAGIC              "**amanda daq98 raw data**"



/* Trigger Flags */
#define AB_TRIGGER_FLAG                   0x04
#define A_TRIGGER_FLAG                    0x01
#define B_TRIGGER_FLAG                    0x02
#define SPASEII_TRIGGER_FLAG              0x08
#define STRING_TRIGGER_FLAG               0x10

/* stuff for the configuration files */
#define DEFAULT_DAEMON_CNF_FILENAME       "daq.cnf"

#define VMECONTROLDAEMON_CNF_FILENAME     "daq.cnf"
#define VMECONTROLDAEMON_SECTION_NAME     "vmecontrol" 

#define DAQCONTROLDAEMON_CNF_FILENAME     "daq.cnf"
#define DAQCONTROLDAEMON_SECTION_NAME     "daqcontrol" 

#define COMMUNICATIONSERVER_CNF_FILENAME  "daq.cnf"
#define COMMUNICATIONSERVER_SECTION_NAME  "communicationserver"

#define DISPATCHER_CNF_FILENAME           "daq.cnf"  
#define DISPATCHER_SECTION_NAME           "dispatcher"

#define DATAPROCESS_CNF_FILENAME          "daq.cnf"
#define DATAPROCESS_SECTION_NAME          "dataprocess"

#define DATACOLLECTOR_CNF_FILENAME        "daq.cnf"
#define DATACOLLECTOR_SECTION_NAME        "datacollector"

#define DATATRANSPORT_CNF_FILENAME        "daq.cnf"
#define DATATRANSPORT_SECTION_NAME        "datatransport"

#define COMMON_SECTION_NAME               "DAQCommon"
#define RUN_PARAM_FILENAME                "runparam.cnf"
#define RUN_PARAM_SECTION_NAME            "DAQRunParam"
#define RUN_NUMBER_FILENAME               "runnumber.dat"
#define RUN_NUMBER_SECTION_NAME           "DAQRunNumber"

/* process types */
#define PROCESS_TYPE_COMMUNICATIONSERVER    "CS"
#define PROCESS_TYPE_DAQCONTROL             "DC"
#define PROCESS_TYPE_VMECONTROL             "VC"
#define PROCESS_TYPE_DATACOLLECTOR          "DCO"
#define PROCESS_TYPE_DATATRANSPORT          "DT"
#define PROCESS_TYPE_DATAPROCESS            "DP"
#define PROCESS_TYPE_MESSAGEDISPATCH        "MD"
#define PROCESS_TYPE_HVDAEMON               "HV"

#define USER_DAQ_INTERN                     "DAQUSER"

/* log file types */
#define LOG_TYPE_RUNLOG                     "RL"
#define LOG_TYPE_ERRORLOG                   "EL"
 
#define FILENAME_RUNLOG              "daqrun.log"
#define FILENAME_ERRORLOG            "daqerror.log"
#define FILENAME_RUNNUMBER           "runnumber.dat"
#define FILENAME_RUNSTAT             "runstat.dat"

/** File name extension that indicates that this file should not be transfered */
#define DO_NOT_TRANSFER              ".do_not_transfer"

/* some DAQ defaults */
#define DEFAULT_VMECONTROL_PORT 11000
#define DEFAULT_VMECONTROL_HOST "localhost"
#define DEFAULT_IPC_PORT_FIRST 10050
#define DEFAULT_IPC_PORT_LAST  10250
#define DEFAULT_FREE_PORT_FIRST 10300
#define DEFAULT_FREE_PORT_LAST  10500
#define DEFAULT_DISPATCHER_PORT 10000
#define DEFAULT_DISPATCHER_HOST "localhost"

/** The default subject to appear in the DAQ mails */
#define DEFAULT_DAQ_MAIL_SUBJECT "DAQ98 Mail"

/** The filename for the detector hardware configuration. */
#define HW_CONFIG_FILE_NAME "detector.cnf"

/** Maximum size for text messages */
#define MAX_TEXT_SIZE 1024

/** Maximum size of C++ strings (annything bigger crashes the program) */
#define MAX_STRING_SIZE 30000

/** Maximum size for the title of a histogram.
ejejrkejx */
#define HISTOGRAM_TITLE_SIZE 512

/** Maximum number of shared memory segments, that can be used */
#define MAX_SHM_SEGMENTS 100

/* End of file command */
//#define CMD_ENDOFFILE "ENDOFFILE"

/** Default extension for an AMANDA DAQ98 script file */
#define DAQ98_SCRIPT_EXTENSION "*.ads"

/** Default extension for an AMANDA log files (globbing)*/
#define LOG_EXTENSION_GLOB "*.log"

/** Default extension for an AMANDA log files */
#define LOG_EXTENSION ".log"

//#define NUM_RAW_DATA_BUFFERS 2
#define MAX_RAW_DATA_BUFFER_SIZE 1024*500 // 0.5 Mbyte
#define MAX_USED_RAW_DATA_BUFFER_SIZE 1024*400 // 0.4 Mbyte
//#define WRITE_RAW_DATA_AT_ONCE_SIZE 10 * 1024 // 10 kByte
 
#if defined __osf__
#define no_argument             0
#define required_argument       1
#define optional_argument       2
#endif // __osf__

#endif // __GLOBALMACROS_H__
