#if !defined __GLOBALTYPES_H__
#define __GLOBALTYPES_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/globaltypes.h,v 1.6 1999/02/04 03:34:00 steffen Exp $
*/

#include <config.h>
#include <String.h>
#include <limits.h>
#include <unistd.h>
#include <iostream.h>
#include <ctype.h>
#include <sys/types.h>

#if defined(__linux__) || defined(__osf__) || defined(__lynx__) 

typedef unsigned char      u_i8;
typedef signed char        s_i8;

#define U_I8_MAX            256
#define S_I8_MAX            127
#define S_I8_MIN           -128

typedef unsigned short     u_i16;
typedef signed short       s_i16;

#define U_I16_MAX           65536
#define S_I16_MAX           32767
#define S_I16_MIN          -32768

typedef unsigned int       u_i32;
typedef signed int         s_i32;

#define U_I32_MAX            
#define S_I32_MAX            
#define S_I32_MIN           

typedef unsigned long long u_i64;
typedef signed long long   s_i64;

#define U_I64_MAX            
#define S_I64_MAX            
#define S_I64_MIN           

#endif // __linux__


typedef int port_t;
typedef int filedescriptor_t;

typedef s_i32 ID_t;

// binary tag of raw data files
typedef u_i16 binary_tag_t;

// types for histograms
typedef float X_t;             // type of the bin
//typedef u_i16 NumBin_t;        //  
typedef u_i32 NumBin_t;        //  
typedef u_i64 Entries_long_t;  // type for an entry
typedef u_i32 Entries_t;       // type for an entry
#define MAX_ENTRIES INT_MAX

// types for an event
struct TDCTime_t
{
     enum { LEADING_EDGE=0,
	    TRAILING_EDGE=1
     };
     u_i16 timeval;
     u_i16 edge;
     
};

//typedef u_i16 amp_t;
struct amp_t
{
     u_i16 ampval;
     u_i16 isamp;                      // =0 if no adc present
};

typedef u_i16 channel_t;
typedef u_i16 count_t;

typedef u_i32 histo_id_t;

/** The struct GPSTime_t structure represents a GPS time.
    It the following members: */
typedef u_i32 ntime_t;
struct GPSTime_t
{
     /** This is the number of years since ???? */
     int year;
     /** This is the day of the year, in the range 1 to 366 */
     int day;
     /** This is the number of hours past midnight, in the range 0 to 23 */
     int hour;
     /** This is the number of minutes after the hour, in the range 0 to 59 */
     int min;
     /** This is the number of seconds after the minute, in the range 0 to 59 */
     int sec;
     /** This is the number of nanoseconds after the second, in the 
	 range 0 to 999 999 999 */
     ntime_t nsec;

     /** Time Quality, should be zero. Anything but there gas an error, but is not defined yet.*/
     int quality;
};

ostream &operator <<(ostream &o,GPSTime_t &GPSTime);

/** The struct UnixMTime structure represents is a unix time as 
    returned by the time() function call ??plus a number of microseconds */
typedef GPSTime_t UnixMTime_t;

typedef unsigned short int Trigger_t;
enum {TRIGGER_TEST1,TRIGGER_TEST2,TRIGGER_TEST3 } ;


struct IPAddress_t
{
     IPAddress_t()
	  :Port(-1),
	   Hostname("-1"){}
     IPAddress_t(const IPAddress_t &IPA)
	  :Port(IPA.Port),
	   Hostname(IPA.Hostname){}
     const IPAddress_t &operator=(const IPAddress_t &IPA){
	  Port=IPA.Port;
	  Hostname=IPA.Hostname;
	  return IPA;
     }       
     port_t Port;
     String Hostname;
     friend ostream &operator <<(ostream &o,IPAddress_t &IPAddr);
     friend istream &operator >>(istream &i,IPAddress_t &IPAddr);
};

ostream &operator <<(ostream &o,IPAddress_t &IPAddr);

istream &operator >>(istream &i,IPAddress_t &IPAddr);
struct PID_t
{ 
     PID_t():pid(0),
	   Hostname("0"),
	   ProcessID("0"){}
     PID_t(const PID_t &PID)
	  :pid(PID.pid),
	   Hostname(PID.Hostname),
	   ProcessID(PID.ProcessID){}
     const PID_t &operator=(const PID_t &PID){
	  pid=PID.pid;
	  Hostname=PID.Hostname;
	  ProcessID=PID.ProcessID;
	  return PID;
     }
     pid_t pid;
     String Hostname;
     String ProcessID;
     friend ostream &operator <<(ostream &o,PID_t &pid);
     friend istream &operator >>(istream &i,PID_t &pid);
};

ostream &operator <<(ostream &o,PID_t &pid);

istream &operator >>(istream &i,PID_t &pid);

// type for channel groups
struct group_t
{
     int start;
     int end;
};

typedef group_t ChannelGroup_t;

#endif // __GLOBALTYPES_H__


