#ifndef __GPSMODULE_H__
#define __GPSMODULE_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/gpsmodule.h,v 1.1 1999/02/05 18:35:05 steffen Exp $

  $Log: gpsmodule.h,v $
  Revision 1.1  1999/02/05 18:35:05  steffen
  * Major cleanup:
    - threw out code for binary config records
    - cleaned up some module classes
  * Fixed bug which prevent 32 bit values to be read correctly from
    detector cnf
  * Added masking to s7201 module

*/

#include <config.h>
#include "channelmodule.h"

/*---------------------------------------------------------*/
/*                                                         */
/*  GPS module configuration data structure                */
/*                                                         */
/*---------------------------------------------------------*/

/** Configuration data structure for GPS modules */
struct GPSModuleConfigRecord_t:public ChannelModuleConfigRecord_t
{
     ClassTypeInfo(ChannelModuleConfigRecord_t);

     /** Constructor */
     GPSModuleConfigRecord_t();
     
     /** Destructor */
     virtual ~GPSModuleConfigRecord_t();
     

     /** Index of this particular GPS clock */
     u_i32 EventIndex;
};

MAKE_REFCOUNT_POINTER(GPSModuleConfigRecord_t,GPSModuleConfigRecord_p);


/*---------------------------------------------------------*/
/*                                                         */
/*  GPS module base class                                  */
/*                                                         */
/*---------------------------------------------------------*/

/** Base class for GPS module classes */
class GPSModuleClass_t:public ChannelModuleBaseClass_t
{
     ClassTypeInfo(ChannelModuleBaseClass_t);
public:
     /** Constructor.
	 @param numChannels Number of channels of this module
	 @param BytesPerInfoUnit Number of bytes per info unit (bytes per channel)
	 @param parent Pointer to parent class. Used for sending messages in Parent context. */
     GPSModuleClass_t(int numChannels,int BytesPerInfoUnit, DaqProcessBase *parent);
};

MAKE_REFCOUNT_POINTER(GPSModuleClass_t, GPSModuleClass_p);



#endif /* __GPSMODULES_H__ */
