/*
$Header: /home/elrond/baikal/src/CVS/daq98/graph.h,v 1.3 1998/11/23 14:42:57 haase Exp $
*/

#if !defined __GRAPH_H__ 
#define  __GRAPH_H__ 
#include <config.h>
#include "memhistogram.h"
#include "pointerutil.h"
#include <qpainter.h>
#include <iostream.h>
#include <qwidget.h>
#include <qmenubar.h>
#include <algo.h>
#include <math.h>

class Graph
{
public:
     Graph();
     virtual ~Graph();
     virtual void Draw(QPainter* P);
     virtual void DrawAxis(QPainter* P);
     void XLogScale(bool X);
     void YLogScale(bool Y);
     inline int TranslateX(double X){
	  return (int)(xLogScale?(log10(X)-log10(xmin))*xFactor+Xint:(X-xmin)*xFactor+Xint+0.5);
     }
     inline int TranslateY(double Y){
	  return (int)(yLogScale?(log10(Y)-log10(ymin))*yFactor+Yint:(Y-ymin)*yFactor+Yint+0.5);
     }
     void SetDrawParams(int x,int y,int w,int h);
     void CalcDrawParams();
     void ZoomX(double Xmin,double Xmax);
     void ZoomY(double Ymin,double Ymax);
protected:
     virtual void GetMinMax();
private:
     void CalcLabel(double &min,double &max,double &Start,double &Step,int &numsteps);
protected:
     double xmin,xmax,ymin,ymax;
     bool xLogScale,yLogScale;
private:
     double xFactor,yFactor;
     int Xint,Yint;
     int Wint,Hint;
};

typedef PointerWrapper_Ref<Graph> Graph_p;

class HistogramGraph:public Graph
{
public:
     HistogramGraph(MemHistogram_t *Hist);
     ~HistogramGraph();
     void Update(MemHistogram_t *Hist);
     virtual void Draw(QPainter* P);
protected:
     virtual void GetMinMax();
private:
     int NumBin;
     double BinWidth;
     MemHistogram_t *Histogram;
};

class GraphView:public QWidget
{
     Q_OBJECT;
public:
     GraphView(Graph_p agraph,QWidget *parent=0,const char *name=0);
     ~GraphView();
     Graph_p GraphObject(){
	  return aGraph;
     }       
protected:
     void paintEvent(QPaintEvent *);
private:
     Graph_p aGraph;
};


#endif // __GRAPH_H__ 
