/*
$Header: /home/elrond/baikal/src/CVS/daq98/histosections.h,v 1.2 1998/11/23 14:43:08 haase Exp $
*/

#if ! defined __HISTOSECTIONS_H__
#define __HISTOSECTIONS_H__

#include <vector.h>
#include <String.h>

#include "globaltypes.h"
#include "settergetter.h"
#include "configsection.h"

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ---------------------------------------------------------------------

class MulChannelHistConfig_t
{
public:
     inline void AddChannel(ID_t ID){
	  ChannelContainer.push_back(ID);
     }
     inline void AddString(ID_t ID){
	  StringContainer.push_back(ID);
     }       
     SetterGetter(ID_t,HistID);
     SetterGetter(String&,Name);
     SetterGetter(vector<ID_t>&,StringContainer);
     SetterGetter(vector<ID_t>&,ChannelContainer);
private:
     ID_t HistID;
     String Name;
     vector<ID_t> StringContainer;
     vector<ID_t> ChannelContainer;
};

MAKE_REFCOUNT_POINTER(MulChannelHistConfig_t,MulChannelHistConfig_p);

class HistogramSection_t:public ConfigSection
{
public:
     HistogramSection_t();
     /** sets property propnum */
     virtual int SetPropertyByNo(int propnum,const String &val);

     //  the setter and getter for the private data members

     SetterGetter(bool,Enabled);
     SetterGetter_NODBG(vector<MulChannelHistConfig_p>&,MulChannelHistConfig);
     SetterGetter(ID_t,IDOffset);
     SetterGetter(NumBin_t,NumBin);
     SetterGetter(X_t,Xmin);
     SetterGetter(X_t,Xmax);
     SetterGetter(String&,Title);
private:
     bool Enabled;
     ID_t IDOffset;
     NumBin_t NumBin;
     X_t Xmin;
     X_t Xmax;
     String Title;
     vector<MulChannelHistConfig_p> MulChannelHistConfig;
     MulChannelHistConfig_p CurrentHistogramConfig;

     static String ItemNames[];
};

class ADCHistogramSection_t:public HistogramSection_t
{
     virtual const String GetSectionName()const;
};

class LeadingEdgeHistogramSection_t:public HistogramSection_t
{
     virtual const String GetSectionName()const;
};

class TOTHistogramSection_t:public HistogramSection_t
{
     virtual const String GetSectionName()const;
};

class MultiplicityHistogramSection_t:public HistogramSection_t
{
     virtual const String GetSectionName()const;
};

class HitTimesHistogramSection_t:public HistogramSection_t
{
     virtual const String GetSectionName()const;
};

#endif     
