/*
$Header: /home/elrond/baikal/src/CVS/daq98/hwconfigitems.C,v 1.2 1998/11/23 14:43:12 haase Exp $
*/

/* 221097 changed MAPCHANNEL to HVCHANNEL *PN*				*/

#include <vector.h>
#include <stdlib.h>
#include <String.h>
#include "hwconfigitems.h"
#include "stringutil.h"


#define CHANNEL_ITEM_STRING    "STRING"

#define HVCHANNEL_ITEM_PMT	"PMT"
#define CHANNEL_ITEM_HVCHANNEL	"HVCHANNEL"		// *PN*
#define HV_ITEM_VOLT            "VOLT"	// *SR*
#define HV_ITEM_TRIP	        "TRIP"  // *SR*
#define HV_ITEM_RAMP            "RAMP"	// *SR*


#define SECTION_NAME_HVCHANNELS	          "HVChannels"


// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// HVChannelSection
// ----------------------------------------------------------------

String HVChannelSection::ItemNames[] = {HVCHANNEL_ITEM_PMT,	// 0
					CHANNEL_ITEM_HVCHANNEL,// 1
					CHANNEL_ITEM_STRING,	// 2
					HV_ITEM_VOLT,	// 3
					HV_ITEM_TRIP,	// 4
					HV_ITEM_RAMP};	// 5

HVChannelSection::HVChannelSection(vector<HVChannelConfig_p> &hvchannelconfig)\
			:HVChannelConfig (hvchannelconfig)
{
	SetProperties (sizeof (ItemNames)/ sizeof (ItemNames[0]), ItemNames);
	CurrentChannel = 0;
}

const String HVChannelSection::GetSectionName () const
{
	return SECTION_NAME_HVCHANNELS;
}

int HVChannelSection::SetPropertyByNo (int propnum, const String &val)
{
	if ((0 == (void*)CurrentChannel) && (propnum != 0)) return -1;
	// this means the list must start withg a HVCHANNEL_ITEM_PMT

	switch (propnum)
	{
		case 0:	// HVCHANNEL_ITEM_PMT
		{
			StringSplitter sp (val, ' ');
			if (sp.NumSplits () != 1) return -1;

			if (!sp ()[0].matches (RXint)) return -1;

			CurrentChannel = new HVChannelConfig_t;
			HVChannelConfig.push_back (CurrentChannel);

			CurrentChannel->SetID (atoi (sp ()[0]));
			// *PN* 151097 this defaults the map channel
			// to the ID
			CurrentChannel->SetHVChannel (atoi (sp ()[0]));
			CurrentChannel->SetUserChange (false);
			CurrentChannel->SetAlarm (false);
		}; break;

		case 1: // CHANNEL_ITEM_HVCHANNEL
		{
			StringSplitter sp (val, ' ');
			if (sp.NumSplits () != 1) return -1;

			if (!sp ()[0].matches (RXint)) return -1;

			CurrentChannel->SetHVChannel (atoi (sp()[0]));
		}; break;

		case 2:	// CHANNEL_ITEM_STRING
		{
			StringSplitter sp (val, ' ');
			if (sp.NumSplits () != 2) return -1;

			if (!sp ()[0].matches (RXint)) return -1;
			if (!sp ()[1].matches (RXint)) return -1;

			CurrentChannel->SetStringNumber (atoi (sp()[0]));
			CurrentChannel->SetStringPosition (atoi (sp()[1]));
		}; break;

		case 3: // HVCHANNEL_ITEM_VOLT
		{
			StringSplitter sp (val, ' ');
			if (sp.NumSplits () != 1) return -1;

			if (!sp ()[0].matches (RXint)) return -1;

			CurrentChannel->SetVoltage (atoi (sp ()[0]));
		}; break;

		case 4: // HVCHANNEL_ITEM_TRIP
		{
			StringSplitter sp (val, ' ');
			if (sp.NumSplits () != 1) return -1;

			if (!sp ()[0].matches (RXint)) return -1;

			CurrentChannel->SetTripCurrent (atoi (sp ()[0]));
		}; break;

		case 5: // HVCHANNEL_ITEM_RAMP
		{
			StringSplitter sp (val, ' ');
			if (sp.NumSplits () != 1) return -1;

			if (!sp ()[0].matches (RXint)) return -1;

			CurrentChannel->SetRampSpeed (atoi (sp ()[0]));
		}; break;

		default: return -1; break;
	}

	return 0;
}

