/*
$Header: /home/elrond/baikal/src/CVS/daq98/hwconfigitems.h,v 1.3 1998/11/23 14:43:13 haase Exp $
*/

#ifndef __HWCONFIGITEMS_H_
#define __HWCONFIGITEMS_H_

#include <config.h>
#include <String.h>
#include <string.h>
#include <vector.h>

#include "simplevector.h"
#include "globaltypes.h"
#include "pointerutil.h"
#include "settergetter.h"
#include "configsection.h"
#include "datafilecode.h"


// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/** Class to store information on a HVChannel read from a config file
  */
// ---------------------------------------------------------------------
// *PN* 061097

// #ifdef 0 what the fuck is that, doesn't compile anymore!!!
class HVChannelConfig_t
{
	friend class HV;
	friend class HVProps;

	public:
		SetterGetter(ID_t, ID);
		SetterGetter(unsigned short, HVChannel);
		SetterGetter(unsigned short, StringNumber);
		SetterGetter(unsigned short, StringPosition);
		SetterGetter(int, Voltage);
		SetterGetter(int, LastVoltage);
		SetterGetter(int, TripCurrent);
		SetterGetter(int, RampSpeed);
		SetterGetter(bool, UserChange);
		SetterGetter(bool, Alarm);
		
	private:
		ID_t ID;
		unsigned short HVChannel;
		unsigned short StringNumber;
		unsigned short StringPosition;
		
		int Voltage;		// in V
		int LastVoltage;	// last measured voltage

		int TripCurrent;	// in mA
		int RampSpeed;		// in V/s

		// internal use only
		bool UserChange;	// indicate if user changed the channel
		bool Alarm;		// indicates an alarm
};

MAKE_REFCOUNT_POINTER (HVChannelConfig_t, HVChannelConfig_p);

class HVChannelSection: public ConfigSection
{
	public:
		HVChannelSection (vector<HVChannelConfig_p> &hvchannelconfig);

		virtual const String GetSectionName()const;
		/** sets property propnum */
		virtual int SetPropertyByNo(int propnum,const String &val);
		/** returns property propnum */
	private:
		vector<HVChannelConfig_p> &HVChannelConfig;
		HVChannelConfig_p CurrentChannel;

		static String ItemNames[];
};
//#endif see above

#endif
