#if ! defined __HWCONFIGITEMS2_h__
#define  __HWCONFIGITEMS2_h__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/hwconfigitems2.h,v 1.10 1999/02/10 11:59:51 steffen Exp $
*/

#include "vectorinclude.h"
#include "configsection2.h"
#include "datafilecode.h"
#include "globaltypes.h"
#include "settergetter.h"
#include "simplevector.h"
#include "adcmodule.h"
#include "tdcmodule.h"
#include "discmodule.h"
#include "scalermodule.h"
#include "gpsmodule.h"
#include "iregmodule.h"
#include "dmadmodule.h"

class ModuleSection_t:public ConfigSection_t
{
public:
     ModuleSection_t(ChannelModuleConfigRecordVector_t &moduleconfig):ModuleConfig(moduleconfig){}
private:
     int DMAD_Select(String &Value){
	  CurDMAD_SelectedChannelIndexes.Clear();
	  if(fcompare(Value,"ALL")==0){
	       for(int i=0;i<CurDMAD->DMAD_ChannelConfigRecordVector.size();i++)
		    CurDMAD_SelectedChannelIndexes.push_back(i);
	  } else {
	       StringSplitter sp(Value,'-');
	       if(sp.NumSplits()==2){
		    int from,to;
		    if(ConvertFromString(sp()[0],from)<0) return -1;
		    if(ConvertFromString(sp()[1],to)<0) return -1;
		    for(int i=0;i<CurDMAD->DMAD_ChannelConfigRecordVector.size();i++){
			 if((CurDMAD->DMAD_ChannelConfigRecordVector[i]->ID>=from)&&
			    (CurDMAD->DMAD_ChannelConfigRecordVector[i]->ID<=to))
			      CurDMAD_SelectedChannelIndexes.push_back(i);
		    }
	       } else {
		    int single;
		    if(ConvertFromString(Value,single)<0) return -1;
		    for(int i=0;i<CurDMAD->DMAD_ChannelConfigRecordVector.size();i++){
			 if(CurDMAD->DMAD_ChannelConfigRecordVector[i]->ID==single)
			      CurDMAD_SelectedChannelIndexes.push_back(i);
		    }
	       }
	  }
	  return 0;
     }
     int DMAD_Operation(String &Value){
	  ON_OFF_t onoff;
	  ConvertFromString(Value,onoff);
	  int_inc_v::iterator start=CurDMAD_SelectedChannelIndexes.begin(),
	       stop=CurDMAD_SelectedChannelIndexes.end();
	  while(start!=stop){
	       CurDMAD->DMAD_ChannelConfigRecordVector[*start]->DMAD_On=onoff;
	       start++;
	  }
	  return 0;
     }
protected:
     BeginItems(ConfigSection_t){
	  BeginActions{
	       ItemAction_SET("MODULE",
			      if((CurMod=CreateModuleConfigRecord(Value))==0) return -1;
			      CurMod->isAsynch=0;
			      ModuleConfig.push_back(CurMod);
			      // convert the general pointer to a specific pointer  
			      CurADC=TYPESAFE_DOWNCAST_RCP(ADCModuleConfigRecord_t,CurMod);
			      CurTDC=TYPESAFE_DOWNCAST_RCP(TDCModuleConfigRecord_t,CurMod);
			      CurDISC=TYPESAFE_DOWNCAST_RCP(DISCModuleConfigRecord_t,CurMod);
			      CurGPS=TYPESAFE_DOWNCAST_RCP(GPSModuleConfigRecord_t,CurMod);
			      CurIREG=TYPESAFE_DOWNCAST_RCP(IREGModuleConfigRecord_t,CurMod);
			      CurSCALER=TYPESAFE_DOWNCAST_RCP(SCALERModuleConfigRecord_t,CurMod);
			      CurDMAD=TYPESAFE_DOWNCAST_RCP(DMAD_ModuleConfigRecord_t,CurMod);
			      if(CurDMAD){
				   CurMod->isAsynch=111;
			      }
		    );
	       // 111 for DMAD module reserved !!!!!!!!!!!
	       ItemAction_SET("ISASYNCH",if(atoi((const char*)Value)==111) return -1); 

	       ItemAction_SET("PED",if(!CurADC) return -1;);
	       ItemAction_SET("THRESH_UP",if(!CurADC) return -1;);
	       ItemAction_SET("THRESH_LOW",if(!CurADC) return -1;);
	       ItemAction_SET("NHIT",if(!CurTDC) return -1;);
	       ItemAction_SET("MODE",if(!CurTDC) return -1;);
	       ItemAction_SET("WIN" ,if(!CurTDC) return -1;);

	       ItemAction_SET("GPSINDEX",if(!CurGPS) return -1;);

	       ItemAction_SET("THRESH",if(!CurDISC) return -1;);

	       ItemAction_SET("MASK",if(!CurSCALER) return -1;);
	       ItemAction_SET("DEADTIME",if(!CurSCALER) return -1;);
	       ItemAction_SET("DEADTIMEENABLE",if(!CurSCALER) return -1;);
	       ItemAction_SET("CHANNEL",
			      if(!CurDMAD) return -1;
			      CurDMAD_CurCh=new DMAD_ChannelConfigRecord_t;
			      CurDMAD->DMAD_ChannelConfigRecordVector.push_back(CurDMAD_CurCh);
		    );
	       ItemAction_SET("DMAD_OPSELECT",if(!CurDMAD) return -1; else return DMAD_Select(Value));
	       ItemAction_SET("DMAD_OP",if(!CurDMAD) return -1; else return DMAD_Operation(Value));

	       ItemAction_SET("MULT20ADDRESS",if(!CurDMAD) return -1;);
	       ItemAction_SET("MULT20CHANNEL",if(!CurDMAD) return -1;);
	  }EndActions;
	  BeginLinks{
	       ItemLink1("MODULE",	CurMod->ModuleType);
	       ItemLink1("SLOT_ADDR",	CurMod->Address_Slot);
	       ItemLink1("ENABLE",      (TRUE_FALSE_t&)CurMod->Enabled);
	       ItemLink1("BINARYTAG",	CurMod->BinaryTag);
	       ItemLink1("BYTESPERUNIT",CurMod->BytesPerInfoUnit);
	       ItemLink1("CRATE",	CurMod->CrateID);
	       ItemLink1("ID",	        CurMod->ModuleID);
	       ItemLink1("ISASYNCH",    CurMod->isAsynch); 

	       ItemLink1("PED",CurADC->Ped);
	       ItemLink1("THRESH_UP",CurADC->ThreshUp);
	       ItemLink1("THRESH_LOW",CurADC->ThreshLow);
	       ItemLink1("NHIT",CurTDC->NHit);
	       ItemLink1("MODE",CurTDC->Mode);
	       ItemLink1("WIN" ,CurTDC->Win);

	       ItemLink1("GPSINDEX",CurGPS->EventIndex);

	       ItemLink1("THRESH",CurDISC->Threshold);
	       ItemLink1("MASK",CurSCALER->Mask);
	       ItemLink2("DEADTIME",CurSCALER->StepWidth, CurSCALER->StepNumber);
	       ItemLink1("DEADTIMEENABLE",(TRUE_FALSE_t&)CurSCALER->DeadTimeEnable);

	       ItemLink1("CHANNEL",CurDMAD_CurCh->ID);
	       ItemLink1("MULT20ADDRESS" ,CurDMAD_CurCh->MULT20_Address);
	       ItemLink2("MULT20CHANNEL" ,
			 CurDMAD_CurCh->MULT20_Channel,
			 (ON_OFF_t&)CurDMAD_CurCh->DMAD_On);
	       ItemLink0("DMAD_OPSELECT");
	       ItemLink0("DMAD_OP");
	  }EndLinks;
     }EndItems(ConfigSection_t);
     SectionName("Modules");
private:
     ChannelModuleConfigRecord_p CreateModuleConfigRecord(const char *Type);
     ChannelModuleConfigRecordVector_t &ModuleConfig;
     ChannelModuleConfigRecord_p CurMod;
     ADCModuleConfigRecord_p CurADC;
     TDCModuleConfigRecord_p CurTDC;
     DISCModuleConfigRecord_p CurDISC;
     GPSModuleConfigRecord_p CurGPS;
     IREGModuleConfigRecord_p CurIREG;
     SCALERModuleConfigRecord_p CurSCALER;

     DMAD_ModuleConfigRecord_p  CurDMAD;
     int_inc_v                  CurDMAD_SelectedChannelIndexes;
     DMAD_ChannelConfigRecord_p CurDMAD_CurCh;
};


// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/** Class to provide an interface to copy the information from an
    config file into the internal representation (CrateConfig_t) for a
    crate for the readout section */
// ---------------------------------------------------------------------
class CrateSection_t:public ConfigSection_t
{
public:
     CrateSection_t(CrateConfigRecordVector_t &crateconfig):CrateConfig(crateconfig){}
protected:
     BeginItems(ConfigSection_t){
	  BeginActions{
	       ItemAction_SET("CRATE",
			      if((CurCrate=CreateCrateConfigRecord(Value))==0) return -1;
			      CrateConfig.push_back(CurCrate) 
		    );
	  }EndActions;
	  BeginLinks{
	       ItemLink1("CRATE" ,CurCrate->CrateType);
	       ItemLink1("ID"    ,CurCrate->CrateID);
	       ItemLink1("ENABLE",(TRUE_FALSE_t&)CurCrate->Enabled);
	       ItemLink1("CONN"  ,CurCrate->ConnectedTo);
	  }EndLinks;
     }EndItems(ConfigSection_t)
     SectionName("Crates");
private:
     CrateConfigRecord_p CreateCrateConfigRecord(const char *Type);
     CrateConfigRecordVector_t &CrateConfig;
     CrateConfigRecord_p CurCrate;
};

class ChannelSection:public ConfigSection_t
{
public:
     ChannelSection(ChannelConfigRecordVector_t &channelconfig):ChannelConfig(channelconfig){}
protected:
     BeginItems(ConfigSection_t){
	  BeginActions{
	       ItemAction_SET("CHANNEL",
			  CurCh=new ChannelConfigRecord_t;
			  ChannelConfig.push_back(CurCh);
		    );
	  }EndActions;
	  BeginLinks{
	       ItemLink1("CHANNEL",CurCh->ID);
	       ItemLink1("GROUP",(BEGIN_END_t &)CurCh->Group);
	       ItemLink2("STRING" ,CurCh->StringNumber,CurCh->StringPosition);
	       ItemLink2("SPECIAL",CurCh->SpecialINT,CurCh->SpecialString);
	       ItemLink3("SCALER",CurCh->SCALER_Id,CurCh->SCALER_Channel,(ON_OFF_t&)CurCh->SCALER_On);
	       ItemLink3("DISC"   ,CurCh->DISC_Id,CurCh->DISC_Channel,(ON_OFF_t&)CurCh->DISC_On);
	       ItemLink3("TDC"    ,CurCh->TDC_Id,CurCh->TDC_Channel,(ON_OFF_t&)CurCh->TDC_On);
	       ItemLink3("ADC"    ,CurCh->ADC_Id,CurCh->ADC_Channel,(ON_OFF_t&)CurCh->ADC_On);
	  }EndLinks;
     }EndItems(ConfigSection_t);
     SectionName("Channels");
private:
     ChannelConfigRecordVector_t &ChannelConfig;
     ChannelConfigRecord_p CurCh;
};


// HV Starts here

class HVChannelConfig_t
{
	friend class HV;
	friend class HVProps;
	friend class HVChannelSection;

	public:

		SetterGetter(ID_t, ID);
		SetterGetter(unsigned short, HVChannel);
		SetterGetter(unsigned short, StringNumber);
		SetterGetter(unsigned short, StringPosition);
		SetterGetter(int, Voltage);
		SetterGetter(int, LastVoltage);
		SetterGetter(int, TripCurrent);
		SetterGetter(int, RampSpeed);
		SetterGetter(bool, UserChange);
		SetterGetter(bool, Alarm);
		
	private:
		ID_t ID;
		unsigned short HVChannel;
		unsigned short StringNumber;
		unsigned short StringPosition;
		
		int Voltage;		// in V
		int LastVoltage;	// last measured voltage

		int TripCurrent;	// in mA
		int RampSpeed;		// in V/s

		// internal use only
		bool UserChange;	// indicate if user changed the channel
		bool Alarm;		// indicates an alarm
};

MAKE_REFCOUNT_POINTER (HVChannelConfig_t, HVChannelConfig_p);
MAKE_INC_VECTOR (HVChannelConfig_p, HVChannelConfigVector_t);

class HVChannelSection: public ConfigSection_t
{
public:
		HVChannelSection (vector<HVChannelConfig_p> &hvchannelconfig)
			:HVChannelConfig (hvchannelconfig)
		{
			CurrentChannel = 0;
		}
protected:
     BeginItems(ConfigSection_t){
	  BeginActions{
	       ItemAction_SET("PMT",
			CurrentChannel = new HVChannelConfig_t;
			HVChannelConfig.push_back (CurrentChannel);

			CurrentChannel->SetUserChange (false);
			CurrentChannel->SetAlarm (false);
		    )
	  }EndActions;
	  BeginLinks{
	       ItemLink1("PMT",CurrentChannel->ID);
	       ItemLink1("HVCHANNEL",CurrentChannel->HVChannel);
	       ItemLink2("STRING",CurrentChannel->StringNumber,CurrentChannel->StringPosition);
	       ItemLink1("VOLT",CurrentChannel->Voltage);
	       ItemLink1("TRIP",CurrentChannel->TripCurrent);
	       ItemLink1("RAMP",CurrentChannel->RampSpeed);
		
	  }EndLinks;
		
	  BeginActions{
	       ItemAction_SET("PMT",
			// *PN* 151097 this defaults the map channel
			// to the ID
			CurrentChannel->HVChannel = CurrentChannel->ID;
		    )
	  }EndActions;
     }EndItems(ConfigSection_t);
     SectionName("HVChannels");
private:
	vector<HVChannelConfig_p> &HVChannelConfig;
	HVChannelConfig_p CurrentChannel;
};
#endif // __HWCONFIGITEMS2_h__
