/*
$Header: /home/elrond/baikal/src/CVS/daq98/item.h,v 1.3 1998/11/23 14:43:22 haase Exp $
*/

#if !defined __ITEM_H__
#define __ITEM_H__ 

#include <config.h>
#include <String.h>
#include <stdlib.h>
#include <unistd.h>
#include "base.h"
#include "pointerutil.h"
#include "globalmacros.h"

/** this is the abstract base class for all classes that are used to
    store any form of information inside a container class, all
    derived classes must overwrite the clone function */
class ItemBase{
public:
     /** ctor */
     ItemBase(){}
     /** dtor, must be virtual */
     virtual ~ItemBase(){}
//      /** creates an exact copy of *this on the heap */
//      virtual ItemBase *clone() const =0;
     virtual const int GetType()const{ cerr << "falsche function\n";return -1;}
};

enum item_type {ITEM_LINK, ITEM_DATA };

class Item_Link:public ItemBase
{
public:
     Item_Link():ItemBase(){}
     Item_Link(const String &path):ItemBase(),lpath(path){}
//      Item_Link(const Item_Link &il):ItemBase(il),lpath(il.lpath){}
//      const Item_Link &operator=(const Item_Link &il) {lpath=il.lpath; return il;}
//      Item_Link *clone()const{return new Item_Link(*this);}
     virtual const int GetType()const{return ITEM_LINK;}
     const String &Path()const{return lpath;}
private:
     String lpath;
};

class Item_Data:public ItemBase{
public:
     Item_Data():ItemBase(){}
//      Item_Data(const Item_Data &):ItemBase(){}
     ~Item_Data(){}
     virtual const int GetType()const{return ITEM_DATA;}
};

/** this class is the base class for a tree item that supports to read
    and set the data members via a text identifier for the data
    member, this is usefule for reading the contents from a config
    file or for displaying an changing the data within a gui
    interface */
class ItemWithProperties
{
public:
     /** ctor */ 
     inline ItemWithProperties(){}
     /** dtor */
     virtual ~ItemWithProperties(){}
     /** returns the number of Properties of the class */
     inline int GetNoProperties() const{return numprops;}
     /** returns an array with the property identifiers */
     inline const String *GetPropertyNames()const{return Property;}
     /** returns the property with the identifier  Prop */
     virtual String GetProperty(const String &Prop)const{
   	  return GetPropertyByNo(GetPropertyNumber(Prop));
     }
     /** sets the property with the identifier Prop */
     virtual int SetProperty(const String &Prop,const String &val){
   	  return SetPropertyByNo(GetPropertyNumber(Prop),val);
     }
     /** sets the property with the Property number propnum , the
	 number can be claculated from the indentifier using the
	 GetPropertyNumber(..) member function */
     virtual int SetPropertyByNo(int propnum,const String &val)=0;
     /** returns the property with the property number propnum */
     virtual const String GetPropertyByNo(int)const{return "";}
     /** returns an ID strign for the class */
     virtual const String GetClassID()=0;
protected:
     /** sets the number and the  array of the property identifiers */ 
     void SetProperties(int NumProps,String *PropStr){ 
   	  numprops=NumProps;
   	  Property=PropStr;
     }
protected:
     /** returns the identifiing number of a property, calculated from
	 the property identifier */
     int GetPropertyNumber(const String &Prop) const{
   	  int propnum;
   	  for(propnum=0;propnum<numprops;propnum++){
   	       if(fcompare(Prop,Property[propnum])==0) break;
   	  }
   	  return propnum;
     }
private:
     /** array for the property identifiers */
     String *Property;
     /** number of properties */
     int numprops;
};

// inline ostream &operator <<(ostream &o,ItemWithProperties &iwp){
//      int index,imax=iwp.GetNoProperties();
//      o << imax;
//      for(index=0;index<imax;index++)
// 	  o << "\n" << iwp.GetPropertyByNo(index);
//      return o;
// }

// inline istream &operator >>(istream &i,ItemWithProperties &iwp){
//      char txt[MAX_TEXT_SIZE];
//      int imax,index;
//      i.getline(txt,MAX_TEXT_SIZE);
//      imax=atoi(txt);
//      for(index=0;index<imax;index++){
// 	  i.getline(txt,MAX_TEXT_SIZE);
// 	  iwp.SetPropertyByNo(index,txt);
//      }
//      return i;
// }

typedef PointerWrapper_Ref<ItemWithProperties> ItemWithProperties_p;

#endif //__ITEM_H__ 
