#if ! defined __K32MODULEEVAL_H__
#define __K32MODULEEVAL_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/k32moduleeval.h,v 1.4 1999/02/03 03:42:19 steffen Exp $
*/

#include <config.h>
#include "tdcmoduleeval.h"

class K32_TDCModuleEvalClass_t:public TDCModuleEvalClass_t
{
     enum 
     { 
	  NUMBER_OF_CHANNELS =32,
	  BYTES_PER_INFO_UNIT=4
     };
     ClassTypeInfo(TDCModuleEvalClass_t);
public:
     inline K32_TDCModuleEvalClass_t(DaqProcessBase *Parent)
	  :TDCModuleEvalClass_t(NUMBER_OF_CHANNELS,BYTES_PER_INFO_UNIT,Parent){}
protected:
     virtual const void* ReadFromBuffer(BinaryDataBuffer &DataBuffer){
	  static u_i32 Data;
	  DataBuffer.ReadFromBuffer(Data);
	  return (void*)&Data;
     }
     virtual inline int Channel(const void *tdc_data){
	  return ((*(u_i32*)tdc_data) >> 18) & 0x1F;
     }
     virtual inline int Edge(const void *tdc_data){
	  return ((*(u_i32*)tdc_data) >> 16) & 0x1;
     }
     virtual inline int TimeVal(const void *tdc_data){
	  return (*(u_i32*)tdc_data) & 0xFFFF;
     }
};

#endif // __K32MODULEEVAL_H__
