#if ! defined __MAILER_H__
#define __MAILER_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/mailer.h,v 1.3 1998/11/23 14:43:33 haase Exp $
*/

#include <config.h>
#include "simplevector.h"
#include "globalmacros.h"

/** An entry for the mailing list */
struct MailListEntry_t
{
     /** Recipients name */
     String Name;
     /** Recipients nick name */
     String NickName;
     /** Recipients mail address */
     String Address;
};

MAKE_INC_VECTOR(MailListEntry_t,MailList_t);

class Mailer_t
{
public:
     /** Constructor */
     Mailer_t();
     
     /** Destructor */
     ~Mailer_t();

     /** Add a recipient.
       @param Entry New recipient */
     void AddRecipient(MailListEntry_t Entry);
     
     /** Send mail.
	 @param Msg Mail msg to send
	 @param Subject Subject line for mail message
	 @return 0 on success, -1 on failure */
     int SendMail(const String Msg, 
		  const String Subject=DEFAULT_DAQ_MAIL_SUBJECT);
     
protected:
     MailList_t MailList;
     
};


#endif //__MAILER_H__
