#if ! defined __MOZILLAHELP_H__
#define __MOZILLAHELP_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/mozillahelp.h,v 1.3 1998/11/23 14:43:52 haase Exp $
*/

#include <config.h>
#include <String.h>
#include "mozilla_remote.h"

/** A class that provides a help function using the 
    Netscape browser */
class MozillaHelp
{
public:
     /** Constructor */
     MozillaHelp();

     /** Sets colormap value
       @param Val If true a private colormap will be used */
     void UseColorMap(bool Val);
     
     /** Displays a file in Netscape.
	 @param file Absolut path of file to display.
	 @return 0 on success, -1 on failure. */
     int DisplayFile(const String &file);
     
     /** Displays an URL in Netscape.
	 @param url of web page to display.
	 @return 0 on success, -1 on failure. */
     int DisplayURL(const String &url);

     /** Displays the page found at the given address.
	 The address given may be any valid web address,
	 including 'file:', 'ftp:', and 'http://' URLs.
	 @param address Adress of page to display
	 @return 0 on success, -1 on failure. */
     int DisplayPage(const String &address);
     
protected:
     /** A class that handles passing URLs to a running 
	 Netscape */
     MozillaRemote Mozilla;
     
     /** Flag that indicates that we started Netscape.
	 May be used later.*/
     bool Invoked;

     /** Colormap flag.
	 If true a private colormap will be used */
     bool ColorMap;
};

#endif // __MOZILLAHELP_H__
