/*
$Header: /home/elrond/baikal/src/CVS/daq98/processlink.C,v 1.2 1998/11/23 14:44:13 haase Exp $
*/

#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>
#include <fstream.h>
#include "process.h"
#include "processlink.h"

ProcessLink_type::ProcessLink_type(){
     stream_cin=0;
     stream_cout=0;
     stream_cerr=0;
}

ProcessLink_type::~ProcessLink_type(){
     if(stream_cin) delete stream_cin;
     if(stream_cout) delete stream_cout;
     if(stream_cerr) delete stream_cerr;
}


int ProcessLink_type::RunProcess(char *name,char *param1,char *param2,char *param3){
     OpenPipes();
     int ret;
     if(0==(ret=ThisProcess->Fork())){ //child
	  MakePipes2StdDescriptors();
	  execlp(name,name,param1,param2,param3,0);
     } else { // parent
	  CreateStreams();
     }
     return ret;
}


void ProcessLink_type::OpenPipes(){
     // create input channel of new process 
     pipe(pipe_cin);
     // create output channel of new process
     pipe(pipe_cout);
     // create error channel of new process
     pipe(pipe_cerr);
}

void ProcessLink_type::MakePipes2StdDescriptors(){
     close(pipe_cin[1]);
     dup2(pipe_cin[0],STDIN_FILENO);
     close(pipe_cout[0]);
     dup2(pipe_cout[1],STDOUT_FILENO);
     close(pipe_cerr[0]);
     dup2(pipe_cerr[1],STDERR_FILENO);
}

int ProcessLink_type::IsOutputWaiting(int fd){
     int num;
     ioctl(fd,FIONREAD,(char*)&num);
     return num;
}

void ProcessLink_type::CreateStreams(){
     close(pipe_cin[0]);
     stream_cin=new ofstream(pipe_cin[1]);
     close(pipe_cout[1]);
     stream_cout=new ifstream(pipe_cout[0]);
     stream_cout->setbuf(0,0);
     close(pipe_cerr[1]);
     stream_cerr=new ifstream(pipe_cerr[0]);
     stream_cerr->setbuf(0,0);
}
