/*
$Header: /home/elrond/baikal/src/CVS/daq98/processlink.h,v 1.4 1999/02/03 03:42:21 steffen Exp $
*/

#if !defined __PROCESSLINK_H__
#define __PROCESSLINK_H__

#include <config.h>
#include <fstream.h>
#include "daqprocessbase.h"

class ProcessLink_type:public DaqProcessBase
{
public:
     ProcessLink_type();
     ~ProcessLink_type();
     int RunProcess(char *name,char *param1=0,char *param2=0,char *param3=0);
     void SetQuitSequence(char *qs);
     ofstream &stdinput();
     ifstream &stdoutput();
     ifstream &erroutput();
     int IsOutputWaiting(int fd);

     int pipe_stdin_descriptor();
     int pipe_stdout_descriptor();
     int pipe_stderr_descriptor();
private:
     void OpenPipes();
     void MakePipes2StdDescriptors();
     void CreateStreams();
private:
     int  pipe_cin[2],pipe_cout[2],pipe_cerr[2];
     ofstream *stream_cin;
     ifstream *stream_cout;
     ifstream *stream_cerr;
};

inline ofstream &ProcessLink_type::stdinput(){
     return *stream_cin;
}
inline ifstream &ProcessLink_type::stdoutput(){
     return *stream_cout;
}
inline ifstream &ProcessLink_type::erroutput(){
     return *stream_cerr;
}
inline int ProcessLink_type::pipe_stdin_descriptor(){
     return pipe_cin[1];
}
inline int ProcessLink_type::pipe_stdout_descriptor(){
     return pipe_cout[0];
}
inline int ProcessLink_type::pipe_stderr_descriptor(){
     return pipe_cerr[0];
}

#endif //__PROCESSLINK_H__
