#if ! defined __REGISTER_H__
#define __REGISTER_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/register.h,v 1.8 1999/02/08 16:08:02 steffen Exp $
*/

// ------------------------------------------------------------------
//      DON'T CHANGE ANYTHING HERE
// ------------------------------------------------------------------

#include <config.h>
//////////////////////////////
// the module and crate classes
#include "channelmodule.h"

// TDCs
#include "dummytdcmodule.h"
#include "dummyrndtdcmodule.h"
#include "k32module.h"
#include "c3377tdcmodule.h"

// ADCs
#include "dummyadcmodule.h"
#include "dummyrndadcmodule.h"
#include "c7164adcmodule.h"

// DISCs
#include "dummydiscmodule.h"

#if ! defined DUMMY_MODULES_ONLY
#include "corbomodule.h"

// Scaler
#include "s7201module.h"
#include "sis3808module.h"

// GPSs
#include "camacgpsmodule.h"
#include "dummygpsmodule.h"
#include "camacgpsmodule97.h"
#include "vmegpsmodule.h"
#endif

// Input Register
#include "c63iregmodule.h"

// the crates
#include "dummycrate.h"

//////////////////////////////
// the module evaluation classes
// TDCs
#include "tdcmoduleeval.h"
#include "dummytdcmoduleeval.h"
#include "dummyrndtdcmodule.h"
#include "k32moduleeval.h"
#include "c3377moduleeval.h"

// ADCs
#include "adcmoduleeval.h"
#include "dummyadcmoduleeval.h"
#include "dummyrndadcmodule.h"
#include "c7164moduleeval.h"

// DISCs
#include "discmoduleeval.h"
#include "dummydiscmoduleeval.h"

// Scaler
#include "scalermoduleeval.h"

// DMAD
#include "dmadmodule.h"

#if ! defined DUMMY_MODULES_ONLY
#include "corbomodule.h"

// GPSs
#include "gpsmoduleeval.h"
#include "camacgpsmoduleeval.h"
#include "camacgpsmodule97eval.h"
#include "vmegpsmoduleeval.h"
#endif

// Input Register
#include "c63iregmoduleeval.h"

// DMAD
#include "dmadmoduleeval.h"



#if ! defined __REGISTER_H__EVALUATOR && defined __EVALUATOR__
#	undef __EVALUATOR__
# 	define  __REGISTER_H__EVALUATOR
#	define MODULE_CLASS_NAME  ModuleCreator_t_EVAL
# 	define RegisterModule(IDString,Type1_t,Type2_t,Type3_t) \
  	if(strcasecmp(Type,IDString)==0) return new Type2_t(Parent);
#else 
#	if ! defined  __REGISTER_H__CONFIGURATION && defined __CONFIGURATION__
#          	undef __CONFIGURATION__
# 		define __REGISTER_H__CONFIGURATION
#		define CRATE_CLASS_NAME CrateCreator_t_CONFIG
#		define MODULE_CLASS_NAME  ModuleCreator_t_CONFIG
# 		define RegisterCrate(IDString,Type1_t,Type2_t) \
  		if(strcasecmp(Type,IDString)==0) return new Type2_t;
# 		define RegisterModule(IDString,Type1_t,Type2_t,Type3_t) \
  		if(strcasecmp(Type,IDString)==0) return new Type3_t;
#	else 
#		if ! defined  __REGISTER_H__HWACCESS && defined __HWACCESS__
#        		undef __HWACCESS__
#			define  __REGISTER_H__HWACCESS
#			define CRATE_CLASS_NAME CrateCreator_t_HWACCESS
#			define MODULE_CLASS_NAME ModuleCreator_t_HWACCESS
# 			define RegisterCrate(IDString,Type1_t,Type2_t) \
  			if(strcasecmp(Type,IDString)==0) return new Type1_t;
# 			define RegisterModule(IDString,Type1_t,Type2_t,Type3_t) \
  			if(strcasecmp(Type,IDString)==0) return new Type1_t(Parent);
#		endif
#	endif
#endif

#if ! defined MODULE_CLASS_NAME

#error no include mode specified, use define MODE befor including \
register.h where MODE is __EVALUATOR__ for the moduel evaluator \
classes, __CONFIGURATION__ for the configuration classes or \
__HWACCESS__ for the harware access classes

#else


// ------------------------------------------------------------------
//     CHANGE  HERE
// ------------------------------------------------------------------
// remeber to backslashify the macros !!!!!!!!

// ------------------------------------------------------------------
// Insert new Crate classes  here
// ------------------------------------------------------------------
#if defined CRATE_CLASS_NAME
template <class crateclass>
struct CRATE_CLASS_NAME{
     crateclass *operator ()(const char *Type){
	  /*             Create ID    Crate Class */		
	  RegisterCrate("DummyCrate",DummyCrate_t,CrateConfigRecord_t);		
	  RegisterCrate("CAMACCrate",CAMAC_Crate_Class_t,CrateConfigRecord_t);
	  return 0;
     }
};

#define CrateCreator(ClassType__,TypeID__) CRATE_CLASS_NAME<ClassType__>()(TypeID__);

#endif


// ------------------------------------------------------------------
// Insert new Module classes  here
// ------------------------------------------------------------------
#if defined MODULE_CLASS_NAME
template <class modclass>
struct MODULE_CLASS_NAME{
     modclass *operator()(const char *Type, DaqProcessBase *Parent){/***/
	  Parent=Parent;
	  /*              Module ID      Module Class   Module Evaluator class */
	  RegisterModule("DummyTDC",
			 Dummy_TDCModule_t,
			 Dummy_TDCModuleEvalClass_t,
			 TDCModuleConfigRecord_t);

	  RegisterModule("RndDummyTDC",
			 RNDDummy_TDCModule_t,
			 Dummy_TDCModuleEvalClass_t,
			 TDCModuleConfigRecord_t);
	
 	  RegisterModule("C3377TDC",
 			 C3377_TDCModule_t,
 			 C3377_TDCModuleEvalClass_t, 
 			 TDCModuleConfigRecord_t); 
	
	  RegisterModule("S7201CNT",
			 S7201_ScalerModule_t,
			 ScalerModuleEvalClass_t,
			 SCALERModuleConfigRecord_t);
	
	  RegisterModule("S7201SCALER",
			 S7201_ScalerModule_t,
			 ScalerModuleEvalClass_t,
			 S7201ScalerConfigRecord_t);

	  RegisterModule("SIS3808SCALER",
			 SIS3808_ScalerModule_t,
			 ScalerModuleEvalClass_t,
			 SIS3808ScalerConfigRecord_t);

	  RegisterModule("DummyADC",
			 Dummy_ADCModule_t,
			 Dummy_ADCModuleEvalClass_t,
			 ADCModuleConfigRecord_t);

	  RegisterModule("RndDummyADC",
			 RNDDummy_ADCModule_t,
			 Dummy_ADCModuleEvalClass_t,
			 ADCModuleConfigRecord_t);

	  RegisterModule("C7164ADC",
			 C7164_ADCModule_t,
			 C7164_ADCModuleEvalClass_t,
			 ADCModuleConfigRecord_t);

	  RegisterModule("K32TDC",
			 K32_TDCModule,
			 K32_TDCModuleEvalClass_t,
			 TDCModuleConfigRecord_t);

	  RegisterModule("GpsDummy",
			 DummyGPSModuleClass_t,
			 CAMAC_GPSModuleEvalClass_t,
			 GPSModuleConfigRecord_t);

	  RegisterModule("CamacGps",
			 CAMAC_GPSModuleClass_t,
			 CAMAC_GPSModuleEvalClass_t,
                         GPSModuleConfigRecord_t);

          RegisterModule("CamacGps97",
                         CAMAC_GPSModule97Class_t,
			 CAMAC_GPSModule97EvalClass_t,
			 GPSModuleConfigRecord_t);

	  RegisterModule("VMEGps",
			 VME_GPSModuleClass_t,
			 VME_GPSModuleEvalClass_t,
			 GPSModuleConfigRecord_t);

	  RegisterModule("C63IREG",
			 C63_IREGModule_t,
			 C63_IREGModuleEvalClass_t,
			 IREGModuleConfigRecord_t);

	  RegisterModule("DummyDISC",
			 Dummy_DISCModule_t,
			 Dummy_DISCModuleEvalClass_t,
			 DISCModuleConfigRecord_t);

 	  RegisterModule("DMAD",
 			 DMAD_Module_t,
 			 DMAD_ModuleEvalClass_t,
 			 DMAD_ModuleConfigRecord_t);
	  return 0;
     }
};
   
#define ModuleCreator(ClassType__,TypeID__,CommParent__) \
MODULE_CLASS_NAME <ClassType__>()(TypeID__,CommParent__);

//#undef MODULE_CLASS_NAME
#endif
#endif

#endif __REGISTER_H__
