/*
  $Header: /home/elrond/baikal/src/CVS/daq98/runfilename.C,v 1.7 1999/02/08 16:08:02 steffen Exp $
  
  $Log: runfilename.C,v $
  Revision 1.7  1999/02/08 16:08:02  steffen
  *** empty log message ***

*/

#include <fstream.h>
#include <stdlib.h>
#include "runfilename.h"
#include "globalmacros.h"
#include "localdir.h"
#include "error.h"
#include "base.h"


int RunFileName_t::GetName(String &RunName, int flags)
{
     String cnf_file=FILENAME_RUNNUMBER;
     String cnf_files[4];
     cnf_files[0]="./" + cnf_file;
     char *path=getenv("HOME");
     if(path){
	  cnf_files[1]=path + String("/.") + String(PACKAGE) + 
	       "/" + cnf_file;
     }else{
	  cnf_files[1]="";
     } 
     path=getenv("DAQ_ROOT_DIR");
     if(path){
	  cnf_files[2]=path + String("/share/") + String(PACKAGE) + 
	       "/" + cnf_file;
     }else{
	  cnf_files[2]="";
     } 
     cnf_files[3]= String(DAQ_ROOT_DIR) + String("/share/") + 
	  String(PACKAGE) + "/" + cnf_file;
     ifstream infile;
     for(int i=0;i<4;i++){
	  infile.open(cnf_files[i]);
	  if(infile) {
	       String msg="Using run number file '" +
		    cnf_files[i] + "'.";
	       Parent->LogMsg(msg,3,3,INFO);
	       i=3;
	  }
     }
     if(!infile){
	  (*Base::Error)=SYS_ERROR;
	  (*Base::Error)="RunFileName_t::Increment";
	  String str="Can't open run number file '" + String(FILENAME_RUNNUMBER)+"'.";
	  Base::Error->SetParam(str);	  
	  return -1;
     }
     char txt[MAX_TEXT_SIZE];
     infile >> txt;
     struct tm tt,*t_ptr;
     t_ptr=&tt;
     time_t t;
     t=time(NULL);
     t_ptr=gmtime(&t);
     RunName="";
     if(flags & RUNYEAR){
	  char year_str[20];
	  int year=t_ptr->tm_year;
	  if (year>90) year+=1900;
	  else year+=2000;
	  sprintf(year_str,"%04d_",year);
	  RunName+=year_str;
     }
     if(flags & RUNDATE){
	  char day_str[20];
	  sprintf(day_str,"%03d_",t_ptr->tm_yday+1);
	  RunName+=day_str;
     }
     if(flags & RUNNUMBER){
	  int num=atoi(txt);
	  char num_str[20];
	  sprintf(num_str,"%04d",num);
	  RunName+= num_str;
     }
     
     return 0;
}

int RunFileName_t::Increment()
{
     String cnf_file=FILENAME_RUNNUMBER;
     String cnf_files[4];
     cnf_files[0]="./" + cnf_file;
     char *path=getenv("HOME");
     if(path){
	  cnf_files[1]=path + String("/.") + String(PACKAGE) + 
	       "/" + cnf_file;
     }else{
	  cnf_files[1]="";
     } 
     path=getenv("DAQ_ROOT_DIR");
     if(path){
	  cnf_files[2]=path + String("/share/") + String(PACKAGE) + 
	       "/" + cnf_file;
     }else{
	  cnf_files[2]="";
     } 
     cnf_files[3]= String(DAQ_ROOT_DIR) + String("/share/") + 
	  String(PACKAGE) + "/" + cnf_file;
     ifstream infile;
     int i;
     for(i=0;i<4;i++){
	  infile.open(cnf_files[i]);
	  if(infile) {
	       String msg="Using run number file '" +
		    cnf_files[i] + "'.";
	       Parent->LogMsg(msg,3,3,INFO);
	       i=3;
	  }
     }
     if(!infile){
	  (*Base::Error)=SYS_ERROR;
	  (*Base::Error)="RunFileName_t::Increment";
	  String str="Can't open run number file '" + String(FILENAME_RUNNUMBER)+"'.";
	  Base::Error->SetParam(str);	  
	  return -1;
     }
     char txt[MAX_TEXT_SIZE];
     infile.getline(txt,MAX_TEXT_SIZE);
     infile.close();
     unsigned int runnumber=atoi(txt);
     runnumber++;
     ofstream outfile(cnf_files[i]);
     if(!outfile){
	  (*Base::Error)=SYS_ERROR;
	  (*Base::Error)=FILENAME_RUNNUMBER;
	  (*Base::Error)="RunFileName_t::Increment";
	  String str="Can't open run number file '" + cnf_files[i] +"'.";
	  Base::Error->SetParam(str);	  
	  return -1;
     }
     outfile << runnumber << endl;
     return 0;
}

     
	       
