#if ! defined __RUNFILENAME_H__
#define  __RUNFILENAME_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/runfilename.h,v 1.5 1999/02/08 16:08:02 steffen Exp $
*/

#include <config.h>
#include <String.h>
#include <time.h>
#include "daqprocessbase.h"

/** Class that produces a name out of a run number and the date */
class RunFileName_t
{
public:
     enum
     {
	  RUNNUMBER=0x1,
	  RUNDATE=0x2,
	  RUNYEAR=0x4
     };
     
     /** Constructor */
     RunFileName_t(DaqProcessBase *p):Parent(p){};
     
     /** Gets the name.
	 The name is produced from a run number that is keept
	 in a file (see {\tt \Ref{FILENAME_RUNNUMBER}} in {\tt globalmacros.h})
	 and the date.
	 @param RunName run name
	 @param flags 
	 @return 0 on success, -1 on failure. */
     int GetName(String &RunName,int flags=RUNYEAR|RUNNUMBER|RUNDATE);

     /** Increments the runnumber
	 @return 0 on success, -1 on failure. */
     int Increment();

protected:
     DaqProcessBase *Parent;
};



#endif // __RUNFILENAME_H__
