/*
  $Header: /home/elrond/baikal/src/CVS/daq98/runstartwidget.C,v 1.4 1999/01/27 13:28:00 daq Exp $
*/

#include "moniclient.h"
#include "runstartwidget.h"

RunStartWidget::RunStartWidget(MonitorClient *daddy, QWidget *mommy=0,const char *name=0)
     :QWidget(mommy,name){
     setCaption("AMANDA Run start");
     setIcon(QPixmap(DAQ_ICON));
     
     MC=daddy;
     
     RunParams_label=new QLabel("Run Parameter:",this);
     RunParams=new QLineEdit(this);
     QuitButton=new QPushButton("&Quit",this);
     connect(QuitButton,SIGNAL(clicked()),SLOT(SL_Quit()));
     AdvancedButton=new QPushButton("&Advanced",this);
     connect(AdvancedButton,SIGNAL(clicked()),SLOT(SL_Advanced()));
     InitButton=new QPushButton("&Init Run",this);
     connect(InitButton,SIGNAL(clicked()),SLOT(SL_InitRun()));
     StartRunAllButton=new QPushButton("&Start Run",this);
     connect(StartRunAllButton,SIGNAL(clicked()),SLOT(SL_StartRunAll()));
     StopRunAllButton=new QPushButton("&Stop Run",this);
     connect(StopRunAllButton,SIGNAL(clicked()),SLOT(SL_StopRunAll()));
     HelpButton=new QPushButton("&Help",this);
     connect(HelpButton,SIGNAL(clicked()),SLOT(SL_Help()));
     

     ExecDataprocessButton=new QPushButton("Exec Dataprocess",this);
     connect(ExecDataprocessButton,SIGNAL(clicked()),SLOT(SL_ExecDataProcess()));
     ExecDataCollectorButton=new QPushButton("Exec Datacollector",this);
     connect(ExecDataCollectorButton,SIGNAL(clicked()),SLOT(SL_ExecDataCollector()));
     ExecDataTransportButton=new QPushButton("Exec Datatransport",this);
     connect(ExecDataTransportButton,SIGNAL(clicked()),SLOT(SL_ExecDataTransport()));

     InitDataTransportButton=new QPushButton("Init Datatransport",this);
     connect(InitDataTransportButton,SIGNAL(clicked()),SLOT(SL_InitDataTransport()));
     InitDataProcessButton=new QPushButton("Init Dataprocess",this);
     connect(InitDataProcessButton,SIGNAL(clicked()),SLOT(SL_InitDataProcess()));
     InitDataCollectorButton=new QPushButton("Init Datacollector",this);
     connect(InitDataCollectorButton,SIGNAL(clicked()),SLOT(SL_InitDataCollector()));

     StartDataTransportButton=new QPushButton("Start Datatransport",this);
     connect(StartDataTransportButton,SIGNAL(clicked()),SLOT(SL_StartDataTransport()));
     StopDataTransportButton=new QPushButton("Stop Datatransport",this);
     connect(StopDataTransportButton,SIGNAL(clicked()),SLOT(SL_StopDataTransport()));
     StartRunButton=new QPushButton("Start Run",this);
     connect(StartRunButton,SIGNAL(clicked()),SLOT(SL_StartRun()));
     StopRunButton=new QPushButton("Stop Run",this);
     connect(StopRunButton,SIGNAL(clicked()),SLOT(SL_StopRun()));

     QuitDataprocessButton=new QPushButton("Quit Dataprocess",this);
     connect(QuitDataprocessButton,SIGNAL(clicked()),SLOT(SL_QuitDataProcess()));
     QuitDatatransportButton=new QPushButton("Quit Datatransport",this);
     connect(QuitDatatransportButton,SIGNAL(clicked()),SLOT(SL_QuitDataTransport()));
     QuitDatacollectorButton=new QPushButton("Quit Datacollector",this);
     connect(QuitDatacollectorButton,SIGNAL(clicked()),SLOT(SL_QuitDataCollector()));

     ScriptButton=new QPushButton("Run Script",this);
     connect(ScriptButton,SIGNAL(clicked()),SLOT(SL_RunScript()));
     AdvancedFlag=FALSE;
     int HS=10, VS=10, BW=90,BH=25;
     DefaultWidth=HS+BW+HS+BW+HS+BW+HS+HS+BW+HS;
//     DefaultWidth=HS+90+HS+160+HS+BW+HS;
     DefaultSimpleHeight=VS+BH+VS+BH+VS+VS+BH+VS;
}

void RunStartWidget::show()
{
  setMinimumWidth(DefaultWidth);
  setMaximumHeight(DefaultSimpleHeight);
  setMinimumHeight(DefaultSimpleHeight);
  AdvancedFlag=true;
  SL_Advanced();
  QWidget::show();
}

void RunStartWidget::SetGeometry()
{
     int HS=10, VS=10, BW=90,BH=25;
     int X=HS,Y=10, W;
     W=90;
     X=width()-HS-BW;
     HelpButton->setGeometry(X,Y,BW,BH);
     X=HS;
     InitButton->setGeometry(X,Y,BW,BH);
     X=HS+BW+HS;
     StartRunAllButton->setGeometry(X,Y,BW,BH);
     X=HS+BW+HS+BW+HS;
     StopRunAllButton->setGeometry(X,Y,BW,BH);
     Y=VS+BH+VS;
     X=width()-HS-BW;
     AdvancedButton->setGeometry(X,Y,BW,BH);
     
     int AO;
     if(AdvancedFlag) {
	  Y=VS+BH+VS;
	  X=HS;
	  RunParams_label->setGeometry(X,Y,W,BH);
	  X=HS+RunParams_label->width()+HS;
	  W=width()-X-HS-BW-HS-HS;
     
	  RunParams->setGeometry(X,Y,W,BH);
	  
	  int ABW=(width()-2*HS-2)/3;
	  AO=5*(BH + 1);
	  
	  // row one ////////
	  X=HS;
	  Y=VS+BH+VS+BH+VS;
	  ExecDataprocessButton->setGeometry(X,Y,ABW,BH);
	  ExecDataCollectorButton->setGeometry(X+ABW+1,Y,ABW,BH);
	  ExecDataTransportButton->setGeometry(X+2*ABW+2,Y,ABW,BH);
	  
	  //row two /////////
	  Y+=BH;
	  InitDataCollectorButton->setGeometry(X,Y,ABW,BH);
	  InitDataTransportButton->setGeometry(X+ABW+1,Y,ABW,BH);
	  InitDataProcessButton->setGeometry(X+2*ABW+2,Y,ABW,BH);
	  
	  //row three //////
	  Y+=BH;
	  StartDataTransportButton->setGeometry(X,Y,ABW,BH);
	  StartRunButton->setGeometry(X+ABW+1,Y,ABW,BH);  
	  StopRunButton->setGeometry(X+2*ABW+2,Y,ABW,BH);
	  
	  //row four ///////
	  Y+=BH;
	  StopDataTransportButton->setGeometry(X,Y,ABW,BH);
	  QuitDataprocessButton->setGeometry(X+ABW+1,Y,ABW,BH);
	  QuitDatatransportButton->setGeometry(X+2*ABW+2,Y,ABW,BH);  

	  //row five //////
	  Y+=BH;
	  QuitDatacollectorButton->setGeometry(X,Y,ABW,BH);
	  ScriptButton->setGeometry(X+ABW+1,Y,ABW,BH);

	  
	  RunParams_label->show();
	  RunParams->show();
	  ExecDataprocessButton->show();
	  ExecDataTransportButton->show();
	  ExecDataCollectorButton->show();
	  
	  InitDataCollectorButton->show();
	  InitDataTransportButton->show();
	  InitDataProcessButton->show();


	  StartDataTransportButton->show();
	  StartRunButton->show();
	  StopRunButton->show();

	  StopDataTransportButton->show();
	  QuitDataprocessButton->show();
	  QuitDatatransportButton->show();

	  QuitDatacollectorButton->show();
	  ScriptButton->show();

	  AdvancedButton->setText("S&imple");
     } else {
	  AO=0;
	  X=HS;
	  
	  RunParams_label->hide();
	  RunParams->hide();

	  ExecDataprocessButton->hide();
	  ExecDataTransportButton->hide();
	  ExecDataCollectorButton->hide();
	  
	  InitDataCollectorButton->hide();
	  InitDataTransportButton->hide();
	  InitDataProcessButton->hide();


	  StartDataTransportButton->hide();
	  StartRunButton->hide();
	  StopRunButton->hide();

	  StopDataTransportButton->hide();
	  QuitDataprocessButton->hide();
	  QuitDatatransportButton->hide();

	  QuitDatacollectorButton->hide();
	  ScriptButton->hide();

	  AdvancedButton->setText("&Advanced");
     }
     Y=VS+BH+VS+BH+VS+VS+AO;
     X=width()-HS-BW;
     QuitButton->setGeometry(X,Y,BW,BH);
}

void RunStartWidget::SL_Help()
{
     MC->Help("runstarthint.html");
}

void RunStartWidget::SL_Advanced()
{
     RunParams->setText(MC->GetDefaultRunParams());
     AdvancedFlag=AdvancedFlag?FALSE:TRUE;
     int AO=AdvancedFlag?5*25:0;
     
     int X=x();
     int Y=y();
     setGeometry(X,Y,DefaultWidth,DefaultSimpleHeight+AO);
     setMinimumHeight(DefaultSimpleHeight+AO);
     setMaximumHeight(DefaultSimpleHeight+AO);
}

void RunStartWidget::SL_Quit()
{
     close();
}

void RunStartWidget::SL_InitRun()
{
     MC->SL_InitRun();
}

void RunStartWidget::SL_StartRunAll()
{
     MC->SL_StartRunAll();
}

void RunStartWidget::SL_StopRunAll()
{
     MC->SL_StopRunAll();
}

void RunStartWidget::SL_RunScript()
{
     MC->SL_RunScript();
}

void RunStartWidget::resizeEvent(QResizeEvent *)
{
     SetGeometry();
}

void RunStartWidget::SL_ExecDataProcess()
{
     MC->SL_StartDataProcess();
}

void RunStartWidget::SL_ExecDataCollector()
{
     MC->SL_StartDataCollector();
}

void RunStartWidget::SL_QuitDataCollector()
{
     MC->SL_QuitDataCollector();
}


void RunStartWidget::SL_StartRun()
{
     MC->SL_StartRun();
}

void RunStartWidget::SL_StopRun()
{
     MC->SL_StopRun();
}

void RunStartWidget::SL_InitDataProcess()
{
     MC->SetInitParams(RunParams->text());
     MC->SL_InitDataProcess();
}

void RunStartWidget::SL_InitDataCollector()
{
     MC->SL_InitDataCollector();
}

void RunStartWidget::SL_QuitDataProcess()
{
     MC->SL_QuitDataProcess();
}

void RunStartWidget::SL_ExecDataTransport()
{
     MC->SL_StartDataTransport();
} 

void RunStartWidget::SL_StartDataTransport()
{
     MC->SL_RunDataTransport();
} 

void RunStartWidget::SL_StopDataTransport()
{
     MC->SL_StopDataTransport();
} 

void RunStartWidget::SL_QuitDataTransport()
{
     MC->SL_QuitDataTransport();
}

void RunStartWidget::SL_InitDataTransport()
{
     MC->SL_InitDataTransport();
} 
