#if ! defined __SCALERMODULE_H__
#define __SCALERMODULE_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/scalermodule.h,v 1.3 1999/02/10 17:31:46 daq Exp $

  $Log: scalermodule.h,v $
  Revision 1.3  1999/02/10 17:31:46  daq
   Version 1.310

  Revision 1.2  1999/02/10 11:59:51  steffen
  added config flags, sn vmegps output

  Revision 1.1  1999/02/05 18:35:08  steffen
  * Major cleanup:
    - threw out code for binary config records
    - cleaned up some module classes
  * Fixed bug which prevent 32 bit values to be read correctly from
    detector cnf
  * Added masking to s7201 module

*/

#include "channelmodule.h"

/*---------------------------------------------------------*/
/*                                                         */
/*      Scaler configuration data structure base type      */
/*                                                         */
/*---------------------------------------------------------*/
/** Configuration data structure for scaler modules. */
struct SCALERModuleConfigRecord_t:public ChannelModuleConfigRecord_t{
     ClassTypeInfo(ChannelModuleConfigRecord_t);
     
     /** Constructor */
     SCALERModuleConfigRecord_t();
     
     /** Destructor */
     virtual ~SCALERModuleConfigRecord_t();
     
     /** Channel Mask.
      Each bit corresponds to on of the 32 channels and sets it on or off.*/
     u_i32 Mask;

     /** Step width */
     u_i32 StepWidth;
     
     /** Stepnumber */
     u_i32 StepNumber;

     /** Deadtime enable */
     u_i32 DeadTimeEnable;
};

MAKE_REFCOUNT_POINTER(SCALERModuleConfigRecord_t,SCALERModuleConfigRecord_p);

/*---------------------------------------------------------*/
/*                                                         */
/*  SCALER module base class                                  */
/*                                                         */
/*---------------------------------------------------------*/

/** Base class for SCALER module classes */
class SCALERModuleClass_t: public ChannelModuleBaseClass_t
{
     ClassTypeInfo(ChannelModuleBaseClass_t);
public:
     /** Constructor.
	 @param numChannels Number of channels of this module
	 @param BytesPerInfoUnit Number of bytes per info unit (bytes per channel)
	 @param parent Pointer to parent class. Used for sending messages in Parent context. */
     SCALERModuleClass_t(int numChannels,int BytesPerInfoUnit, DaqProcessBase *parent);
};

MAKE_REFCOUNT_POINTER(SCALERModuleClass_t, SCALERModuleClass_p);
#endif // __SCALERMODULE_H__
