/*
  $Header: /home/elrond/baikal/src/CVS/daq98/statusdispl.C,v 1.4 1998/11/23 14:44:36 haase Exp $
*/

/*
  $Log: statusdispl.C,v $
  Revision 1.4  1998/11/23 14:44:36  haase
  -- major changes in event building and histogramming to make it faster
  -- minor class structure changes
  -- sorry for late commit, but cvs at SP is almost impossible!

  Revision 1.3  1998/11/03 06:43:56  daq
  merged pamanda2 and pamanda3 versions

  Revision 1.2  1998/07/27 23:59:12  steffen
  OSF specific changes

  Revision 1.1  1998/06/29 05:16:30  daq
  Added Files:
  	cursesstatusdispl.C cursesstatusdispl.h statusdispl.C
  	statusdispl.h

*/

#include <config.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include "statusdispl.h"


char *StatusDisplay_t::Time2ETAStr(time_t Time)
{
  static char Ret[124];
  if(Time>90060){
    strcpy(Ret,"ETA: --:--");
    return Ret;
  }
  int Hour=Time/3600;
  Time=Time%3600;
  int Min=Time/60;
  Time=Time%60;
  if(Hour){
    sprintf(Ret,"ETA: %02i:%02i:%02li",Hour,Min,Time); 
  }else{
    sprintf(Ret,"ETA: %02i:%02li",Min,Time); 
  }    
  return Ret;
}

char *StatusDisplay_t::Bytes2Str(unsigned int NumBytes)
{
     static char Ret[124];
     if(NumBytes>1024*1024*1024){
	  sprintf(Ret,"%3.2f GBytes",(float)NumBytes/(1024*1024*1024));
     }
     else if(NumBytes>1024*1024){
	  sprintf(Ret,"%3.2f MBytes",(float)NumBytes/(1024*1024));
     }
     else if(NumBytes>1024){
	  sprintf(Ret,"%3.2f KBytes",(float)NumBytes/(1024));
     }
     else {
	  sprintf(Ret,"%i Bytes",NumBytes);
     }
     return Ret;
}

	  
	      
