/*
$Header: /home/elrond/baikal/src/CVS/daq98/stringutil.h,v 1.5 1999/02/05 18:35:08 steffen Exp $
*/

#if ! defined __STRINGUTIL_H__
#define __STRINGUTIL_H__
#include <config.h>
#include <String.h>
#include <stdlib.h>
#include "base.h"
#include "globalfunctions.h"

extern Regex MyRxWhite;
extern Regex RXinthex;
extern Regex RXQuote;
extern Regex RXEscQuote;
extern Regex RLeadZeros;
extern Regex RZeros;

/** converts a string to an integer, handling hex and dec 
    numbers as well as leading zeros */
long hstrtol(String t);

/** converts a string to an integer, handling hex and dec 
    numbers as well as leading zeros */
unsigned long hstrtoul(String t);

/** function object to split a path into its components */
class StringSplitter
{
public:
     /* default ctor */
     StringSplitter(){
	  SplitTxt=0;
	  numsplit=0;
     }       
     /** constructor, and splitter */
     StringSplitter(const String &txt,char separator){
	  Split(txt,separator);
     }
     /** dtor */
     ~StringSplitter(){
	  if(SplitTxt) delete[] SplitTxt;
     }
     /** returns the array of the path components */
     String *operator()(){
	  return SplitTxt;
     }
     /** returns the number of the path components */
     int NumSplits(){
	  return numsplit;
     }
protected:
     /** splitting */
     void Split(const String &txt,char separator){
	  String temptxt=txt;
	  bool quote=false;
	  if(separator==temptxt[0]) temptxt=temptxt.after(0);
	  for(unsigned int i=0;i<temptxt.length();i++) {
	       if(temptxt.contains(RXQuote,i)&&temptxt[i]=='"')
		  {
		       quote=true;
		       String S1=temptxt.before((int)i);
		       String QuoteStr=temptxt.at(RXQuote,i);
		       String S2=temptxt.after(RXQuote,(int)i);
	       
		       QuoteStr.gsub(" ","__&space&__");
		       QuoteStr.gsub("\t","__&tab&__");
		       QuoteStr.gsub("\r","__&return&__");
		       QuoteStr.gsub("\n","__&newline&__");
		       temptxt=S1+QuoteStr+S2;
		       i+=2;
		  }
	  }
	  
	  numsplit=temptxt.freq(separator)+1;
	  SplitTxt=new String[numsplit];
	  split(temptxt,SplitTxt,numsplit,separator);	     
	  if(quote){
	       for(int i=0;i<numsplit;i++){
		    SplitTxt[i].gsub("__&space&__"," ");
		    SplitTxt[i].gsub("__&tab&__","\t");
		    SplitTxt[i].gsub("__&return&__","\r");
		    SplitTxt[i].gsub("__&newline&__","\n");
	       }
	  }
	  
     }
private:
     /** pointer to the array of the splitte path */
     String *SplitTxt;
     /** holder of the pathlangth */
     int numsplit;
};     

/** function object to compare two strings */
struct StringCompare
{
public:
     bool operator()(const String &s1,const String &s2) const{
	  return fcompare(s1,s2)<0;
     }
};

//---------------------------------------------------------------
inline int ConvertToString(String &sVal,char *val){
     sVal=String(val);
     return 0;
}

inline int ConvertFromString(const String &sVal,char *&val){
     if(val!=0) delete val;
     val=new char[sVal.length()+1];
     strcpy(val,(const char*)sVal);
     return 0;
}
//---------------------------------------------------------------
inline int ConvertToString(String &sVal,int val){
     sVal=ltoasc(val);
     return 0;
}

inline int ConvertFromString(const String &sVal,int &val){
     if((!sVal.matches(RXint))&&(!sVal.matches(RXinthex))) return -1;
     val=hstrtol(sVal);
     return 0;
}
//---------------------------------------------------------------
inline int ConvertToString(String &sVal,long int val){
     sVal=ltoasc(val);
     return 0;
}

inline int ConvertFromString(const String &sVal,long int &val){
     if((!sVal.matches(RXint))&&(!sVal.matches(RXinthex))) return -1;
     val=hstrtol(sVal);
     return 0;
}
//---------------------------------------------------------------
inline int ConvertToString(String &sVal,unsigned long int val){
     sVal=ltoasc(val);
     return 0;
}

inline int ConvertFromString(const String &sVal,unsigned long int &val){
     if((!sVal.matches(RXint))&&(!sVal.matches(RXinthex))) return -1;
     val=hstrtoul(sVal); 
     return 0;
}
//---------------------------------------------------------------
inline int ConvertToString(String &sVal,short int val){
     sVal=ltoasc(val);
     return 0;
}

inline int ConvertFromString(const String &sVal,short int &val){
     if((!sVal.matches(RXint))&&(!sVal.matches(RXinthex))) return -1;
     val=hstrtol(sVal);
     return 0;
}
//---------------------------------------------------------------
inline int ConvertToString(String &sVal,unsigned int val){
     sVal=ltoasc(val);
     return 0;
}

inline int ConvertFromString(const String &sVal,unsigned  &val){
     if((!sVal.matches(RXint))&&(!sVal.matches(RXinthex))) return -1;
     val=hstrtoul(sVal);
     return 0;
}
//---------------------------------------------------------------
inline int ConvertToString(String &sVal,unsigned short int val){
     sVal=ltoasc(val);
     return 0;
}

inline int ConvertFromString(const String &sVal,unsigned short int &val){
     if((!sVal.matches(RXint))&&(!sVal.matches(RXinthex))) return -1;
     val=hstrtol(sVal);
     return 0;
}
//---------------------------------------------------------------
inline int ConvertToString(String &sVal,signed char val){
     sVal=ltoasc(val);
     return 0;
}

inline int ConvertFromString(const String &sVal,signed char &val){
     if((!sVal.matches(RXint))&&(!sVal.matches(RXinthex))) return -1;
     val=hstrtol(sVal);
     return 0;
}
//---------------------------------------------------------------
inline int ConvertToString(String &sVal,unsigned char val){
     sVal=ltoasc(val);
     return 0;
}

inline int ConvertFromString(const String &sVal,unsigned char &val){
     if((!sVal.matches(RXint))&&(!sVal.matches(RXinthex))) return -1;
     val=hstrtol(sVal);
     return 0;
}
//---------------------------------------------------------------
inline int ConvertToString(String &sVal,String &val){
     sVal=val;
     return 0;
}

inline int ConvertFromString(const String &sVal,String &val){
     val=sVal;
     return 0;
}

#define TEXT_TRUE   "TRUE"
#define TEXT_FALSE  "FALSE"

#define TEXT_ON     "ON"
#define TEXT_OFF    "OFF"

#define TEXT_BEGIN  "BEGIN"
#define TEXT_END    "END"
#define TEXT_NONE   "NONE"

enum ON_OFF_t{
     OFF_val=0,
     ON_val=1
};

enum BEGIN_END_t{
     BEGIN_val=0,
     END_val=1,
     NONE_val=2
};

enum TRUE_FALSE_t{
     FALSE_val=0,
     TRUE_val=1
};



//---------------------------------------------------------------
inline int ConvertToString(String &sVal,BEGIN_END_t val){
     if(val==0) sVal=TEXT_BEGIN;
     else if(val==1) sVal=TEXT_END;
     else sVal=TEXT_NONE;
     return 0;
}
inline int ConvertFromString(const String &sVal,BEGIN_END_t &val){
     if(fcompare(sVal,TEXT_BEGIN)==0) val=BEGIN_val;
     else if(fcompare(sVal,TEXT_END)==0) val=END_val;
     else val=NONE_val;
     return 0;
}

//---------------------------------------------------------------
inline int ConvertToString(String &sVal,TRUE_FALSE_t val){
     if(val) sVal=TEXT_TRUE;
     else sVal=TEXT_FALSE;
     return 0;
}
inline int ConvertFromString(const String &sVal,TRUE_FALSE_t &val){
     if(fcompare(sVal,TEXT_TRUE)==0) val=TRUE_val;
     else val=FALSE_val;
     return 0;
}

//---------------------------------------------------------------
inline int ConvertToString(String &sVal,ON_OFF_t val){
     if(val) sVal=TEXT_ON;
     else sVal=TEXT_OFF;
     return 0;
}

inline int ConvertFromString(const String &sVal,ON_OFF_t &val){
     if(fcompare(sVal,TEXT_ON)==0) val=ON_val;
     else val=OFF_val;
     return 0;
}

//---------------------------------------------------------------
/* 
inline int ConvertToString(String &sVal,const Type val){
}
inline int ConvertFromString(const String &sVal,Type &val){
} 
*/

#endif __STRINGUTIL_H__
