#if ! defined __TDCMODULE_H__
#define __TDCMODULE_H__

/*
  $Header: /home/elrond/baikal/src/CVS/daq98/tdcmodule.h,v 1.5 1999/02/05 18:35:08 steffen Exp $

  $Log: tdcmodule.h,v $
  Revision 1.5  1999/02/05 18:35:08  steffen
  * Major cleanup:
    - threw out code for binary config records
    - cleaned up some module classes
  * Fixed bug which prevent 32 bit values to be read correctly from
    detector cnf
  * Added masking to s7201 module

*/

#include <config.h>
#include "channelmodule.h"

/*---------------------------------------------------------*/
/*                                                         */
/*  TDC module configuration data structure                */
/*                                                         */
/*---------------------------------------------------------*/

/** Configuration data structure for TDC modules */
struct TDCModuleConfigRecord_t:public ChannelModuleConfigRecord_t
{
     ClassTypeInfo(ChannelModuleConfigRecord_t);

     /** Constructor */
     TDCModuleConfigRecord_t();
     
     /** Destructor */
     virtual ~TDCModuleConfigRecord_t();
     
     /** Number of possible hits per channel */
     u_i16 NHit;

     /** ?? */
     u_i16 Win;

     /** ?? */
     char *Mode;
};

MAKE_REFCOUNT_POINTER(TDCModuleConfigRecord_t,TDCModuleConfigRecord_p);

/*---------------------------------------------------------*/
/*                                                         */
/*  TDC module base class                                  */
/*                                                         */
/*---------------------------------------------------------*/

/** Base class for TDC module classes */
class TDCModuleClass_t: public ChannelModuleBaseClass_t
{
     ClassTypeInfo(ChannelModuleBaseClass_t);
public:
     /** Constructor.
	 @param numChannels Number of channels of this module
	 @param BytesPerInfoUnit Number of bytes per info unit (bytes per channel)
	 @param parent Pointer to parent class. Used for sending messages in Parent context. */
     TDCModuleClass_t(int numChannels,int BytesPerInfoUnit, DaqProcessBase *parent);
};

MAKE_REFCOUNT_POINTER(TDCModuleClass_t, TDCModuleClass_p);

#endif // __TDCMODULE_H__
