/*
$Header: /home/elrond/baikal/src/CVS/daq98/transferclass.h,v 1.3 1998/11/23 14:44:45 haase Exp $
*/

#if ! defined __TRANSFERCLASS_H__
#define __TRANSFERCLASS_H__

#include <config.h>
#include <string.h>
#include "base.h"
#include "error.h"
#include "socketclass.h"

template<class T>
class TransferClass:public Base
{
public:
     TransferClass(IOSocket &s):
	  TransSocket(&s){
     }       
     ~TransferClass(){
     }
     int Send(T &Object){
	  int ret;
	  // sync with the reciever object
	  TEST_FAILURE(SyncSend());
	  // send the data
	  ret=Object.Serialize((*TransSocket).OutputStream());
	  (*TransSocket).OutputStream() << flush;
	  TEST_FAILURE(SyncRecv());
	  return ret;	  
     }
     int Recv(T &Object){
	  int ret;
	  // sunc with the send object
	  TEST_FAILURE(SyncRecv());
	  // recieving the data
	  ret=Object.Deserialize((*TransSocket).InputStream());	
	  TEST_FAILURE(SyncSend());
	  return ret;
     }     
protected:
     // for synchronisation
     int SyncSend(){
	  TEST_FAILURE((*TransSocket).WriteText(" \r\nSynchronisation\r\n"));
	  char *t;
	  do{
	       TEST_FAILURE((t=(*TransSocket).ReadText())==0?-1:0);
	  } while(strcmp(t,"Synchronisation\r\n")!=0);
	  return 0;
     }
     int SyncRecv(){
	  char *t;
	  do{
	       TEST_FAILURE((t=(*TransSocket).ReadText())==0?-1:0);
	  } while(strcmp(t,"Synchronisation\r\n")!=0);
	  TEST_FAILURE((*TransSocket).WriteText(" \r\nSynchronisation\r\n"));
	  return 0;
     }
     IOSocket *TransSocket;
};

template <class T>
class TransferPipe:public Base{     
public:
     TransferPipe(IOSocket &fSocket,IOSocket &tSocket):
	  fromSocket(fSocket),toSocket(tSocket){}
     int DoPipe(){
	  int ret=0;
	  TEST_FAILURE(SyncRecv(fromSocket));
	  TEST_FAILURE(SyncSend(toSocket));
	  ret=T::Pipe(fromSocket.InputStream(),toSocket.OutputStream());
	  toSocket.OutputStream() << flush;
	  TEST_FAILURE(SyncRecv(toSocket));
	  TEST_FAILURE(SyncSend(fromSocket));	  
	  return ret;
     }
private:
     int SyncSend(IOSocket &Socket){
	  TEST_FAILURE(Socket.WriteText(" \r\nSynchronisation\r\n"));
	  char *t;
	  do{
	       TEST_FAILURE((t=Socket.ReadText())==0?-1:0);
	  } while(strcmp(t,"Synchronisation\r\n")!=0);
	  return 0;
     }
     int SyncRecv(IOSocket &Socket){
	  char *t;
	  do{
	       TEST_FAILURE((t=Socket.ReadText())==0?-1:0);
	  } while(strcmp(t,"Synchronisation\r\n")!=0);
	  TEST_FAILURE(Socket.WriteText(" \r\nSynchronisation\r\n"));
	  return 0;
     }
     IOSocket &fromSocket,&toSocket;
};


#endif __TRANSFERCLASS_H__
