#include "pointerutil.h"
#include "datafilecode.h"

/////////////////////
// module classes

// Channel module base class
#include "channelmodule.C"

// TDCs
#include "dummytdcmodule.h"
#include "dummyrndtdcmodule.h"
#include "k32module.h"
#include "c3377tdcmodule.h"

// ADCs
#include "dummyadcmodule.h"
#include "dummyrndadcmodule.h"
#include "c7164adcmodule.h"

// DISCs
#include "dummydiscmodule.h"

// GPSs
#include "gpsmodule.h"
#include "dummygpsmodule.h"
#include "camacgpsmodule.h"
#include "camacgpsmodule97.h"
#include "vmegpsmodule.h"

// Scaler
#include "s7201module.h"
#include "sis3808module.h"

// Input Register
#include "c63iregmodule.h"



////////////////////
// module evaluation classes

// base classes
#include "moduleevalbase.h"
#include "tdcmodule.h"
#include "adcmodule.h"
#include "discmodule.h"

// TDCs
#include "tdcmoduleeval.h"
#include "dummytdcmoduleeval.h"
#include "k32moduleeval.h"
#include "c3377moduleeval.h"

// ADCs
#include "adcmoduleeval.h"
#include "dummyadcmoduleeval.h"
#include "c7164moduleeval.h"

// DISCs
#include "discmoduleeval.h"
#include "dummydiscmoduleeval.h"

// DMAD
#include "dmadmodule.h"
#include "dmadmoduleeval.h"

// GPSs
#include "gpsmoduleeval.h"
#include "camacgpsmoduleeval.h"
#include "camacgpsmodule97eval.h"
#include "vmegpsmoduleeval.h"

// Scalers
#include "scalermoduleeval.h"

// Input Register
#include "c63iregmoduleeval.h"

// ??????????
#include "configsection.h"
#include "configsection2.h"

ClassTypeInfoHelper(ClassWithTypeInfo_t);

ClassTypeInfoHelper(ConfigSection);
ClassTypeInfoHelper(ConfigSection_t);

ClassTypeInfoHelper(CrateBaseClass_t);
ClassTypeInfoHelper(CAMAC_Crate_Class_t);
ClassTypeInfoHelper(VME_Crate_Class_t);


ClassTypeInfoHelper(SCALERModuleConfigRecord_t);
ClassTypeInfoHelper(DMAD_ModuleConfigRecord_t);
ClassTypeInfoHelper(IREGModuleConfigRecord_t);
ClassTypeInfoHelper(VME_GPSModuleConfigRecord_t);
ClassTypeInfoHelper(CAMAC_GPSModuleConfigRecord_t);
ClassTypeInfoHelper(DISCModuleConfigRecord_t);
ClassTypeInfoHelper(TDCModuleConfigRecord_t);
ClassTypeInfoHelper(ADCModuleConfigRecord_t);
ClassTypeInfoHelper(ChannelModuleConfigRecord_t);

/////////////////////////
// module evaluator classes

// base classes
ClassTypeInfoHelper(ModuleEvalBaseClass_t);
ClassTypeInfoHelper(GenericModuleEvalBaseClass_t);

// ADCs
ClassTypeInfoHelper(ADCModuleEvalClass_t);
ClassTypeInfoHelper(Dummy_ADCModuleEvalClass_t);
ClassTypeInfoHelper(C7164_ADCModuleEvalClass_t);

// TDCs
ClassTypeInfoHelper(TDCModuleEvalClass_t);
ClassTypeInfoHelper(Dummy_TDCModuleEvalClass_t);
ClassTypeInfoHelper(K32_TDCModuleEvalClass_t);
ClassTypeInfoHelper(C3377_TDCModuleEvalClass_t);

// DISCs
ClassTypeInfoHelper(DISCModuleEvalClass_t);
ClassTypeInfoHelper(Dummy_DISCModuleEvalClass_t);

// GPSs
ClassTypeInfoHelper(GPSModuleEvalClass_t);
ClassTypeInfoHelper(CAMAC_GPSModuleEvalClass_t);
ClassTypeInfoHelper(CAMAC_GPSModule97EvalClass_t);
ClassTypeInfoHelper(VME_GPSModuleEvalClass_t);

// Scaler
ClassTypeInfoHelper(ScalerModuleEvalClass_t);

// Input Register
ClassTypeInfoHelper(IREGModuleEvalClass_t);
ClassTypeInfoHelper(C63_IREGModuleEvalClass_t);

//DMAD
ClassTypeInfoHelper(DMAD_ModuleEvalClass_t);


////////////////////////
// module classes

// base classes
ClassTypeInfoHelper(ChannelModuleBaseClass_t);

// ADCs
ClassTypeInfoHelper(ADCModuleClass_t);
ClassTypeInfoHelper(Dummy_ADCModule_t);
ClassTypeInfoHelper(RNDDummy_ADCModule_t);
ClassTypeInfoHelper(C7164_ADCModule_t);

// TDCs
ClassTypeInfoHelper(TDCModuleClass_t);
ClassTypeInfoHelper(Dummy_TDCModule_t);
ClassTypeInfoHelper(RNDDummy_TDCModule_t);
ClassTypeInfoHelper(K32_TDCModule);
ClassTypeInfoHelper(C3377_TDCModule_t);

// DISCs
ClassTypeInfoHelper(DISCModuleClass_t);
ClassTypeInfoHelper(Dummy_DISCModule_t);

// GPSs
ClassTypeInfoHelper(GPSModuleClass_t);
ClassTypeInfoHelper(DummyGPSModuleClass_t);
ClassTypeInfoHelper(CAMAC_GPSModuleClass_t);
ClassTypeInfoHelper(CAMAC_GPSModule97Class_t);
ClassTypeInfoHelper(VME_GPSModuleClass_t);

// Scaler
ClassTypeInfoHelper(SCALERModuleClass_t);
ClassTypeInfoHelper(S7201_ScalerModule_t);
ClassTypeInfoHelper(SIS3808_ScalerModule_t);

// Input Register
ClassTypeInfoHelper(IREGModuleClass_t);
ClassTypeInfoHelper(C63_IREGModule_t);

//DMAD
ClassTypeInfoHelper(DMAD_Module_t);

//ClassTypeInfoHelper();
