/*
$Header: /home/elrond/baikal/src/CVS/daq98/vmecontrol.h,v 1.3 1998/11/23 14:44:50 haase Exp $
*/

#if ! defined __VMECONTROL_H__
#define __VMECONTROL_H__

#include <config.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <String.h>
#include "simplevector.h"
#include "process.h"
#include "datatypes.h"
#include "socketclass.h"
#include "ipcclasses.h"
#include "dispatcherlib.h"
#include "daemon.h"

class VMEControl_SignalHandler:public SignalHandlerClass
{
     virtual int Handle_SIGCHLD(Process &P);
     virtual int Handle_SIGUSR1(Process &P);
};


class VMEControlDaemon:public DaemonBase
{
public:
     VMEControlDaemon();
     ~VMEControlDaemon();

     int Init();
     int Destroy();
     /** returns the type of the process, must be overwritten in
         derived class */
     virtual const String GetProcessType()const;
protected:
     /** the event dispatcher */
     virtual int DispatchEvent();
     /** the IPC event handler */
     virtual int DoIPCEvent(const String &Cmd,SlaveServerSocket &s);
     /** returns a String with the configuration file name */
     virtual const String GetConfigFileName()const;
     /** returns a pointer to the configuration class, created with
         new on the heap, must be overwritten in derived class */
     virtual ClassWithTypeInfo_t *GetConfigSection();
private:
     int StartSlaveServer(const char* Progname,ServerSocket *SS);
private:
     struct ServerPortMapper_t
     {
	  port_t port;
	  String servername;
	  ServerSocket SSocket;
	  SocketNotifier SSocketNotifier;
     };

     MAKE_REFCOUNT_POINTER(ServerPortMapper_t,ServerPortMapper_p);
     MAKE_INC_VECTOR(ServerPortMapper_p, ServerPortVector_t);
     
     // for accessing the typedefs
     friend class VMEControlDaemonConfig;

     ServerPortVector_t ServerPortVector;

     
     Interpreter<VMEControlDaemon> IPC_CMD_Interpreter;
     int IPC_CMD_StartProcess(IOSocket &S,String *param,int numparams);
     int IPC_CMD_StopProcess(IOSocket &S,String *param,int numparams);
     int IPC_CMD_Help(IOSocket &s,String *param,int numparams);
     int IPC_CMD_UnknownCommand(IOSocket &S,String *param,int numparams);
     int IPC_CMD_WrongTypeCommand(IOSocket &S,String *param,int numparams);

     int SendUsageInfo(IOSocket &s,String param);

     /** the dispatcher interface */
     DispatcherLib_t Dispatcher;

     StopProcess(String &ProcessID);
     PID_t pid;

     VMEControl_SignalHandler SignalHandler;
     friend VMEControl_SignalHandler;
     port_t VMEControlPort;
};



#endif // __VMECONTROL_H__








