#if !defined __VMEGPSMODULE_H_
#define __VMEGPSMODULE_H_

/*
$Header: /home/elrond/baikal/src/CVS/daq98/vmegpsmodule.h,v 1.10 1999/02/10 21:35:15 daq Exp $
*/


#include <config.h>
#include "gpsmodule.h"


#define MAX_FIFO_VMEGPS  100*5              // 100 Events a 5 words
//  changes possible here with VMEGPS-redesign 
#define WORD_LENGTH_VMEGPS       4          // word length in Bytes - structure of binary data buffer 
#define FIFOWORDS_PER_VMEGPS     4          // #Fifo-words per vmegps-event:  4*fifo
#define WORDS_PER_VMEGPS         5          // #words per vmegps-event:  4*fifo, 1 status
#define WAIT_LOOPS_VMEGPS_READ   1000       // waitloops in fifo-readout

struct VME_GPSModuleConfigRecord_t:public ChannelModuleConfigRecord_t
{
     ClassTypeInfo(ChannelModuleConfigRecord_t);
     VME_GPSModuleConfigRecord_t(){
     }
     virtual ~VME_GPSModuleConfigRecord_t(){
     }
     u_i32 EventIndex;
};

MAKE_REFCOUNT_POINTER(VME_GPSModuleConfigRecord_t,VME_GPSModuleConfigRecord_p);


class VME_GPSModuleClass_t:public GPSModuleClass_t
{
     ClassTypeInfo(GPSModuleClass_t);
     enum 
     { 
	  NUMBER_OF_CHANNELS =1,
	  BYTES_PER_INFO_UNIT=24
     };
public:
     VME_GPSModuleClass_t(DaqProcessBase *parent);/***/
     
     ~VME_GPSModuleClass_t();
     
     /** returns true, if the module has data or false if the module
	 does not have any data */
     virtual bool HasModuleData();

     /** this function reads the entire module and saves the RAW data
         at the current position into the buffers, which is given as
         the paramter */
     virtual int ReadToBuffer(BinaryDataBuffer &DataBuffer);
     
     /** this function initializes the module 
	 CCrate Init is done here for Crate Nb. =1 (perlim.) */
     virtual int InitModule(StringVector_t &errors);

     /** this function initializes the module 
	 CCrate Init is done here for Crate Nb. =1 (perlim.) */
     virtual int StartModule(StringVector_t &errors){
	  if (GetModuleConfig()->isAsynch) {
	     Enable_PO();
	  }
	  return 0;
     }
     

     /** Resets the module 
       @param errors Vector of errors that may occur during initialization.
       @return 0 on success. Negative number of errors occured during 
       initialization on failure.*/
     virtual int ResetModule(StringVector_t &errors);

     
/// private:

#warning   ---> should be inline?
     /**  check if FIFO empty 
	  true = empty */  
     bool  FIFO_Empty ();
   
     /**  read the FIFO eventwise  */
     int Read_FIFO_Event (u_i32 *w, int &iw);

     /** Enable pulser output */
     void Enable_PO();
	  
     /** get the  status register
	 4 bits valid */
     u_i32 GetStatusRegister();

     /** get the FIFO status register
	 2 bits valid */
     u_i32 GetFIFOStatusRegister();
     
     /** output single calibration pulse
	 length defined with cont-register  */
     int Cal_Out();
     
     /** output to ECL register */
     int ECL_Out(int ecl);
     
     /**  write to LED register */
     int LED_Out(int led);
     
     /** check GPS status  true = external GPS on */
     bool Is_GPS_On ();
     
     /**  Reset GPS external GPS on, use last stored status written   */
     int Reset_GPS_On ();
     
     /**  Reset GPS external GPS on, use last stored status written   */
     int Reset_GPS_On_TimeOut ();

private:

     /** Number of times {\tt \Ref{HasModuleData}} is accessed */
     u_i32 ModuleAccess;

     u_i32  *p_vgps,
            *p_vgps_fifo,
            *p_vgps_eclout,
            *p_vgps_ledout,
            *p_vgps_calout;
     u_i32  last_vgps_contreg;
     int nw_map;

     u_i32  ievt_vmegps;     // for testing 
     u_i64  t_full_last_vmegps;
};

MAKE_REFCOUNT_POINTER(VME_GPSModuleClass_t, VME_GPSModuleClass_p);

#endif // __VMEGPSMODULE_H__
